#include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3>
Dim $NEWdata, $Num = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = StringTrimRight($TxtPath,4)
$Names = _FileListToArrayRec($Dir, "*.SoundNodeWave", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no SoundNodeWave files in the "&@cr&CompGetFileName($Dir)&" folder, or the folder not exist.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	$bFile = FileRead($File)
	FileSetPos($File,132,0)
	$Datasize = FileRead($File,4)
	If $Datasize <> "0x04000000" Then
		FileRead($File,4)
		$Count = FileRead($File,4)
		FileRead($File,16)
		$Dif = 0
		For $c = 1 to $Count
			$pos = FileGetPos($File)
			$BlockSize = FileRead($File,4)
			FileRead($File,4)
			$Str = $NEWdata[$Num]
			$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
			$Str = StringRegExpReplace($Str,"<lf>",@LF)
			$Str = StringRegExpReplace($Str,"<cr>",@CR)
			$OldStrLen = _BinaryToInt32(FileRead($File, 4))
			If $OldStrLen = 0 Then
				$NewBlock = _BinaryFromInt32(4) & Binary("0x" & Hex(0,16))
			Else
				If $OldStrLen < 0 Then
					$NewText = StringToBinary($Str,2) & Binary("0x0000")
					$NewLen = BinaryLen($NewText)
					$NewBlock = _BinaryFromInt32($NewLen+4) & Binary("0x00000000") & _BinaryFromInt32(-int($NewLen/2)) & $NewText
				Else
					$NewText = StringToBinary($Str) & Binary("0x00")
					$NewLen = BinaryLen($NewText)
					$NewBlock = _BinaryFromInt32($NewLen+4) & Binary("0x00000000") & _BinaryFromInt32($NewLen) & $NewText
				EndIf
			EndIf
			$Num += 1
			FileSetPos($File,$pos,0)
			$OldBlock = FileRead($File,_BinaryToInt32($BlockSize)+8)
			FileRead($File,52)
			If $NewBlock <> $OldBlock Then
				$Dif += BinaryLen($NewBlock) - (_BinaryToInt32($BlockSize)+8)
				$bFile = _BinaryReplace($bFile, $OldBlock, $NewBlock, 1)
			EndIf
		Next
		$hNewfile = FileOpen($Dir &"\"& $Names[$i], 2+16)
		FileWrite($hNewfile, $bFile)
		FileClose($hNewfile)
		$Asize = FileGetSize($Dir &"\"& $Names[$i]) - 20
		FileSetPos($File,$Asize,0)
		$End1 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileRead($File, 12)
		$End2 = _BinaryToInt32(FileRead($File, 4))+$Dif
		$bFile = _BinaryPoke($bFile, $Asize+1, $End1, "dword")
		$bFile = _BinaryPoke($bFile, $Asize+17, $End2, "dword")
		$bFile = _BinaryPoke($bFile, 133, _BinaryToInt32($Datasize)+$Dif, "dword")
		$hNewfile = FileOpen($Dir &"\"& $Names[$i], 2+16)
		FileWrite($hNewfile, $bFile)
		FileClose($hNewfile)
	EndIf
	FileClose ($File)
Next
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc