#include <File.au3>
#include <Binary.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
FileSetPos($File,8,0)
$Files = _BinaryToInt32(FileRead($File,4))
$pos = _BinaryToInt32(FileRead($File,4))
$Offset = ($pos + $Files*4)
FileSetPos($File,0,0)
$Newfile = FileRead($File,$Offset)
$Newfiletext = Binary("0x00")
FileSetPos($File,$pos,0)
For $i = 1 to $Files
	$OrigOffset = _BinaryToInt32(FileRead($File,4))
	FileSetPos($File,$OrigOffset,0)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$NewText = StringToBinary($NEWdata[$i],4) & Binary("0x00")
	$Len = BinaryLen($NewText)
	$Newfile = _BinaryPoke($Newfile,$pos+1,$Offset,"dword")
	$Pad = 4 - Mod($Len,4)
	If $Pad > 0 And $Pad < 4 Then
		$Newfiletext &= FileRead($File,4) & $NewText & Binary("0x" & Hex(0,$Pad*2))
		$Len += $Pad
	Else
		$Newfiletext &= FileRead($File,4) & $NewText
	EndIf
	$pos += 4
	$Offset += $Len + 4
	FileSetPos($File,$pos,0)
Next
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile&BinaryMid($Newfiletext,2))
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc