$sScriptName = "Blur Text Exporter"
$sLocbFilePath = FileOpenDialog("Select the loc file", @ScriptDir, "loc files (*.loc)|All (*.*)",1)
If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	 EndIf
$hLocbfile = FileOpen ($sLocbFilePath, 0+16)
$bLocbfile = FileRead ($hLocbfile)
FileClose ($hLocbfile)
$Name = StringTrimRight(CompGetFileName($sLocbFilePath),4)
$BasePos = Dec (Hex ((Binarymid ($bLocbfile, 13, 4)), 4))+17
$Langs = Dec (Hex ((Binarymid ($bLocbfile, 21, 4)), 4))
Dim $Positions[$Langs][3]
$Hpos = 0
For $l = 0 To $Langs-1
   $Positions[$l][2] = BinaryToString (Binarymid ($bLocbfile, 29+$Hpos, 2))
   $Positions[$l][0] = (Dec (Hex ((Binarymid ($bLocbfile, 45+$Hpos, 4)), 4)))+1
   $Positions[$l][1] = (Dec (Hex ((Binarymid ($bLocbfile, 49+$Hpos, 4)), 4)))
   $Hpos += 24
Next
$Size = FileGetSize($sLocbFilePath)+1
$IDnum = Dec (Hex ((Binarymid ($bLocbfile, $Langs*24+29, 4)), 4))
Dim $IDs[$IDnum*3]
$Ipos = $Langs*24+37
$Ppos = 0
   For $i = 0 To ($IDnum*3)-3 Step 3
   $IDs[$i] = Hex ((Binarymid ($bLocbfile, $Ipos+$Ppos, 4)), 4)
   $Offset = Dec (Hex ((Binarymid ($bLocbfile, $Ipos+$Ppos+4, 4)), 4))+$Langs*24+29
   If $i <> ($IDnum*3)-3 Then
	  $Offset2 = Dec (Hex ((Binarymid ($bLocbfile, $Ipos+$Ppos+12, 4)), 4))+$Langs*24+29
   Else
	  $Offset2 = $BasePos
   EndIf
   $Len = $Offset2 - $Offset
   $IDs[$i+1] = $Offset
   $IDs[$i+2] = $Len-1
   $Ppos += 8
Next
Dim $Text
For $i = 0 To $Langs-1
	  $Files = Dec (Hex ((Binarymid ($bLocbfile, $Positions[$i][0], 4)), 4))
	  $Pos = $Positions[$i][0] + 8
	  $Text &= "[LangID]" & @CRLF& $Positions[$i][2] & @CRLF
	  _Export($Pos)
Next
Func _Export($APos)
   If $i > 0 Then
	  $BasePos += $Positions[$i-1][1]
   EndIf
   $Ppos = 0
   For $k = 1 To $Files
   $ID = Hex ((Binarymid ($bLocbfile, $APos+$Ppos, 4)), 4)
   $n = 0
   While $ID <> $IDs[$n]
	  $n += 3
   WEnd
   $Text &= "[" & BinaryToString (Binarymid ($bLocbfile, Int($IDs[$n+1]), Int($IDs[$n+2])), 4) & "]" & @CRLF
   $Offset = Dec (Hex ((Binarymid ($bLocbfile, $APos+$Ppos+4, 4)), 4))+$BasePos
   If $k <> $Files Then
	  $Offset2 = Dec (Hex ((Binarymid ($bLocbfile, $APos+$Ppos+12, 4)), 4))+$BasePos
   ElseIf $i < $Langs-1 Then
	  $Offset2 = $Positions[$i+1][0]
   Else
	  $Offset2 = $Size
   EndIf
   $Len = $Offset2 - $Offset
   $Text &= BinaryToString (Binarymid ($bLocbfile, $Offset, $Len-2), 3) & @CRLF
   $Ppos += 8
   Next
   $hAllTextFil = FileOpen ($Name&"_"&$Positions[$i][2]&".txt", 2+64)
FileWrite ($hAllTextFil, $Text)
FileClose ($hAllTextFil)
   $Text = ""
EndFunc
MsgBox(0, $sScriptName, "Finish!")
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
	EndFunc