#Include <Binary.au3>
$sScriptName = "Blur Text Importer"
$sAllTextFilePath = FileOpenDialog("Select the txt file...", @ScriptDir, "text files (*.txt)|All (*.*)", 1)
If $sAllTextFilePath = "" Then
	MsgBox (0, "Error", "No file selected!")
	Exit
EndIf
$hAllTextFile = FileOpen ($sAllTextFilePath, 0+32)
$sAllText = FileRead($hAllTextFile)
FileClose ($hAllTextFile)
$a=StringRegExp($sAllText&'[', '(?s)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n=UBound($a)
Dim $aAllText[Int($n/2)]
For $i = 0 to $n-1 Step 2
    $aAllText[$i/2]=$a[$i+1]
Next
$sLocbFilePath = FileOpenDialog("Select the loc file", @ScriptDir, "loc files (*.loc)|All (*.*)",1)
If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	 EndIf
$hLocbfile = FileOpen ($sLocbFilePath, 0+16)
$bLocbfile = FileRead ($hLocbfile)
FileClose ($hLocbfile)
$Name = CompGetFileName($sLocbFilePath)
$BasePos = Dec (Hex ((Binarymid ($bLocbfile, 13, 4)), 4))+17
$Langs = Dec (Hex ((Binarymid ($bLocbfile, 21, 4)), 4))
Dim $Positions[$Langs][5]
$Hpos = 0
For $l = 0 To $Langs-1
   $Positions[$l][4] = BinaryToString (Binarymid ($bLocbfile, 29+$Hpos, 2))
   $Positions[$l][2] = 45+$Hpos
   $Positions[$l][3] = 49+$Hpos
   $Positions[$l][0] = (Dec (Hex ((Binarymid ($bLocbfile, 45+$Hpos, 4)), 4)))+1
   $Positions[$l][1] = (Dec (Hex ((Binarymid ($bLocbfile, 49+$Hpos, 4)), 4)))
   $Hpos += 24
Next
$Asize = FileGetSize($sLocbFilePath)+1
$o = 0
Do
   $Pos = $Positions[$o][0]
   $Size = $Positions[$o][1]
   $o += 1
   If $o == $Langs Then
	  MsgBox (0, "Error", "Unknown langid: "&$aAllText[0])
   Exit
   EndIf
Until $aAllText[0] == $Positions[$o-1][4]
$o -= 1
$Files = Dec (Hex ((Binarymid ($bLocbfile, $Pos, 4)), 4))
$Head = Binarymid ($bLocbfile, 1, $Pos-1+8+($Files*8))
$Foot = Binarymid ($bLocbfile, $Pos+$Size)
$Pos += 8
$Diff = 0
$plus = Binary ("0x" & Hex (0, 4))
$Ppos = 0
For $i = 1 To $Files
   $Offset = Dec (Hex ((Binarymid ($bLocbfile, $Pos+$Ppos+4, 4)), 4))+$BasePos
   If $i <> $Files Then
	  $Offset2 = Dec (Hex ((Binarymid ($bLocbfile, $Pos+$Ppos+12, 4)), 4))+$BasePos
   ElseIf $o < $Langs-1 Then
	  $Offset2 = $Positions[$o+1][0]
   Else
	  $Offset2 = $Asize
   EndIf
   $Len = $Offset2 - $Offset
   $Offset -= $BasePos
   $bNewText = StringToBinary ($aAllText[$i],3)
   $bNewText = $bNewText & $plus
   $NewLen = Dec(Hex (BinaryLen ($bNewText), 8))
   $NewOff = $Offset
   $NewOff += $Diff
   $Diff += $NewLen - $Len
   $bNewOff = (Binary ("0x" & Hex ($NewOff, 8)))
   If $bNewOff <> $Offset Then
   $Head = _BinaryPoke($Head, $Pos+$Ppos+4, $bNewOff, "dword")
   EndIf
   $Head &= $bNewText
   $Ppos += 8
Next
$Head &= $Foot
$Size += $Diff
$Size = (Binary ("0x" & Hex ($Size, 8)))
$Head = _BinaryPoke($Head, $Positions[$o][3], $Size, "dword")
While $o < $Langs-1
   $o += 1
   $Spos = $Positions[$o][0]-1
   $Spos += $Diff
   $Spos = (Binary ("0x" & Hex ($Spos, 8)))
   $Head = _BinaryPoke($Head, $Positions[$o][2], $Spos, "dword")
WEnd
   $hNewFile = FileOpen ("new_"&$Name, 2+16)
   FileWrite ($hNewFile, $Head)
   FileClose ($hNewFile)
MsgBox(0, $sScriptName, "Finish!")
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
	EndFunc