#include <File.au3>
#include <Binary.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error!","Can't open "&$Name&" file.")
Exit
EndIf
$Asize = FileGetSize($Name)
FileSetPos($File,$Asize-12,0)
$End = FileRead($File,4)
FileSetPos($File,12,0)
$Files = Dec(Hex(FileRead($File,4)))
FileSetPos($File,0,0)
$Baseoff = $Files*8+20
$Newfile = FileRead($File,$Baseoff)
$plus = Binary("0x0000")
$Offset = 0
$Newtext = Binary("0x00")
$Head = 25
For $i = 1 To $Files
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$bNewText = StringToBinary ($NEWdata[$i],3) & $plus
	$NewLen = BinaryLen ($bNewText)
	$padding = 4 - Mod($NewLen, 4)
	$Newfile = _BinaryPoke($Newfile,$Head,Binary("0x" & Hex(int($Offset/2),8)),"dword")
	$Newtext &= $bNewText
	$Offset += $NewLen
	$Head += 8
Next
$Newfile = $Newfile & BinaryMid($Newtext,2)
$Len = BinaryLen($Newfile)
$padding = 16 - Mod($Len, 16)
If $padding < 16 Then
	$Newfile &= _binaryrandom($padding, 0, 0)
EndIf
$Newfile &= _binaryrandom(1232, 0, 0) & $End & Binary("0x" & Hex($Len,8)) & _binaryrandom(4, 0, 0)
$hNewfile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc