#include <File.au3>
#include <Binary.au3>
Dim $plus = Binary("0x0000")
$Path = FileOpenDialog("Select the BIN file", @ScriptDir, "bin files (*.bin)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
If $File = -1 Then Exit
$Binname = CompGetFileName($Path)
$Newfile = FileRead($File,4)
$Files = _BinaryToInt32($Newfile)
If $Files > 10000000 Or $Files < 0 Then
	FileSetPos($File,0,0)
	$Files = Dec(Hex(FileRead($File,4)))
	$Endian = 0
Else
	$Endian = 1
EndIf
for $i = 1 to $Files
	$bNamesize = FileRead($File,4)
	If $Endian = 0 Then
		$Namesize = Dec(Hex($bNamesize))*-2
	Else
		$Namesize = _BinaryToInt32($bNamesize)*-2
	EndIf
	$pos = FileGetPos($File)
	$p = -1
	Do
		$p += 1
		$S = BinaryToString(FileRead($File,2),2)
	Until $S <> "\" And $S <> "."
	FileSetPos($File,$pos,0)
	$bName = FileRead($File, $Namesize)
	$Name = StringTrimRight(StringTrimLeft(BinaryToString($bName,2),$p),1)
	$Newfile &= $bNamesize & $bName
	$bNum1 = FileRead($File,4)
	$Newfile &= $bNum1
	If $Endian = 0 Then
		$Num1 = Dec(Hex($bNum1))
	Else
		$Num1 = _BinaryToInt32($bNum1)
	EndIf
	Dim $NEWdata, $s = 1
	_FileReadToArray("unpacked\"&$Name,$NEWdata)
	For $n = 1 to $Num1
		$bSize = FileRead($File,4)
		If $Endian = 0 Then
			$Size = Dec(Hex($bSize))*-2
		Else
			$Size = _BinaryToInt32($bSize)*-2
		EndIf
		FileRead($File,$Size)
		If $Size = 0 Then
			$NewText = StringToBinary($NEWdata[$s],2)
		Else
			$NewText = StringToBinary($NEWdata[$s],2) & $plus
		EndIf
		$bNum2 = FileRead($File,4)
		If $Endian = 0 Then
			$Newfile &= Binary("0x" & Hex(-Int(BinaryLen($NewText)/2),8)) & $NewText & $bNum2
		Else
			$Newfile &= _BinaryFromInt32(-Int(BinaryLen($NewText)/2)) & $NewText & $bNum2
		EndIf
		If $Endian = 0 Then
			$Num2 = Dec(Hex($bNum2))*2
		Else
			$Num2 = _BinaryToInt32($bNum2)*2
		EndIf
		For $k = 1 to $Num2
			$bSize = FileRead($File,4)
			If $Endian = 0 Then
				$Size = Dec(Hex($bSize))*-2
			Else
				$Size = _BinaryToInt32($bSize)*-2
			EndIf
			FileRead($File,$Size)
			$NEWdata[$s+$k] = StringRegExpReplace($NEWdata[$s+$k],"<cf>",@CRLF)
			$NEWdata[$s+$k] = StringRegExpReplace($NEWdata[$s+$k],"<lf>",@LF)
			$NEWdata[$s+$k] = StringRegExpReplace($NEWdata[$s+$k],"<cr>",@CR)
			$NewText = StringToBinary($NEWdata[$s+$k],2)
			If $Size = 0 Then
				$NewText = StringToBinary($NEWdata[$s+$k],2)
			Else
				$NewText = StringToBinary($NEWdata[$s+$k],2) & $plus
			EndIf
			If $Endian = 0 Then
				$Newfile &= Binary("0x" & Hex(-Int(BinaryLen($NewText)/2),8)) & $NewText
			Else
				$Newfile &= _BinaryFromInt32(-Int(BinaryLen($NewText)/2)) & $NewText
			EndIf
		Next
		$s += $k
	Next
Next
$hNewfile = FileOpen ("NEW_"&$Binname, 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc