#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
$Path = FileOpenDialog("Select the STRDB file", @ScriptDir, "strdb files (*.strdb)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
$Name = CompGetFileName($Path)
$Id = FileRead($File,4)
If $Id = "SKDB" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
FileRead($File,4)
If $Endian = 0 Then
	$K = _BinaryToInt32(FileRead($File,4))
Else
	$K = Dec(Hex(FileRead($File, 4)))
EndIf
If $Endian = 0 Then
	$Kv = _BinaryToInt32(FileRead($File,4))
Else
	$Kv = Dec(Hex(FileRead($File, 4)))
EndIf
FileRead($File,8)
Dim $Text, $UTF8 = 0
For $i = 1 to $K
	$p = 0
	Do
		$p += 1
	Until FileRead($File, 1) = 0
	$Pad = 4-Mod($p,4)
	If $Pad < 4 Then
		FileRead($File,$Pad)
	EndIf
Next
$Files = $Kv - $K
$pos = FileGetPos($File)
FileRead($File,1)
$a = FileRead($File,1)
FileRead($File,1)
$b = FileRead($File,1)
If $a <> 0 And $b <> 0 Then $UTF8 = 1
FileSetPos($File,$pos,0)
For $i = 1 to $Files
	$p = 0
	If $UTF8 = 1 Then
		$S = ""
		$Str = ""
		Do
			$p += 1
			$Str &= $S
			$S = FileRead ($File, 1)
		Until $S = 0
		$Str = BinaryToString("0x" & StringRegExpReplace($Str,"0x",""),4)
	Else
		$S = ""
		$Str = ""
		Do
			$p += 2
			If $Endian = 0 Then
				$Str &= BinaryToString($S,2)
			Else
				$Str &= BinaryToString($S,3)
			EndIf
			$S = FileRead ($File, 2)
		Until $S = 0
	EndIf
	$Pad = 4-Mod($p,4)
	If $Pad < 4 Then
		FileRead($File,$Pad)
	EndIf
	$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
	$Str = StringRegExpReplace($Str,@LF,"<lf>")
	$Str = StringRegExpReplace($Str,@CR,"<cr>")
	$Text &= $Str & @CRLF
Next
If $UTF8 = 1 Then
	$hFile = FileOpen($Name&".txt", 2+128)
ElseIf $Endian = 0 Then
	$hFile = FileOpen($Name&".txt", 2+32)
Else
	$hFile = FileOpen($Name&".txt", 2+64)
EndIf
FileWrite($hFile,$Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc