#include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata, $UTF8 = 0
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error!","Can't open "&$Name&" file.")
Exit
EndIf
$Id = FileRead($File,4)
If $Id = "SKDB" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
FileRead($File,4)
If $Endian = 0 Then
	$K = _BinaryToInt32(FileRead($File,4))
Else
	$K = Dec(Hex(FileRead($File, 4)))
EndIf
If $Endian = 0 Then
	$Kv = _BinaryToInt32(FileRead($File,4))
Else
	$Kv = Dec(Hex(FileRead($File, 4)))
EndIf
If $Endian = 0 Then
	$Vo = _BinaryToInt32(FileRead($File,4))
Else
	$Vo = Dec(Hex(FileRead($File, 4)))
EndIf
If $Endian = 0 Then
	$Datapos = _BinaryToInt32(FileRead($File,4))+24
Else
	$Datapos = Dec(Hex(FileRead($File, 4)))+24
EndIf
Dim $Text, $UTF8 = 0
For $i = 1 to $K
	$p = 0
	Do
		$p += 1
	Until FileRead($File, 1) = 0
	$Pad = 4-Mod($p,4)
	If $Pad < 4 Then
		FileRead($File,$Pad)
	EndIf
Next
$Files = $Kv - $K
$pos = FileGetPos($File)
FileRead($File,1)
$a = FileRead($File,1)
FileRead($File,1)
$b = FileRead($File,1)
If $a <> 0 And $b <> 0 Then $UTF8 = 1
FileSetPos($File,0,0)
$Newfile = FileRead($File,$pos)
For $i = 1 to $Files
	$p = 0
	If $UTF8 = 1 Then
		$S = ""
		Do
			$p += 1
			$S = FileRead ($File, 1)
		Until $S = 0
	Else
		$S = ""
		Do
			$p += 2
			$S = FileRead ($File, 2)
		Until $S = 0
	EndIf
	$Pad = 4-Mod($p,4)
	If $Pad < 4 Then
		FileRead($File,$Pad)
	EndIf
Next
$pos = FileGetPos($File)
For $i = 1 To $Files
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	If $UTF8 = 1 Then
		$bNewText = StringToBinary ($NEWdata[$i],4) & Binary("0x00")
	ElseIf $Endian = 0 Then
		$bNewText = StringToBinary ($NEWdata[$i],2) & Binary("0x00")
	Else
		$bNewText = StringToBinary ($NEWdata[$i],3) & Binary("0x00")
	EndIf
	$NewLen = BinaryLen ($bNewText)
	$padding = 4 - Mod($NewLen, 4)
	If $padding < 4 Then
		$Newfile &= $bNewText & _binaryrandom($padding, 0, 0)
	Else
		$Newfile &= $bNewText
	EndIf
Next
For $i = 1 to $Vo
	$p = 0
	$S = ""
	Do
		$p += 1
		$S = FileRead ($File, 1)
	Until $S = 0
	$Pad = 4-Mod($p,4)
	If $Pad < 4 Then
		FileRead($File,$Pad)
	EndIf
Next
$End = FileGetPos($File)
FileSetPos($File,$pos,0)
$Newfile &= FileRead($File,$End-$pos)
$Datasize = BinaryLen($Newfile)-24
If $Endian = 0 Then
	$Newfile = _BinaryPoke($Newfile,21,$Datasize,"dword")
Else
	$Newfile = _BinaryPoke($Newfile,21,Binary("0x" & Hex($Datasize,8)),"dword")
EndIf
FileSetPos($File,$Datapos,0)
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile&FileRead($File))
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc