#include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3>
Dim $NEWdata, $k = 1, $I1 = Binary("0x210000000000000003000000"), $I2 = Binary("0x1F0000000000000003000000")
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = StringTrimRight($TxtPath,4)
$Names = _FileListToArrayRec($Dir, "*.Ms01DataMessage", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no Ms01DataMessage files in the "&@cr&CompGetFileName($Dir)&" folder, or the folder not exist.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
	$bFile = FileRead($File)
	$Pos = _BinaryInBin($bFile, $I1, 1, 1)
	If $Pos = 0 Then $Pos = _BinaryInBin($bFile, $I2, 1, 1)
	If $Pos <> 0 Then
		Do
			FileSetPos($File,$Pos+15,0)
			$Size = _BinaryToInt32(FileRead($File, 4))
			FileRead($File, 4)
			$Num = FileRead($File, 4)
			FileSetPos($File,$Pos+15,0)
			$Oldblock = FileRead($File,$Size+8)
			$Newblock = Binary("0x00")
			FileSetPos($File,$Pos+27,0)
			For $n = 1 to $Num
				$Str = $NEWdata[$k]
				$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
				$Str = StringRegExpReplace($Str,"<lf>",@LF)
				$Str = StringRegExpReplace($Str,"<cr>",@CR)
				$OldStrLen = _BinaryToInt32(FileRead($File, 4))
				If $OldStrLen = 0 Then
					$Newblock &= Binary("0x00000000")
				Else
					If $OldStrLen < 0 Then
						$OldLen = -_BinaryToInt32($OldStrLen)*2
						$NewText = StringToBinary($Str,2) & Binary("0x0000")
						$NewLen = BinaryLen($NewText)
						$Newblock &= _BinaryReverse(Binary("0x" & Hex(-int($NewLen/2),8))) & $NewText
						FileRead($File,$OldLen)
					Else
						$OldLen = _BinaryToInt32($OldStrLen)
						$NewText = StringToBinary($Str) & Binary("0x00")
						$NewLen = BinaryLen($NewText)
						$Newblock &= _BinaryReverse(Binary("0x" & Hex($NewLen,8))) & $NewText
						FileRead($File,$OldLen)
					EndIf
				EndIf
				$k += 1
			Next
			$Pos = FileGetPos($File)+1
			FileRead($File,8)
			$Newblock = _BinaryReverse(Binary("0x" & Hex(BinaryLen($Newblock)+3,8))) & Binary("0x00000000") & $Num & BinaryMid($Newblock,2)
			If $Newblock <> $Oldblock Then $bFile = _BinaryReplace($bFile, $Oldblock, $Newblock, 1)
		Until FileRead($File,1) <> "0x03"
	EndIf
	$File = FileOpen($Dir &"\"& $Names[$i], 2+16)
	FileWrite($File,$bFile)
	FileClose($File)
Next
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc