#include<Binary.au3>
#include<File.au3>
#include <ArrayNaturalSort.au3>
$BdtPath = FileOpenDialog("Select the BDT file", @ScriptDir,"bdt files (*.bdt)",1)
If @error = 1 Then Exit
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
RunWait(@ComSpec & " /c " & 'del \q "'&$Dir &'\"*.cmp')
$Names = _FileListToArray($Dir, "*", 1)
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	RunWait(@ComSpec & " /c " & 'quickbms.exe compress.bms "'&$Dir &"\"& $Names[$i] & '" "' & $Dir & '"')
Next
RunWait(@ComSpec & " /c " & 'quickbms.exe -w -r bdt_import.bms "'&$BdtPath & '" "' & $Dir & '"')
$BdtFile = fileopen($BdtPath,1+16)
$BhdFile = fileopen(StringTrimRight(CompGetFileName($BdtPath),3)&"bhd5",16)
For $i=1 to $Names[0]
	$Size = FileGetSize($Dir&"\"&$Names[$i])
	FileSetPos($BhdFile,28,0)
	$BaseOffset = _BinaryToInt32(FileRead($BhdFile,4))
	FileSetPos($BhdFile,StringTrimRight($Names[$i],4) * 16 + $BaseOffset - 8,0)
	$Offset = _BinaryToInt64(FileRead($BhdFile,8)) + 28
	Filesetpos($BdtFile,$Offset,0)
	FileWrite($BdtFile,Binary("0x" & Hex($Size,8)))
Next
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc