#Include <File.au3>
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.fmg", 1,1)
Dim $Text
$File = FileOpen ($Dir &"\"& $Names[1], 0+16)
$Id = FileRead($File,2)
FileClose($File)
If $Id = 1 Then
	$Endian = 0
Else
	$Endian = 1
EndIf
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,16,0)
	If $Endian = 0 Then
		$Files = FileRead($File, 4)
	Else
		$Files = Dec(Hex(FileRead($File, 4)))
	EndIf
	If $Endian = 0 Then
		FileSetPos($File,FileRead($File, 4),0)
	Else
		FileSetPos($File,Dec(Hex(FileRead($File, 4))),0)
	EndIf
	For $f = 1 to $Files
		If $Endian = 0 Then
			$Offset = FileRead($File, 4)
		Else
			$Offset = Dec(Hex(FileRead($File, 4)))
		EndIf
		If $Offset <> 0 Then
			$Offpos = FileGetPos($File)
			FileSetPos($File,$Offset,0)
			$S = ""
			$Str = ""
			Do
				If $Endian = 0 Then
					$Str &=  BinaryToString($S,2)
				Else
					$Str &=  BinaryToString($S,3)
				EndIf
				$S = FileRead($File, 2)
			Until $S = 0
			$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
			$Str = StringRegExpReplace($Str,@LF,"<lf>")
			$Str = StringRegExpReplace($Str,@CR,"<cr>")
			$Text &= $Str & @CRLF
			FileSetPos($File,$Offpos,0)
		EndIf
	Next
	FileClose($File)
Next
If $Endian = 0 Then
	$hFile = FileOpen(CompGetFileName($Dir)&".txt", 2+32)
Else
	$hFile = FileOpen(CompGetFileName($Dir)&".txt", 2+64)
EndIf
FileWrite($hFile, $Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
EndFunc
