#Include <File.au3>
#include <ArrayNaturalSort.au3>
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.DOSeqAct_AddMission", 1,1)
If $Names = "" Then
	MsgBox(0,"No files","There are no .DOSeqAct_AddMission files in the folder.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
Dim $Text
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,52,0)
	For $n = 1 to 2
		If FileRead($File,4) =  "0x04000000" Then
			FileRead($File,32)
		Else
			FileRead($File,4)
		EndIf
		$Len = _BinaryToInt32(FileRead($File,4))
		If $Len < 0 Then
			$Len = -$Len*2
			$Str = BinaryToString(FileRead($File,$Len),2)
			$Str = StringTrimRight($Str,1)
		Else
			$Str = BinaryToString(FileRead($File,$Len))
			$Str = StringTrimRight($Str,1)
		EndIf
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
	FileRead($File,16)
	Next
	FileClose($File)
Next
$Names = _FileListToArrayRec($Dir, "*.DOSeqAct_Announcement", 1,1)
If $Names = "" Then
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,20,0)
	If FileRead($File,4) <>  "0x04000000" Then
		FileRead($File,4)
		$Len = _BinaryToInt32(FileRead($File,4))
		If $Len < 0 Then
			$Len = -$Len*2
			$Str = BinaryToString(FileRead($File,$Len),2)
			$Str = StringTrimRight($Str,1)
		Else
			$Str = BinaryToString(FileRead($File,$Len))
			$Str = StringTrimRight($Str,1)
		EndIf
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
		FileClose($File)
	EndIf
Next
$hFile = FileOpen (CompGetFileName($Dir)&".txt", 2)
FileWrite ($hFile, $Text)
FileClose ($hFile)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func _BinaryToInt32($Binary)
	Return BitAND(Int(Binary($Binary)), 0xFFFFFFFF)
EndFunc