#Include <File.au3>
#include <Binary.au3>
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArray($Dir, "*", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no files in the folder.")
	Exit
EndIf
Dim $Text
For $i=1 to $Names[0]
	$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
	If FileRead($File,4) = "LANG" Then
		FileSetPos($File,276,0)
		$Files = FileRead($File,4)
		FileRead($File,8)
		$offpos = _BinaryToInt32(FileRead($File,4)) + 256
		$sizepos = _BinaryToInt32(FileRead($File,4)) + 256
		If $Files <> 0 Then
			Dim $offsets[$Files], $sizes[$Files]
			FileSetPos($File,$offpos,0)
			For $f = 1 to $Files
				$offsets[$f-1] = _BinaryToInt32(FileRead($File,4)) + 256
			Next
			FileSetPos($File,$sizepos,0)
			For $f = 1 to $Files
				$sizes[$f-1] = FileRead($File,4)
			Next
			For $f = 1 to $Files
				FileSetPos($File,$offsets[$f-1],0)
				$Str = StringTrimRight(BinaryToString(FileRead($File,$sizes[$f-1]),2),1)
				$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
				$Str = StringRegExpReplace($Str,@LF,"<lf>")
				$Str = StringRegExpReplace($Str,@CR,"<cr>")
				$Text &= $Str & @CRLF
			Next
		EndIf
	EndIf
	FileClose($File)
Next
$hTextFile = FileOpen(CompGetFileName($Dir)&".txt", 2+32)
FileWrite($hTextFile,$Text)
FileClose($hTextFile)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
EndFunc