#Include <File.au3>
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArray($Dir, "*.psv", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no psv files in the folder.")
	Exit
EndIf
$File = FileOpen ($Dir &"\"& $Names[1], 0+16)
$Id = FileRead($File,4)
FileClose($File)
If $Id = "BBLL" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
Dim $Text
If $Endian = 0 Then
	For $i=1 to $Names[0]
		$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
		FileRead($File,8)
		$Files = FileRead($File,4)
		$Asize = FileGetSize($Dir &"\"& $Names[$i])
		Dim $Text
		For $f = 1 to $Files
			FileRead($File,4)
			FileRead($File,FileRead($File,4))
		Next
		Do
			$id = FileRead($File,4)
			If $id <> "0x08000000" Then
				$Str = StringTrimRight(BinaryToString(FileRead($File,FileRead($File,4)),2),1)
				$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
				$Str = StringRegExpReplace($Str,@LF,"<lf>")
				$Str = StringRegExpReplace($Str,@CR,"<cr>")
				$Text &= $Str & @CRLF
			Else
				FileRead($File,FileRead($File,4))
			EndIf
		Until FileGetPos($File) = $Asize
		FileClose($File)
	Next
	$hTextFile = FileOpen (CompGetFileName($Dir)&".txt", 2+32)
Else
	For $i=1 to $Names[0]
		$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
		FileRead($File,16)
		$Files = Dec(Hex(FileRead($File,4)))
		$Asize = FileGetSize($Dir &"\"& $Names[$i])
		Dim $Text
		FileRead($File,1)
		For $f = 1 to $Files
			FileRead($File,1)
			Do
			Until FileRead($File,2) = 0
		Next
		Do
			$id = FileRead($File,1)
			If $id = "0x01" Or $id = "0x02" Then
				FileRead($File,4)
			ElseIf $id = "0x05" Then
			Else
				$S = ""
				$Str = ""
				Do
					$Str &= BinaryToString($S,3)
					$S = FileRead($File,2)
				Until $S = 0
				$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
				$Str = StringRegExpReplace($Str,@LF,"<lf>")
				$Str = StringRegExpReplace($Str,@CR,"<cr>")
				$Text &= $Str & @CRLF
			EndIf
		Until FileGetPos($File) = $Asize
		FileClose($File)
	Next
	$hTextFile = FileOpen (CompGetFileName($Dir)&".txt", 2+64)
EndIf
FileWrite($hTextFile, $Text)
FileClose($hTextFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc