#Include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata,$Num = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = FileSelectFolder("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArray($Dir, "*.psv", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no psv files in the folder.")
	Exit
EndIf
$File = FileOpen ($Dir &"\"& $Names[1], 0+16)
$Id = FileRead($File,4)
FileClose($File)
If $Id = "BBLL" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
If $Endian = 0 Then
	For $i=1 to $Names[0]
		$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
		FileRead($File,8)
		$Files = FileRead($File,4)
		$Asize = FileGetSize($Dir &"\"& $Names[$i])
		Dim $Text
		For $f = 1 to $Files
			FileRead($File,4)
			FileRead($File,FileRead($File,4))
		Next
		$pos = FileGetPos($File)
		FileSetPos($File,0,0)
		$Newfile = FileRead($File,$pos)
		Do
			$id = FileRead($File,4)
			$Newfile &= $id
			If $id <> "0x08000000" Then
				FileRead($File,FileRead($File,4))
				$NEWdata[$Num] = StringRegExpReplace($NEWdata[$Num],"<cf>",@CRLF)
				$NEWdata[$Num] = StringRegExpReplace($NEWdata[$Num],"<lf>",@LF)
				$NEWdata[$Num] = StringRegExpReplace($NEWdata[$Num],"<cr>",@CR)
				$NewText = StringToBinary($NEWdata[$Num],2) & Binary("0x0000")
				$Newfile &= _BinaryReverse(Binary("0x" & Hex(BinaryLen($Newtext),8))) & $NewText
				$Num += 1
			Else
				$Size = FileRead($File,4)
				$Newfile &= $Size & FileRead($File,$Size)
			EndIf
		Until FileGetPos($File) = $Asize
		FileClose($File)
		$hNewfile = FileOpen ($Dir &"\"& $Names[$i], 2+16)
		FileWrite($hNewfile,$Newfile)
		FileClose($hNewfile)
	Next
Else
	For $i=1 to $Names[0]
		$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
		FileRead($File,4)
		$Unk = Dec(Hex(FileRead($File,4)))
		FileRead($File,8)
		$Files = Dec(Hex(FileRead($File,4)))
		$Asize = FileGetSize($Dir &"\"& $Names[$i])
		Dim $Text
		FileRead($File,1)
		For $f = 1 to $Files
			FileRead($File,1)
			Do
			Until FileRead($File,2) = 0
		Next
		$pos = FileGetPos($File)
		FileSetPos($File,0,0)
		$Newfile = FileRead($File,$pos)
		Do
			$id = FileRead($File,1)
			$Newfile &= $id
			If $id = "0x01" Or $id = "0x02" Then
				$Newfile &= FileRead($File,4)
			ElseIf $id = "0x05" Then
			Else
				$S = ""
				$Str = ""
				Do
					$Str &= BinaryToString($S,3)
					$S = FileRead($File,2)
				Until $S = 0
				$NEWdata[$Num] = StringRegExpReplace($NEWdata[$Num],"<cf>",@CRLF)
				$NEWdata[$Num] = StringRegExpReplace($NEWdata[$Num],"<lf>",@LF)
				$NEWdata[$Num] = StringRegExpReplace($NEWdata[$Num],"<cr>",@CR)
				$NewText = StringToBinary($NEWdata[$Num],3) & Binary("0x0000")
				$Newfile &= $NewText
				$Num += 1
			EndIf
		Until FileGetPos($File) = $Asize
		FileClose($File)
		$Unk += (BinaryLen($Newfile) - $Asize)
		$Newfile = _BinaryPoke($Newfile,5,Binary("0x" & Hex($Unk,8)),"dword")
		$hNewfile = FileOpen ($Dir &"\"& $Names[$i], 2+16)
		FileWrite($hNewfile,$Newfile)
		FileClose($hNewfile)
	Next
EndIf
TrayTip("Importer", "Finish!", 3)
sleep(3000)