#Include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3> ;NaturalCompare, https://www.autoitscript.com/forum/topic/83626-natural-order-string-comparison/
$Path = FileOpenDialog("Select the PCK file", @ScriptDir, "pck files (*.pck)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
FileSetPos($File,4,0)
If FileRead($File,2) = 0 Then
	$Endian = 1
Else
	$Endian = 0
EndIf
FileSetPos($File,4,0)
If $Endian = 0 Then
	$Files = FileRead($File, 4)
Else
	$Files = Dec(Hex(FileRead($File, 4)))
EndIf
For $i = 1 to $Files
	FileRead($File, 4)
	If $Endian = 0 Then
		$Offset = FileRead($File, 4)
	Else
		$Offset = Dec(Hex(FileRead($File, 4)))
	EndIf
	If $Endian = 0 Then
		$Size = FileRead($File, 4)
	Else
		$Size = Dec(Hex(FileRead($File, 4)))
	EndIf
	$pos = FileGetPos($File)
	FileSetPos($File,$Offset,0)
	$hFile = FileOpen("unpacked\"&$i&".gmd", 2+8+16)
	FileWrite($hFile, FileRead($File,$Size))
	FileClose($hFile)
	FileSetPos($File,$pos,0)
Next
$Names = _FileListToArray("unpacked\", "*.gmd", 1)
_ArrayNaturalSort($Names,0,1)
Dim $Text
For $i=1 to $Names[0]
	$File = FileOpen("unpacked\" &"\"& $Names[$i], 0+16)
	FileSetPos($File,8,0)
	If $Endian = 0 Then
		$Lang = FileRead($File,4)
	Else
		$Lang = Dec(Hex(FileRead($File,4)))
	EndIf
	If $Lang = 1 Then
		$Asize = FileGetSize("unpacked\" &"\"& $Names[$i])
		FileSetPos($File,24,0)
		If $Endian = 0 Then
			$Files = FileRead($File,4)
		Else
			$Files = Dec(Hex(FileRead($File,4)))
		EndIf
		FileRead($File,4)
		If $Endian = 0 Then
			$Size = _Binarytoint32(FileRead($File,4))
		Else
			$Size = Dec(Hex(FileRead($File,4)))
		EndIf
		Filesetpos($File,$Asize-$Size,0)
		For $n = 1 to $Files
			$S = ""
			$Str = ""
			Do
				$Str &= $S
				$S = FileRead ($File, 1)
			Until $S = 0
			$Str = BinaryToString("0x" & StringRegExpReplace($Str,"0x",""),4)
			$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
			$Str = StringRegExpReplace($Str,@LF,"<lf>")
			$Str = StringRegExpReplace($Str,@CR,"<cr>")
			$Text &= $Str & @CRLF
		Next
	EndIf
	FileClose($File)
Next
$hTextFile = FileOpen (CompGetFileName($Path)&".txt", 2+256)
FileWrite($hTextFile, $Text)
FileClose($hTextFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc