#include <File.au3>
#include <Binary.au3>
Dim $plus = Binary("0x00")
$Path = FileOpenDialog("Select the BIN file", @ScriptDir, "bin files (*.bin)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
If $File = -1 Then Exit
$Binname = CompGetFileName($Path)
$Files = FileRead($File,1)
$Newfile = $Files
If $Files >= 64 Then
	$Files2 = FileRead($File,1)
	$Files = (Dec(Hex($Files2))-1)*64 + Dec(Hex($Files))
	$Newfile &= $Files2
EndIf
for $i = 1 to $Files
	$bNamesize = FileRead($File,1)
	$bName = FileRead ($File, $bNamesize)
	$Name = StringTrimRight(BinaryToString($bName),1)
	$pos = FileGetPos($File)
	$Sections = FileRead($File,1)
	$Newfile &= $bNamesize & $bName & $Sections
	If $Sections >= 64 Then
		$Sections2 = FileRead($File,1)
		$Sections = (Dec(Hex($Sections2))-1)*64 + Dec(Hex($Sections))
		$Newfile &= $Sections2
	EndIf
	Dim $NEWdata, $z = 1
	_FileReadToArray("unpacked\"&$Name,$NEWdata)
	For $s = 1 to $Sections
		$Len  = FileRead($File,1)
		$u = 0
		If $Len >= 64 And $Len < 128 Then
			$Len = (Dec(Hex(FileRead($File,1)))-1)*64 + Dec(Hex($Len))
		ElseIf $Len >= 128 Then
			$Len = (Dec(Hex($Len))- Int(128/Dec(Hex(FileRead($File,1)))))*2
			$u = 1
		EndIf
		If $u = 0 Then
			FileRead($File,$Len)
		Else
			FileRead($File,$Len)
		EndIf
		$NewText = StringToBinary($NEWdata[$z]) & $plus
		$Newlen = BinaryLen($NewText)
		$Div = Int($Len/64)
		If $Div > 0 Then
			$Newlen = $Newlen-(64*($Div-1))
			$Newfile &= Binary("0x" & Hex ($Newlen, 2)) & Binary("0x" & Hex ($Div, 2)) & $NewText
		Else
			$Newfile &= Binary("0x" & Hex ($Newlen, 2)) & $NewText
		EndIf
		$Num = FileRead($File,1)
		$Newfile &= $Num
		$Num = Dec(Hex($Num))
		If $Num >= 64 Then
			$Num2 = FileRead($File,1)
			$Num = (Dec(Hex($Num2))-1)*64 + Dec(Hex($Num))
			$Newfile &= $Num2
		EndIf
		$Num *= 2
		For $k = 1 to $Num
			$u = 0
			$Len  = FileRead($File,1)
			If $Len >= 64 And $Len < 128 Then
				$Len = (Dec(Hex(FileRead($File,1)))-1)*64 + Dec(Hex($Len))
			ElseIf $Len >= 128 Then
				$Len = (Dec(Hex($Len))- Int(128/Dec(Hex(FileRead($File,1)))))*2
				$u = 1
			EndIf
			If $u = 0 Then
				FileRead($File,$Len)
			Else
				FileRead($File,$Len)
			EndIf
			$NEWdata[$z+$k] = StringRegExpReplace($NEWdata[$z+$k],"<cf>",@CRLF)
			$NEWdata[$z+$k] = StringRegExpReplace($NEWdata[$z+$k],"<lf>",@LF)
			$NEWdata[$z+$k] = StringRegExpReplace($NEWdata[$z+$k],"<cr>",@CR)
			If $NEWdata[$z+$k] <> "" Then
				$NewText = StringToBinary($NEWdata[$z+$k]) & $plus
				$Newlen = BinaryLen($NewText)
				$Div = Int($Len/64)
				If $Div > 0 Then
					$Newlen = $Newlen-(64*($Div-1))
					$Newfile &= Binary("0x" & Hex ($Newlen, 2)) & Binary("0x" & Hex ($Div, 2)) & $NewText
				Else
					$Newfile &= Binary("0x" & Hex ($Newlen, 2)) & $NewText
				EndIf
			Else
				$Newfile &= Binary("0x" & Hex (0, 2))
			EndIf
		Next
		$z += $k
	Next
Next
$hNewfile = FileOpen ("NEW_"&$Binname, 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc