#include<File.au3>
#include<zlib.au3>
#include<ArrayNaturalSort.au3>
#include<Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata, $pos = 13, $num = 0
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
FileRead($File,4)
$Files = _BinaryToInt32(FileRead($File,4))
$Offset = 8+$Files*8
FileSetPos($File,0,0)
$Newfile = FileRead($File,$Offset)
For $i = 1 to $Files
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$NewText = StringToBinary($NEWdata[$i],4) & Binary("0x00")
	$Len = BinaryLen($NewText)
	$Newfile &= $NewText
	$Newfile = _BinaryPoke($Newfile,$pos,$Offset,"dword")
	$Offset += $Len
	$pos += 8
Next
$hNewfile = FileOpen($Name, 2+16)
FileWrite($hNewfile, $Newfile)
FileClose($hNewfile)
$Path = FileOpenDialog("Select the UNP file", @ScriptDir, "unp files (*.unp)",1)
If @error = 1 Then Exit
$Name = StringTrimRight(CompGetFileName($Path),4)
$Names = _FileListToArray(@ScriptDir, "*.dat", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no dat files in the folder.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
Dim $Sizes[$Names[0]]
For $i = 1 to $Names[0]
	$hFile = FileOpen(@ScriptDir&"\"&$Names[$i], 16)
	$Sizes[$i-1] = FileGetSize(@ScriptDir&"\"&$Names[$i])
	FileClose($hFile)
Next
$File = fileopen($Path,16)
$Blocks = _BinaryToInt32(FileRead($File,4))
FileSetPos($File,0,0)
$Newunp = FileRead($File,260+$Blocks*16)
For $i = 1 to $Blocks
	$Newunp &= FileRead($File,16)
	$Files = FileRead($File,4)
	$Newunp &= $Files
	For $f = 1 to $Files
		$Newunp &= FileRead($File,8)
		FileRead($File,4)
		$Newunp &= _BinaryReverse(Binary("0x" & Hex($Sizes[$num+$f-1],8)))
	Next
	$Newunp &= FileRead($File,4)
	For $f = 1 to $Files
		$hFile = FileOpen($Names[$num+$f], 16)
		$Newunp &= FileRead($hFile)
		FileClose($hFile)
	Next
	$num += $f-1
Next
FileClose($File)
$plus = 65536 - Mod(BinaryLen($Newunp),65536)
$Newunp &= _BinaryRandom($plus,0,0)
$num = Int(BinaryLen($Newunp)/65536)
$File = fileopen($Name,16)
$Newfile = FileRead($File,12)
FileClose($File)
$pos = 1
For $i = 1 to $num
	$Comp = _ZLIB_Compress(BinaryMid($Newunp,$pos,65536), 9)
	$Newfile &= _BinaryReverse(Binary("0x" & Hex(BinaryLen($Comp),8))) & $Comp
	$pos += 65536
Next
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile)
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc