#include<Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
$Path = FileOpenDialog("Select the file", @ScriptDir, "all files (*.*)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
$Name = CompGetFileName($Path)
Dim $Text
If FileRead($File,4) = 0 Then
	FileSetPos($File,36,0)
	$Endian = 0
Else
	FileSetPos($File,28,0)
	$Endian = 1
EndIf
For $b = 1 to 6
	FileRead($File,12)
	If $Endian = 0 Then
		$Files = Dec(Hex(FileRead($File,4)))
	Else
		$Files = FileRead($File,4)
	EndIf
	For $i = 1 to $Files
		If $Endian = 0 Then
			$Size = Dec(Hex(FileRead($File,4)))
		Else
			$Size = _BinaryToInt32(FileRead($File,4))
		EndIf
		FileRead($File,$Size)
		$Pad = 4 - Mod($Size,4)
		If $Pad > 0 And $Pad < 4 Then
			FileRead($File,$Pad)
		EndIf
		If $Endian = 0 Then
			$Size = Dec(Hex(FileRead($File,4)))
		Else
			$Size = _BinaryToInt32(FileRead($File,4))
		EndIf
		$Str = BinaryToString(FileRead($File,$Size),4)
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
		$Pad = 4 - Mod($Size,4)
		If $Pad > 0 And $Pad < 4 Then
			FileRead($File,$Pad)
		EndIf
	Next
Next
$hFile = FileOpen ($Name&".txt", 2+256)
FileWrite($hFile, $Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc