#Include <File.au3>
#Include <Array.au3>
#include <Binary.au3> 
$sScriptName = "Memento Mori 2 Text Importer"
$sOLDFilePath = FileOpenDialog("Select the ORIG file", @ScriptDir, "orig file (*.orig)|All (*.*)",1)
	If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
	$hOLDfile = FileOpen ($sOLDFilePath, 0+32) 
	$bOLDfile = FileRead ($hOLDfile)
	FileClose ($hOLDfile)
$a1=StringRegExp($bOLDfile&'[', '(?s)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n1=UBound($a1)
Dim $OLDdata[$n1]
For $i = 0 to $n1-2 Step 2
    $OLDdata[$i] = StringTrimRight (StringTrimLeft ($a1[$i], 1), 1)
	$OLDdata[$i+1] = $a1[$i+1]
Next

$sNEWFilePath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)|All (*.*)",1)
	If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
	$hNEWfile = FileOpen ($sNEWFilePath, 0+32) 
	$bNewfile = FileRead ($hNEWfile)
	FileClose ($hNEWfile)
$a2=StringRegExp($bNEWfile&'[', '(?s)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n2=UBound($a2)
Dim $NEWdata[Int($n2/2)]
For $i = 0 to $n2-2 Step 2
    $NEWdata[$i/2]=$a2[$i+1]
Next

$FilePath = FileOpenDialog("Select the DB file", @ScriptDir, "db files (*.db)|All (*.*)",1)
	If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
	$hFile = FileOpen ($FilePath, 0+16) 
	$bFile = FileRead ($hFile)
	FileClose ($hFile)
	
MsgBox(0, "Working", "Please wait, this will takes about 10 minutes!" & @CRLF & "Click the OK button, and wait for finish!")
$k=0
$Pos = 0
$Diff = 0
$plus = Binary ("0x" & Hex (0, 4))
For $i=0 To ($n2/2)-1
   $bNEWText = StringToBinary ($NEWdata[$i],2)
   $bOLDText = StringToBinary ($OLDdata[$k+1],2)
   $bOLDText = $bOLDText & $plus
   $bNEWText = $bNEWText & $plus
   $NEWTextLen = Int(Dec(Hex (BinaryLen ($bNEWText), 4)))/2
   $bOLDTextLen = _BinaryReverse(Binary ("0x" & Hex (Int($OLDdata[$k]), 4)))
   $bNEWTextLen = _BinaryReverse(Binary ("0x" & Hex (Int($NEWTextLen), 4)))
   $bOLDText = $bOLDTextLen & $bOLDText
   $bNEWText = $bNEWTextLen & $bNEWText
   If $bOLDText <> $bNEWText Then
   $bFile = _BinaryReplace($bFile, $bOLDText, $bNEWText, 1)
   EndIf
   $k += 2
Next
   $hFile = FileOpen ("new_TEXTS.DB", 2+16)
   FileWrite ($hFile, $bFile)
   FileClose ($hFile)
MsgBox(0, "End", "Finish!")