$Path = FileOpenDialog("Select the XFBIN file", @ScriptDir, "xfbin files (*.xfbin)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
$Name = CompGetFileName($Path)
FileSetPos($File,288,0)
$Files = _BinaryToInt32(FileRead($File,4))
If $Files > 10000000 Or $Files < 0 Then
	FileSetPos($File,288,0)
	$Files = Dec(Hex(FileRead($File,4)))
	$Endian = 0
Else
	$Endian = 1
EndIf
Dim $Text
FileRead($File,4)
For $i = 1 to $Files
	FileRead($File,4)
	If $Endian = 0 Then
		$Offset1 = Dec(Hex(FileRead($File,4)))
	Else
		$Offset1 = _BinaryToInt32(FileRead($File,4))
	EndIf
	if $Offset1 <> 0 Then $Offset1 += FileGetPos($File)-4
	If $Endian = 0 Then
		$Offset2 = Dec(Hex(FileRead($File,4)))
	Else
		$Offset2 = _BinaryToInt32(FileRead($File,4))
	EndIf
	if $Offset2 <> 0 Then $Offset2 += FileGetPos($File)-4
	FileRead($File,4)
	$pos = FileGetPos($File)
	if $Offset1 <> 0 Then
		FileSetPos($File,$Offset1,0)
		$S = ""
		$Str = ""
		Do
			$Str &= $S
			$S = FileRead ($File, 1)
		Until $S = 0
		$Str = BinaryToString("0x" & StringRegExpReplace($Str,"0x",""),4)
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
	EndIf
	if $Offset2 <> 0 Then
		FileSetPos($File,$Offset2,0)
		$S = ""
		$Str = ""
		Do
			$Str &= $S
			$S = FileRead ($File, 1)
		Until $S = 0
		$Str = BinaryToString("0x" & StringRegExpReplace($Str,"0x",""),4)
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
	EndIf
	FileSetPos($File,$pos,0)
Next
$hFile = FileOpen ($Name&".txt", 2+128)
FileWrite ($hFile, $Text)
FileClose ($hFile)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func _BinaryToInt32($Binary)
	Return BitAND(Int(Binary($Binary)), 0xFFFFFFFF)
EndFunc