#Include <File.au3>
#Include <Binary.au3>
$sScriptName = "Ninja Blade Text Exporter"
$sLocbFilePath = FileOpenDialog("Select the file", @ScriptDir, "fmg files (*.fmg)|All (*.*)",1+4)
If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
Dim $sAllText, $sAllText2, $hLocbfile, $bLocbfile
$hLocbfile = FileOpen ($sLocbFilePath, 0+16)
$bLocbfile = FileRead ($hLocbfile)
FileClose ($hLocbfile)
$Pos = 0
$k = 1
$ID = Dec (Hex (Binarymid ($bLocbfile, 1, 4), 4))
$Size = Dec (Hex (Binarymid ($bLocbfile, 5, 4), 4))
$Files = Dec (Hex (Binarymid ($bLocbfile, 17, 4), 4))
$Offpos = Dec (Hex (Binarymid ($bLocbfile, 21, 4), 4))
$Name = StringTrimRight(CompGetFileName($sLocbFilePath),4)
For $i = 1 To $Files
	  $sAllText &= "[" & $k & "]" & @CRLF
	  $Pos1 = $Pos
   Do
	  $Offset = Dec (Hex (Binarymid ($bLocbfile, $Offpos+$Pos1+1, 4), 4))
	  If $Offset == 0 Then
		 $i += 1
	  EndIf
	  $Pos1 += 4
   Until $Offset <> 0
   	  $Pos = $Pos1
	  $Pos2 = $Pos1
   If $i == $Files Then
	  $Len = $Size
   Else
   Do
	  $Len = Dec (Hex (Binarymid ($bLocbfile, $Offpos+1+$Pos2, 4), 4))
	  $Pos2 += 4
   Until $Len <> 0
   EndIf
   If $ID = 10002 Then
	  $Offset += 32
   EndIf
	  $Len -= $Offset+2
	  $sAllText &= BinaryToString (Binarymid ($bLocbfile, $Offset+1, $Len), 3) & @CRLF
	  $sAllText2 &= "[" & $Offpos+$Pos1-3 & "]" & @CRLF
	  $sAllText2 &= "[" & $Len & "]" & @CRLF
	  $sAllText2 &= BinaryToString (Binarymid ($bLocbfile, $Offset+1, $Len), 3) & @CRLF
	  $k += 1
Next
sleep (50)
TrayTip ($sScriptName, "Finish!", 3)
$sAllTextFilePath = FileSaveDialog ("Save to file", @ScriptDir, "text files (*.txt)", 2+16, $Name&".txt")
If $sAllTextFilePath = "" Then Exit
$hAllTextFil = FileOpen ($sAllTextFilePath, 2+64)
FileWrite ($hAllTextFil, $sAllText)
FileClose ($hAllTextFil)
$sAllTextFilePath2 = FileSaveDialog ("Save to file", @ScriptDir, "text files (*.txt)", 2+16, $Name&".orig")
If $sAllTextFilePath2 = "" Then Exit
$hAllTextFil2 = FileOpen ($sAllTextFilePath2, 2+64)
FileWrite ($hAllTextFil2, $sAllText2)
FileClose ($hAllTextFil2)


Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
	EndFunc