#Include <File.au3>
#Include <Array.au3>
#include <Binary.au3>
$sScriptName = "Ninja Blade Text Importer"
$sOLDFilePath = FileOpenDialog("Select the ORIG file", @ScriptDir, "orig file (*.orig)|All (*.*)",1)
	If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
	$hOLDfile = FileOpen ($sOLDFilePath, 0+64)
	$bOLDfile = FileRead ($hOLDfile)
	FileClose ($hOLDfile)
$a1=StringRegExp($bOLDfile&'[', '(?s)(\[.*?\])(?:\r\n)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n1=UBound($a1)
Dim $OLDdata[$n1]
For $i = 0 to $n1-3 Step 3
    $OLDdata[$i] = StringTrimRight (StringTrimLeft ($a1[$i], 1), 1)
	$OLDdata[$i+1] = StringTrimRight (StringTrimLeft ($a1[$i+1], 1), 1)
    $OLDdata[$i+2]=$a1[$i+2]
Next
$sNEWFilePath = FileOpenDialog("Select the TXT file", @ScriptDir, "text (*.txt)|All (*.*)",1)
	If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
	$hNEWfile = FileOpen ($sNEWFilePath, 0+64)
	$bNewfile = FileRead ($hNEWfile)
	FileClose ($hNEWfile)
$a2=StringRegExp($bNEWfile&'[', '(?s)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n2=UBound($a2)
Dim $NEWdata[Int($n2/2)]
For $i = 0 to $n2-2 Step 2
    $NEWdata[$i/2]=$a2[$i+1]
Next
$FilePath = FileOpenDialog("Select the FMG file", @ScriptDir, "fmg files (*.fmg)|All (*.*)",1)
	If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
	$hFile = FileOpen ($FilePath, 0+16)
	$bFile = FileRead ($hFile)
	FileClose ($hFile)

$ID = Dec (Hex (Binarymid ($bFile, 1, 4), 4))
$Size = Dec (Hex (Binarymid ($bFile, 5, 4), 4))
$Name = CompGetFileName($FilePath)
$k=2
$Pos = 0
$Diff = 0
$plus = Binary ("0x" & Hex (00, 2))
If $ID = 10002 Then
For $i=0 To ($n2/2)-1
   $NEWText = StringRegExpReplace($NEWdata[$i],@CRLF,@LF)
   $bNEWText = StringToBinary ($NEWText,3)
   $bOLDText = StringToBinary ($OLDdata[$k],3)
If $i <> ($n2/2)-1 Then
   $OLDTextLen = Int($OLDdata[$k-1])
Else
   $OLDTextLen = Dec(Hex (BinaryLen ($bOLDText), 8))
EndIf
   $NEWTextLen = Dec(Hex (BinaryLen ($bNEWText), 8))
   $Pos = Int($OLDdata[$k-2])
   $NewOff = Dec (Hex (Binarymid ($bFile, $Pos, 4), 4))
   $NewOff += $Diff
   $Diff += $NEWTextLen - $OLDTextLen
   $bNewOff = Binary ("0x" & Hex (Int($NewOff), 8))
   $bOLDText = $plus & $bOLDText & $plus
   $bNEWText = $plus & $bNEWText & $plus
   If $bOLDText <> $bNEWText Then
   $bFile = _BinaryReplace($bFile, $bOLDText, $bNEWText, 1)
   EndIf
   $bFile = _BinaryPoke($bFile, $Pos, $bNewOff, "dword")
   $k += 3
Next
$Size+=$Diff
$Size = Binary ("0x" & Hex (Int($Size), 8))
$bFile = _BinaryPoke($bFile, 5, $Size, "dword")
   $hFile = FileOpen ("new_"&$Name, 2+16)
   FileWrite ($hFile, $bFile)
   FileClose ($hFile)
MsgBox(0, "End", "Finish!")
Else
   $Off = Int($OLDdata[$k-2])
   $Nlen = Dec (Hex (Binarymid ($bFile, $Off, 4), 4))
   $NewFile = Binarymid ($bFile, 1, $Nlen)
For $i=0 To ($n2/2)-1
   $NEWText = StringRegExpReplace($NEWdata[$i],@CRLF,@LF)
   $bNEWText = StringToBinary ($NEWText,3)
   $bOLDText = StringToBinary ($OLDdata[$k],3)
If $i <> ($n2/2)-1 Then
   $OLDTextLen = Int($OLDdata[$k-1])
Else
   $OLDTextLen = Dec(Hex (BinaryLen ($bOLDText), 8))
EndIf
   $NEWTextLen = Dec(Hex (BinaryLen ($bNEWText), 8))
   $Pos = Int($OLDdata[$k-2])
   $NewOff = Dec (Hex (Binarymid ($bFile, $Pos, 4), 4))
   $NewOff += $Diff
   $Diff += $NEWTextLen - $OLDTextLen
   $bNewOff = Binary ("0x" & Hex (Int($NewOff), 8))
   $bNEWText = $bNEWText & $plus & $plus
   $NewFile &= $bNEWText
   $NewFile = _BinaryPoke($NewFile, $Pos, $bNewOff, "dword")
   $Nlen += $NEWTextLen+2
   $k += 3
Next
$Size = Binary ("0x" & Hex ($Nlen, 8))
$NewFile = _BinaryPoke($NewFile, 5, $Size, "dword")
   $hNewFile = FileOpen ("new_"&$Name, 2+16)
   FileWrite ($hNewFile, $NewFile)
   FileClose ($hNewFile)
MsgBox(0, "End", "Finish!")
EndIf
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
	EndFunc