#include <Binary.au3>
$Path = FileOpenDialog("Select the P3D file", @ScriptDir, "p3d files (*.p3d)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
$Id = FileRead($File,3)
If $Id = "P3D" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
FileRead($File,5)
If $Endian = 0 Then
	$Asize = _BinaryToInt32(FileRead($File,4))
Else
	$Asize = Dec(Hex(FileRead($File,4)))
EndIf
$i = 1
Do
	$Offset = FileGetPos($File)
	FileRead($File,8)
	If $Endian = 0 Then
		$Size = _BinaryToInt32(FileRead($File,4))
	Else
		$Size = Dec(Hex(FileRead($File,4)))
	EndIf
	FileSetPos($File,$Offset,0)
	$hFile = FileOpen($i&".dat", 2+16)
	FileWrite($hFile,FileRead($File,$Size))
	FileClose($hFile)
	$i += 1
Until FileGetPos($File) = $Asize
FileClose($File)
$Path = FileOpenDialog("Select the DAT file", @ScriptDir, "dat files (*.dat)",1)
If @error = 1 Then Exit
$Name = CompGetFileName($Path)
$File = fileopen($Path,16)
FileRead($File,12)
FileRead($File,FileRead($File,1))
FileRead($File,4)
If $Endian = 0 Then
	$Files = _BinaryToInt32(FileRead($File,4))
Else
	$Files = Dec(Hex(FileRead($File, 4)))
EndIf
Dim $Text, $Offsets[$Files+1]
For $i = 1 to $Files
	FileRead($File,FileRead($File,1))
Next
For $i = 1 to $Files
	If $Endian = 0 Then
		$Offsets[$i-1] = _BinaryToInt32(FileRead($File,4))
	Else
		$Offsets[$i-1] = Dec(Hex(FileRead($File,4)))
	EndIf
Next
FileRead($File,$Files*4)
FileRead($File,12)
FileRead($File,FileRead($File,1))
FileRead($File,4)
If $Endian = 0 Then
	$Offsets[$i-1] = _BinaryToInt32(FileRead($File,4))
Else
	$Offsets[$i-1] = Dec(Hex(FileRead($File,4)))
EndIf
For $i = 1 to $Files
	$Size = $Offsets[$i] - $Offsets[$i-1]
	$Str = BinaryToString(FileRead($File,$Size),4)
	$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
	$Str = StringRegExpReplace($Str,@LF,"<lf>")
	$Str = StringRegExpReplace($Str,@CR,"<cr>")
	$Text &= $Str & @CRLF
Next
$File = FileOpen($Name&".txt", 2+256)
FileWrite($File,$Text)
FileClose($File)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc