#include <File.au3>
#include <Binary.au3>
#include <winapi.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$FilePath = FileOpenDialog("Select the LOC8 file", @ScriptDir, "loc8 files (*.loc8)",1)
If @error = 1 Then Exit
$LangidFiles = Binary ("0x" & Hex ($NEWdata[1], 8)) & Binary ("0x" & Hex ($NEWdata[0]-1, 8))
$Pos = _HexSearch($FilePath, $LangidFiles)
If $Pos < 1 Then
	MsgBox(0,"","Can't find the langid: "&$NEWdata[1])
	Exit
EndIf
$hFile = FileOpen ($FilePath, 0+16)
If $hFile = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
$NewfileHead = FileRead($hFile,$Pos)
$NewfileText = FileRead($hFile,8)
For $i = 2 to $NEWdata[0]
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$NewText = StringToBinary($NEWdata[$i],4)
	$NewfileText &= FileRead($hFile,4) & Binary("0x" & Hex (BinaryLen($NewText), 8)) & $NewText
	FileRead($hFile,Dec(Hex(Fileread($hFile,4))))
Next
$NewfileText &= FileRead($hFile)
$hNewfile = FileOpen ("NEW_"&CompGetFileName($FilePath), 2+16)
FileWrite ($hNewfile, $NewfileHead&$NewfileText)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func _HexSearch($FilePath, $BinaryValue, $StartOffset = Default)
        Local $Buffer, $ptr, $hFile, $Result, $Read, $SearchValue, $Pos, $BufferSize = 2048
            If $StartOffset = Default       Then    $StartOffset = 0
            If Not FileExists($FilePath)    Then    Return SetError(1, @error, 0)
            $fLen = FileGetSize($FilePath)
            If $StartOffset > $fLen         Then    Return SetError(2, @error, 0)
            If Not IsBinary($BinaryValue)   Then    Return SetError(3, @error, 0)
            If Not IsNumber($StartOffset)   Then    Return SetError(4, @error, 0)
            $SearchValue = BinaryToString($BinaryValue)
            $Buffer = DllStructCreate("byte[" & $BufferSize & "]")
            $ptr = DllStructGetPtr($Buffer)
                $hFile = _WinAPI_CreateFile($FilePath, 2, 2, 1)
                If $hFile = 0 Then Return SetError(5, @error, 0)
            $Result = _WinAPI_SetFilePointer($hFile, $StartOffset)
            $err = @error
            If $Result = 0xFFFFFFFF Then
                _WinAPI_CloseHandle($hFile)
                Return SetError(5, $err, 0)
            EndIf
            $Pos = $StartOffset
            While True
                    $Read = 0
                    $Result = _WinAPI_ReadFile($hFile, $ptr, $BufferSize, $Read)
                    $err = @error
                    If Not $Result Then
                        _WinAPI_CloseHandle($hFile)
                        Return SetError(6, $err, 0)
                    EndIf
                    $Result = DllStructGetData($Buffer, 1)
                    $Result = BinaryToString($Result)
                    $Result = StringInStr($Result, $SearchValue)
                    If $Result > 0 Then ExitLoop
                    If $Read < $BufferSize Then
                        _WinAPI_CloseHandle($hFile)
                        Return -1
                    EndIf
                    $Pos += $Read
            WEnd
            _WinAPI_CloseHandle($hFile)
            If Not $Result Then Return SetError(7, @error, 0)
            $Result = $Pos + $Result - 1
            Return $Result
		EndFunc