#Include <File.au3>
#include <Binary.au3>
$MsgDir = FileSelectFolder ("Select the MSG folder...", "", "", @ScriptDir)
If $MsgDir = "" Then
   Exit
EndIf
$Lang = InputBox("Language", "Type the language you want to export."&@CRLF&"eng, pol, ...", "", " M3")
$Names = _FileListToArray($MsgDir, "*"&$Lang&".gmd", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no gmd files in the folder,"&@CR&"or you type wrong language.")
	Exit
EndIf
Dim $Text
$File = FileOpen ($MsgDir &"\"& $Names[1], 0+16)
$Id = FileRead($File,3)
FileClose($File)
If $Id = "GMD" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
For $i=1 to $Names[0]
	$File = FileOpen ($MsgDir &"\"& $Names[$i], 0+16)
	FileSetPos($File,20,0)
	If $Endian = 0 Then
		$Files = _BinaryToInt32(FileRead ($File, 4))
	Else
		$Files = Dec(Hex(FileRead($File, 4)))
	EndIf
	Dim $Entries[$Files],$real = 0
	for $e = 1 to $Files
		If $Endian = 0 Then
			$Offset = _BinaryToInt32(FileRead ($File, 4))
		Else
			$Offset = Dec(Hex(FileRead($File, 4)))
		EndIf
		If $Offset >= 0 Then
			$Entries[$real] = $Offset
			$real += 1
		EndIf
	Next
	FileRead ($File, 4)
	$Pos = FileGetPos($File)
	For $r = 1 to $real
		Filesetpos($File,$Pos+$Entries[$r-1],0)
		$S = ""
		$Str = ""
		Do
			$Str &= $S
			$S = FileRead ($File, 1)
		Until $S = 0
		$Str = BinaryToString("0x" & StringRegExpReplace($Str,"0x",""),4)
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
	Next
	FileClose($File)
Next
$hTextFile = FileOpen ("RE6_Text_"&$Lang&".txt", 2+256)
FileWrite($hTextFile, $Text)
FileClose($hTextFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)