#Include<File.au3>
#include<Binary.au3>
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArray($Dir, "*.le_strings", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .le_strings files in the folder.")
	Exit
EndIf
Dim $Text
For $i=1 to $Names[0]
	$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,4,0)
	$Type = FileRead($file,2)
	If $Type = 1 Then
		FileRead($file,2)
		$files = FileRead($file,4)
		for $f = 1 to $files
			$f += _BinaryToInt32(FileRead($file,4))-1
			FileRead($file,4)
		Next
		for $f = 1 to $files
			$Offset = FileRead($file,4)
			$pos = FileGetPos($file)
			FileSetPos($file,$Offset,0)
			FileRead($file,4)
			$S = ""
			$Str = ""
			Do
				$Str &= BinaryToString($S,2)
				$S = FileRead($file,2)
			Until $S = 0
			$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
			$Str = StringRegExpReplace($Str,@LF,"<lf>")
			$Str = StringRegExpReplace($Str,@CR,"<cr>")
			$Text &= $Str & @CRLF
			FileSetPos($file,$pos,0)
		Next
	Else
		$files = FileRead($file,4)
		for $f = 1 to $files
			FileRead($File,4)
			$Size = _BinaryToInt32(FileRead($File,2))
			$Str = StringTrimRight(BinaryToString(FileRead($file,$Size),2),1)
			$Pad = 4-Mod(FileGetPos($file),4)
			If $Pad > 0 And $Pad < 4 Then FileRead($file,$Pad)
			$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
			$Str = StringRegExpReplace($Str,@LF,"<lf>")
			$Str = StringRegExpReplace($Str,@CR,"<cr>")
			$Text &= $Str & @CRLF
		Next
	EndIf
	FileClose($File)
Next
$hTextFile = FileOpen(CompGetFileName($Dir)&".txt", 2+32)
FileWrite($hTextFile,$Text)
FileClose($hTextFile)
TrayTip ("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
EndFunc