#include<binary.au3>
$Path = FileOpenDialog("Select the BIN file", @ScriptDir, "bin files (*.bin)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
$Name = CompGetFileName($Path)
FileSetPos($File,4,0)
If FileRead($File,2) = 0 Then
	$Endian = 1
Else
	$Endian = 0
EndIf
FileSetPos($File,4,0)
If $Endian = 0 Then
	$FFnum = _BinaryToInt32(FileRead($File, 4))
	$Files = _BinaryToInt32(FileRead($File, 4))
Else
	$FFnum = Dec(Hex(FileRead($File,4)))
	$Files = Dec(Hex(FileRead($File,4)))
EndIf
FileRead($File,$FFnum*4)
Dim $Text
For $i = 1 to $Files
	If $Endian = 0 Then
		$Offset = _BinaryToInt32(FileRead($File, 4))
		FileRead($File,4)
	Else
		$Offset = Dec(Hex(FileRead($File,4)))
		FileRead($File,4)
	EndIf
	If $Offset = 0 Then
		$Text &= @CRLF
	Else
		$pos = FileGetPos($File)
		FileSetPos($File,$Offset,0)
		$S = ""
		$Str = ""
		Do
			$Str &= $S
			$S = FileRead ($File, 1)
		Until $S = 0
		$Str = BinaryToString("0x" & StringRegExpReplace($Str,"0x",""),4)
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
		FileSetPos($File,$pos,0)
	EndIf
Next
$hFile = FileOpen($Name&".txt", 2+256)
FileWrite($hFile, $Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc