#include <File.au3>
#include <Binary.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error!","Can't open "&$Name&" file.")
Exit
EndIf
FileSetPos($File,4,0)
If FileRead($File,2) = 0 Then
	$Endian = 1
Else
	$Endian = 0
EndIf
FileSetPos($File,4,0)
If $Endian = 0 Then
	$FFnum = _BinaryToInt32(FileRead($File, 4))
	$Files = _BinaryToInt32(FileRead($File, 4))
Else
	$FFnum = Dec(Hex(FileRead($File,4)))
	$Files = Dec(Hex(FileRead($File,4)))
EndIf
$plus = Binary("0x00")
$Offset = $FFnum*4+$Files*8+12
FileSetPos($File,0,0)
$Newfile = FileRead($File,$Offset)
$pos = $FFnum*4+13
$Newtext = Binary("0x00")
For $i = 1 To $Files
	If $NEWdata[$i] == "" Then
		$Newfile = _BinaryPoke($Newfile,$pos,Binary("0x" & Hex(0,8)),"dword")
	Else
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
		$bNewText = StringToBinary($NEWdata[$i],4) & $plus
		$NewLen = BinaryLen ($bNewText)
		If $Endian = 0 Then
			$Newfile = _BinaryPoke($Newfile,$pos,$Offset,"dword")
		Else
			$Newfile = _BinaryPoke($Newfile,$pos,Binary("0x" & Hex(int($Offset),8)),"dword")
		EndIf
		$Newtext &= $bNewText
		$Offset += $NewLen
	EndIf
	$pos += 8
Next
$hNewfile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewfile, $Newfile & BinaryMid($Newtext,2))
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc