#Include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArray($Dir, "*.tdb", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no tdb files in the folder.")
	Exit
EndIf
Dim $Text
$File = FileOpen ($Dir &"\"& $Names[1], 0+16)
$Id = FileRead($File,4)
FileClose($File)
If $Id = "#TDB" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,4,0)
	If $Endian = 0 Then
		$Files = _BinaryToInt32(FileRead($File,4))
	Else
		$Files = Dec(Hex(FileRead($File,4)))
	EndIf
	If $Endian = 0 Then
		$EntNum = _BinaryToInt32(FileRead($File,4))-2
	Else
		$EntNum = Dec(Hex(FileRead($File,4)))-2
	EndIf
	FileRead($File,4)
	for $n = 1 to $Files
		FileRead($File,4)
		If $Endian = 0 Then
			FileRead($File,FileRead($File,4))
		Else
			FileRead($File,Dec(Hex(FileRead($File,4))))
		EndIf
		For $e = 1 to $EntNum
			If $Endian = 0 Then
				$Size = FileRead($File,4)
			Else
				$Size = Dec(Hex(FileRead($File,4)))
			EndIf
			If $Endian = 0 Then
				$Str = StringTrimRight(BinaryToString(FileRead($File,$Size),2),1)
			Else
				$Str = StringTrimRight(BinaryToString(FileRead($File,$Size),3),1)
			EndIf
			$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
			$Str = StringRegExpReplace($Str,@LF,"<lf>")
			$Str = StringRegExpReplace($Str,@CR,"<cr>")
			$Text &= $Str & @CRLF
		Next
		If $Endian = 0 Then
			FileRead($File,FileRead($File,4))
		Else
			FileRead($File,Dec(Hex(FileRead($File,4))))
		EndIf
	Next
	FileClose($File)
Next
$hTextFile = FileOpen(CompGetFileName($Dir)&".txt", 2+32)
FileWrite($hTextFile, $Text)
FileClose($hTextFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc