#Include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata,$Num = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = FileSelectFolder ( "Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArray($Dir, "*.tdb", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no tdb files in the folder.")
	Exit
EndIf
$File = FileOpen ($Dir &"\"& $Names[1], 0+16)
$Id = FileRead($File,4)
FileClose($File)
If $Id = "#TDB" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,4,0)
	If $Endian = 0 Then
		$Files = _BinaryToInt32(FileRead($File,4))
	Else
		$Files = Dec(Hex(FileRead($File,4)))
	EndIf
	If $Endian = 0 Then
		$EntNum = _BinaryToInt32(FileRead($File,4))-2
	Else
		$EntNum = Dec(Hex(FileRead($File,4)))-2
	EndIf
	FileSetPos($File,0,0)
	$Newfile = FileRead($File,16)
	for $n = 1 to $Files
		$Newfile &= FileRead($File,4)
		$Size = FileRead($File,4)
		If $Endian = 0 Then
			$bSize = $Size
		Else
			$bSize = Dec(Hex($Size))
		EndIf
		$Newfile &= $Size & FileRead($File,$bSize)
		For $e = 1 to $EntNum
			If $Endian = 0 Then
				FileRead($File,FileRead($File,4))
			Else
				FileRead($File,Dec(Hex(FileRead($File,4))))
			EndIf
			$Str = $NEWdata[$Num]
			$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
			$Str = StringRegExpReplace($Str,"<lf>",@LF)
			$Str = StringRegExpReplace($Str,"<cr>",@CR)
			If $Endian = 0 Then
				$Newtext = StringToBinary($Str,2) & Binary("0x0000")
			Else
				$Newtext = StringToBinary($Str,3) & Binary("0x0000")
			EndIf
			If $Endian = 0 Then
				$Newfile &= _BinaryReverse(Binary("0x" & Hex(BinaryLen($Newtext),8))) & $Newtext
			Else
				$Newfile &= Binary("0x" & Hex(BinaryLen($Newtext),8)) & $Newtext
			EndIf
			$Num += 1
		Next
		$Size = FileRead($File,4)
		If $Endian = 0 Then
			$bSize = $Size
		Else
			$bSize = Dec(Hex($Size))
		EndIf
		$Newfile &= $Size & FileRead($File,$bSize)
	Next
	$hNewfile = FileOpen ($Dir &"\"& $Names[$i], 2+16)
	FileWrite($hNewfile,$Newfile)
	FileClose($hNewfile)
	FileClose($File)
Next
TrayTip("Importer", "Finish!", 3)
sleep(3000)