#include <Binary.au3>
$Path = FileOpenDialog("Select the TX0 file", @ScriptDir, "tx0 files (*.tx0)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
Dim $Text, $Chars[256]
Table()
$Name = CompGetFileName($Path)
FileRead($File,4)
$Files = FileRead($File,4)
FileRead($File,4)
For $i = 1 to $Files
	FileRead($File,4)
	$Offset = FileRead($File,4)
	$Size = _BinaryToInt32(FileRead($File,4))-1
	$pos = FileGetPos($File)
	FileSetPos($File,$Offset,0)
	$Str = ""
	For $n = 1 to $Size
		$S = BitXOR(FileRead($File,1),96)
		$Str &= BinaryToString($Chars[$S],2)
	Next
	FileRead($File,1)
	$Text &= $Str & @CRLF
	FileSetPos($File,$pos,0)
Next
$hFile = FileOpen ($Name&".txt", 2+32)
FileWrite($hFile, $Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func Table()
$Chars[1] = "0x7E01"
$Chars[2] = "0xC100"
$Chars[3] = "0x0C01"
$Chars[4] = "0x0E01"
$Chars[5] = "0xC900"
$Chars[6] = "0x1A01"
$Chars[7] = "0xCD00"
$Chars[8] = "0x4701"
$Chars[9] = "0xD300"
$Chars[10] = "0x5801"
$Chars[11] = "0x6001"
$Chars[12] = "0x6401"
$Chars[13] = "0xDA00"
$Chars[14] = "0xD301"
$Chars[15] = "0xDD00"
$Chars[16] = "0x7D01"
$Chars[17] = "0xE000"
$Chars[18] = "0xE200"
$Chars[19] = "0xE700"
$Chars[20] = "0xE800"
$Chars[21] = "0xEB00"
$Chars[22] = "0xEA00"
$Chars[23] = "0xEE00"
$Chars[24] = "0xEF00"
$Chars[25] = "0xF400"
$Chars[26] = "0x5301"
$Chars[27] = "0xFB00"
$Chars[28] = "0xC000"
$Chars[29] = "0xC200"
$Chars[30] = "0xC700"
$Chars[31] = "0xC800"
$Chars[32] = "0x2D00"
$Chars[33] = "0x3000"
$Chars[34] = "0x3100"
$Chars[35] = "0x3200"
$Chars[36] = "0x3300"
$Chars[37] = "0x3400"
$Chars[38] = "0x3500"
$Chars[39] = "0x3600"
$Chars[40] = "0x3700"
$Chars[41] = "0x3800"
$Chars[42] = "0x3900"
$Chars[43] = "0x2800"
$Chars[44] = "0x2900"
$Chars[45] = "0x2E00"
$Chars[46] = "0x3F00"
$Chars[47] = "0x2200"
$Chars[48] = "0x3B00"
$Chars[49] = "0x3D00"
$Chars[50] = "0x5F00"
$Chars[51] = "0xE100"
$Chars[52] = "0x0D01"
$Chars[53] = "0x0F01"
$Chars[54] = "0xE900"
$Chars[55] = "0x1B01"
$Chars[56] = "0xED00"
$Chars[57] = "0x4801"
$Chars[58] = "0xF300"
$Chars[59] = "0x5901"
$Chars[60] = "0x6101"
$Chars[61] = "0x6501"
$Chars[62] = "0xFA00"
$Chars[63] = "0x6F01"
$Chars[64] = "0x4200"
$Chars[65] = "0x4300"
$Chars[66] = "0x4400"
$Chars[67] = "0x4500"
$Chars[68] = "0x4600"
$Chars[69] = "0x4700"
$Chars[70] = "0x4800"
$Chars[71] = "0x4900"
$Chars[72] = "0x4A00"
$Chars[73] = "0x4B00"
$Chars[74] = "0x4C00"
$Chars[75] = "0x4D00"
$Chars[76] = "0x4E00"
$Chars[77] = "0x4F00"
$Chars[78] = "0x5000"
$Chars[79] = "0x5100"
$Chars[80] = "0x5200"
$Chars[81] = "0x5300"
$Chars[82] = "0x5400"
$Chars[83] = "0x5500"
$Chars[84] = "0x5600"
$Chars[85] = "0x5700"
$Chars[86] = "0x5800"
$Chars[87] = "0x5900"
$Chars[88] = "0x5A00"
$Chars[89] = "0xC400"
$Chars[90] = "0xD600"
$Chars[91] = "0xDC00"
$Chars[92] = "0x2C00"
$Chars[93] = "0x3A00"
$Chars[94] = "0x2700"
$Chars[95] = "0x2100"
$Chars[96] = "0x0000"
$Chars[97] = "0x6100"
$Chars[98] = "0x6200"
$Chars[99] = "0x6300"
$Chars[100] = "0x6400"
$Chars[101] = "0x6500"
$Chars[102] = "0x6600"
$Chars[103] = "0x6700"
$Chars[104] = "0x6800"
$Chars[105] = "0x6900"
$Chars[106] = "0x6A00"
$Chars[107] = "0x6B00"
$Chars[108] = "0x6C00"
$Chars[109] = "0x6D00"
$Chars[110] = "0x6E00"
$Chars[111] = "0x6F00"
$Chars[112] = "0x7000"
$Chars[113] = "0x7100"
$Chars[114] = "0x7200"
$Chars[115] = "0x7300"
$Chars[116] = "0x7400"
$Chars[117] = "0x7500"
$Chars[118] = "0x7600"
$Chars[119] = "0x7700"
$Chars[120] = "0x7800"
$Chars[121] = "0x7900"
$Chars[122] = "0x7A00"
$Chars[123] = "0xE400"
$Chars[124] = "0xDF00"
$Chars[125] = "0xF600"
$Chars[126] = "0xFC00"
$Chars[127] = "0x4100"
$Chars[128] = "0x0000"
$Chars[129] = "0x0000"
$Chars[130] = "0x0000"
$Chars[131] = "0x0000"
$Chars[132] = "0x0000"
$Chars[133] = "0x0000"
$Chars[134] = "0x0000"
$Chars[135] = "0x0000"
$Chars[136] = "0x0000"
$Chars[137] = "0x0000"
$Chars[138] = "0x0000"
$Chars[139] = "0x0000"
$Chars[140] = "0x0000"
$Chars[141] = "0x0000"
$Chars[142] = "0x0000"
$Chars[143] = "0x0000"
$Chars[144] = "0x0000"
$Chars[145] = "0x0000"
$Chars[146] = "0x0000"
$Chars[147] = "0x0000"
$Chars[148] = "0x0000"
$Chars[149] = "0x0000"
$Chars[150] = "0x0000"
$Chars[151] = "0x0000"
$Chars[152] = "0x0000"
$Chars[153] = "0x0000"
$Chars[154] = "0x0000"
$Chars[155] = "0x0000"
$Chars[156] = "0x0000"
$Chars[157] = "0x0000"
$Chars[158] = "0x0000"
$Chars[159] = "0x2000"
$Chars[160] = "0xDC00"
$Chars[161] = "0x3A00"
$Chars[162] = "0x2C00"
$Chars[163] = "0x2100"
$Chars[164] = "0x2D00"
$Chars[165] = "0x3000"
$Chars[166] = "0x3100"
$Chars[167] = "0x3200"
$Chars[168] = "0x3300"
$Chars[169] = "0x3400"
$Chars[170] = "0x3500"
$Chars[171] = "0x3600"
$Chars[172] = "0x3700"
$Chars[173] = "0x3800"
$Chars[174] = "0x3900"
$Chars[175] = "0x2800"
$Chars[176] = "0x2900"
$Chars[177] = "0x0000"
$Chars[178] = "0x0000"
$Chars[179] = "0x0000"
$Chars[180] = "0x0000"
$Chars[181] = "0x0000"
$Chars[182] = "0x0000"
$Chars[183] = "0x0000"
$Chars[184] = "0x0000"
$Chars[185] = "0x0000"
$Chars[186] = "0x0000"
$Chars[187] = "0x0000"
$Chars[188] = "0x0000"
$Chars[189] = "0x0000"
$Chars[190] = "0x0000"
$Chars[191] = "0x0000"
$Chars[192] = "0x5001"
$Chars[193] = "0x7001"
$Chars[194] = "0x2000"
$Chars[195] = "0x4100"
$Chars[196] = "0x4200"
$Chars[197] = "0x4300"
$Chars[198] = "0x4400"
$Chars[199] = "0x4500"
$Chars[200] = "0x4600"
$Chars[201] = "0x4700"
$Chars[202] = "0x4800"
$Chars[203] = "0x4900"
$Chars[204] = "0x4A00"
$Chars[205] = "0x4B00"
$Chars[206] = "0x4C00"
$Chars[207] = "0x4D00"
$Chars[208] = "0x4E00"
$Chars[209] = "0x4F00"
$Chars[210] = "0x5000"
$Chars[211] = "0x5100"
$Chars[212] = "0x5200"
$Chars[213] = "0x5300"
$Chars[214] = "0x5400"
$Chars[215] = "0x5500"
$Chars[216] = "0x5600"
$Chars[217] = "0x5700"
$Chars[218] = "0x5800"
$Chars[219] = "0x5900"
$Chars[220] = "0x5A00"
$Chars[221] = "0xC400"
$Chars[222] = "0xDF00"
$Chars[223] = "0xD600"
$Chars[224] = "0xCB00"
$Chars[225] = "0xCA00"
$Chars[226] = "0xCE00"
$Chars[227] = "0xCF00"
$Chars[228] = "0xD400"
$Chars[229] = "0x5201"
$Chars[230] = "0xDB00"
$Chars[231] = "0x0401"
$Chars[232] = "0x0601"
$Chars[233] = "0x1801"
$Chars[234] = "0x4101"
$Chars[235] = "0x4301"
$Chars[236] = "0x5A01"
$Chars[237] = "0x7B01"
$Chars[238] = "0x7901"
$Chars[239] = "0x0501"
$Chars[240] = "0x0701"
$Chars[241] = "0x1901"
$Chars[242] = "0x4201"
$Chars[243] = "0x4401"
$Chars[244] = "0x5B01"
$Chars[245] = "0x7C01"
$Chars[246] = "0x7A01"
$Chars[247] = "0xF100"
$Chars[248] = "0xD100"
$Chars[249] = "0xA100"
$Chars[250] = "0xBF00"
$Chars[251] = "0x5101"
$Chars[252] = "0xF900"
$Chars[253] = "0xEC00"
$Chars[254] = "0xF200"
$Chars[255] = "0x7101"
EndFunc