#include <File.au3>
#include <Binary.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error!","Can't open "&$Name&" file.")
Exit
EndIf
$Id = FileRead($File,4)
If $Id = "SKDB" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
FileRead($File,4)
If $Endian = 0 Then
	$Head = _BinaryToInt32(FileRead($File,4))
Else
	$Head = Dec(Hex(FileRead($File, 4)))
EndIf
If $Endian = 0 Then
	$Files = _BinaryToInt32(FileRead($File,4))
Else
	$Files = Dec(Hex(FileRead($File, 4)))
EndIf
$Baseoff = $Files*8+$Head
FileSetPos($File,0,0)
$Newfile = FileRead($File,$Baseoff)
$plus = Binary("0x0000")
$Offset = 0
$Newtext = Binary("0x00")
For $i = 1 To $Files
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	If $Endian = 0 Then
		$bNewText = StringToBinary ($NEWdata[$i],2) & $plus
	Else
		$bNewText = StringToBinary ($NEWdata[$i],3) & $plus
	EndIf
	$NewLen = BinaryLen ($bNewText)
	$padding = 4 - Mod($NewLen, 4)
	If $padding < 4 Then
		$Newtext &= $bNewText & _binaryrandom($padding, 0, 0)
		$NewLen += $padding
	Else
		$Newtext &= $bNewText
	EndIf
	If $Endian = 0 Then
		$Newfile = _BinaryPoke($Newfile,$Head+5,int($Offset/2),"dword")
	Else
		$Newfile = _BinaryPoke($Newfile,$Head+5,Binary("0x" & Hex(int($Offset/2),8)),"dword")
	EndIf
	$Offset += $NewLen
	$Head += 8
Next
$Newfile = $Newfile & BinaryMid($Newtext,2)
$hNewfile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc