#include<File.au3>
#include<Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
$Newfile = FileRead($File,4)
If $Newfile = "0x05000000" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
$Files = FileRead($File,4)
$Newfile &= $Files & FileRead($File,4)
If $Endian = 1 Then
	$Files = Dec(Hex($Files))
EndIf
$Tsize = 0
$Tsizeoff = 9
For $i = 1 to $Files
	$Newfile &= FileRead($File,8)
	$Size = FileRead($File,2)
	If $Endian = 0 Then
		$iSize = _BinaryToInt32($Size)
	Else
		$iSize = Dec(Hex($Size))
	EndIf
	$Newfile &= $Size & FileRead($File,$iSize)
	If $Endian = 0 Then
		$Size = _BinaryToInt32(FileRead($File,2))*2
		FileRead($File,$Size)
	Else
		$Size = Dec(Hex(FileRead($File,2)))*2
		FileRead($File,$Size)
	EndIf
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	If $Endian = 0 Then
		$NewText = StringToBinary($NEWdata[$i],2) & Binary("0x0000")
	Else
		$NewText = StringToBinary($NEWdata[$i],3) & Binary("0x0000")
	EndIf
	$Size = int(BinaryLen($NewText)/2)
	$Tsize += $Size
	If $Endian = 0 Then
		$Newfile &= _BinaryReverse(Binary("0x" & Hex($Size,4))) & $NewText
	Else
		$Newfile &= Binary("0x" & Hex($Size,4)) & $NewText
	EndIf
Next
$num = $i-1
$Newfile &= FileRead($File,4)
If $Endian = 0 Then
	$Newfile = _BinaryPoke($Newfile,$Tsizeoff,$Tsize,"dword")
Else
	$Newfile = _BinaryPoke($Newfile,$Tsizeoff,Binary("0x" & Hex($Tsize,8)),"dword")
EndIf
$Offsetpos = BinaryLen($Newfile) + 9
$pos = FileGetPos($File)
If $Endian = 0 Then
	$BlockNum = _BinaryToInt32(FileRead($File,4))
Else
	$BlockNum = Dec(Hex(FileRead($File,4)))
EndIf
Dim $Offsets[$BlockNum]
For $i = 1 to $BlockNum
	FileRead($File,4)
	If $Endian = 0 Then
		$Offsets[$i-1] = _BinaryToInt32(FileRead($File,4))
	Else
		$Offsets[$i-1] = Dec(Hex(FileRead($File,4)))
	EndIf
Next
FileSetPos($File,$pos,0)
$Newfile &= FileRead($File,$BlockNum*8+4)
$Offset = BinaryLen($Newfile)
For $i = 1 to $BlockNum
	If $Endian = 0 Then
		$Newfile = _BinaryPoke($Newfile,$Offsetpos,$Offset,"dword")
	Else
		$Newfile = _BinaryPoke($Newfile,$Offsetpos,Binary("0x" & Hex($Offset,8)),"dword")
	EndIf
	FileSetPos($File,$Offsets[$i-1],0)
	$Files = FileRead($File,4)
	$Newfile &= $Files
	If $Endian = 1 Then
		$Files = Dec(Hex($Files))
	EndIf
	$Tsize = 0
	$Tsizeoff = BinaryLen($Newfile)+1
	$Newfile &= FileRead($File,4)
	For $f = 1 to $Files
		$Newfile &= FileRead($File,8)
		$Size = FileRead($File,2)
		If $Endian = 0 Then
			$iSize = _BinaryToInt32($Size)
		Else
			$iSize = Dec(Hex($Size))
		EndIf
		$Newfile &= $Size & FileRead($File,$iSize)
		If $Endian = 0 Then
			$Size = _BinaryToInt32(FileRead($File,2))*2
			FileRead($File,$Size)
		Else
			$Size = Dec(Hex(FileRead($File,2)))*2
			FileRead($File,$Size)
		EndIf
		$NEWdata[$num+$f] = StringRegExpReplace($NEWdata[$num+$f],"<cf>",@CRLF)
		$NEWdata[$num+$f] = StringRegExpReplace($NEWdata[$num+$f],"<lf>",@LF)
		$NEWdata[$num+$f] = StringRegExpReplace($NEWdata[$num+$f],"<cr>",@CR)
		If $Endian = 0 Then
			$NewText = StringToBinary($NEWdata[$num+$f],2) & Binary("0x0000")
		Else
			$NewText = StringToBinary($NEWdata[$num+$f],3) & Binary("0x0000")
		EndIf
		$Size = int(BinaryLen($NewText)/2)
		$Tsize += $Size
		If $Endian = 0 Then
			$Newfile &= _BinaryReverse(Binary("0x" & Hex($Size,4))) & $NewText
		Else
			$Newfile &= Binary("0x" & Hex($Size,4)) & $NewText
		EndIf
	Next
	$num += $f-1
	$Newfile &= FileRead($File,4)
	If $Endian = 0 Then
		$Newfile = _BinaryPoke($Newfile,$Tsizeoff,$Tsize,"dword")
	Else
		$Newfile = _BinaryPoke($Newfile,$Tsizeoff,Binary("0x" & Hex($Tsize,8)),"dword")
	EndIf
	$Offset = BinaryLen($Newfile)
	$Offsetpos += 8
Next
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile)
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc