#Include <File.au3>
#Include <Binary.au3>
Global Const $HX_REF="0123456789ABCDEF"

$sScriptName = "Toy Soldiers Text Exporter"
$sLocbFilePath = FileOpenDialog("Select the file", @ScriptDir, "Toy Soldiers (*.locb)|All (*.*)",1)
Dim $sAllText, $sAllText2, $hLocbfile, $bLocbfile, $iNameLen, $iTextLen
$hLocbfile = FileOpen ($sLocbFilePath, 0+16)
$bLocbfile = FileRead ($hLocbfile)
FileClose ($hLocbfile)
$Pos = 0
$BaseOff = Dec (Hex (_BinaryReverse(Binarymid ($bLocbfile, 77, 3)), 4))
$Files = Dec (Hex (_BinaryReverse(Binarymid ($bLocbfile, 81, 3)), 4))
For $i = 1 To $Files
	  $IDOff1 = Dec (Hex (_BinaryReverse(Binarymid ($bLocbfile, $BaseOff+$Pos-3, 4)), 4))
	  $IDOff = Dec (Hex (_BinaryReverse(Binarymid ($bLocbfile, $IDOff1+1, 3)), 4))
	  $IDLen = Dec (Hex (_BinaryReverse(Binarymid ($bLocbfile, $IDOff1+5, 4)), 4))
	  $sAllText &= "[" & BinaryToString (Binarymid ($bLocbfile, $IDOff-3, $IDLen-1), 1) & "]" & @CRLF
	  $Offset = Dec (Hex (_BinaryReverse(Binarymid ($bLocbfile, $BaseOff+$Pos+1, 3)), 4))
	  $sAllText2 &= "[" & _HexToDecimal(Hex (_BinaryReverse(Binarymid ($bLocbfile, $BaseOff+$Pos+1, 4)), 4)) & "]" & @CRLF
	  $Len = Dec (Hex (_BinaryReverse(Binarymid ($bLocbfile, $BaseOff+$Pos+5, 4)), 4))
	  $sAllText2 &= "[" & $Len & "]" & @CRLF
	  $sAllText &= BinaryToString (Binarymid ($bLocbfile, $Offset-3, ($Len*2)-2), 2) & @CRLF
	  $sAllText2 &= BinaryToString (Binarymid ($bLocbfile, $Offset-3, ($Len*2)-2), 2) & @CRLF   
	  $Pos += 12
Next
sleep (50)
TrayTip ($sScriptName, "Finish!", 3)
$sAllTextFilePath = FileSaveDialog ("Save to file", @ScriptDir, "text files (*.txt)", 2+16, "ToySoldiersText.txt")
If $sAllTextFilePath = "" Then Exit
$hAllTextFil = FileOpen ($sAllTextFilePath, 2+32)
FileWrite ($hAllTextFil, $sAllText)
FileClose ($hAllTextFil)

$sAllTextFilePath2 = FileSaveDialog ("Save to file", @ScriptDir, "orig files (*.orig)", 2+16, "ToySoldiers.orig")
If $sAllTextFilePath2 = "" Then Exit
$hAllTextFil2 = FileOpen ($sAllTextFilePath2, 2+32)
FileWrite ($hAllTextFil2, $sAllText2)
FileClose ($hAllTextFil2)

Func _HexToDecimal($hx_hex)
    If StringLeft($hx_hex, 2) = "0x" Then $hx_hex = StringMid($hx_hex, 3)
    If StringIsXDigit($hx_hex) = 0 Then
        SetError(1)
        MsgBox(0,"Error","Wrong input, try again ...")
        Return ""
    EndIf
    Local $ret="", $hx_count=0, $hx_array = StringSplit($hx_hex, ""), $Ii, $hx_tmp
    For $Ii = $hx_array[0] To 1 Step -1
        $hx_tmp = StringInStr($HX_REF, $hx_array[$Ii]) - 1
        $ret += $hx_tmp * 16 ^ $hx_count
        $hx_count += 1
    Next
    Return $ret
EndFunc