#Include <File.au3>
#Include <binary.au3>
$Dir = FileSelectFolder("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Lang = InputBox("Language", "Type the language you want to export."&@CRLF&"en, fr, ...", "", " M2")
$Names = _FileListToArrayRec($Dir, "*_"&$Lang&".msd", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .msd files in the folder.")
	Exit
EndIf
$File = FileOpen("chars",32)
If $File = -1 Then
MsgBox(0,"Error","Can't open chars file.")
Exit
$Chars = FileRead($File)
FileClose($File)
$Charssz = StringLen($Chars)
$Name = CompGetFileName($Dir)
Dim $Text
For $i=1 to $Names[0]
	$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,4,0)
	$Files = FileRead($File,4)
	For $f = 1 to $Files
		$Size = _BinaryToInt32(FileRead($File,4))
		$Str = ""
		For $c = 1 to $Size
			$S = FileRead($File,2)
			$dS = _BinaryToInt16($S)+1
			If $S <> "0xFFFF" Then
				If $dS <= $Charssz Then
					If StringMid($Chars,$dS,1) <> "" Then
						$Str &= StringMid($Chars,$dS,1)
					Else
						$Str &= "{" & $S & "}"
					EndIf
				Else
					$Str &= "{" & $S & "}"
				EndIf
			EndIf
		Next
		$Text &= $Str & @CRLF
	Next
	FileClose($File)
Next
$hFile = FileOpen($Name&".txt", 2+32)
FileWrite($hFile,$Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc