#include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata, $Num = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$Dir = FileSelectFolder("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Lang = InputBox("Language", "Type the language you want to import."&@CRLF&"en, fr, ...", "", " M2")
$Names = _FileListToArrayRec($Dir, "*_"&$Lang&".msd", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .msd files in the folder.")
	Exit
EndIf
$File = FileOpen("chars",32)
If $File = -1 Then
MsgBox(0,"Error","Can't open chars file.")
Exit
EndIf
$Chars = FileRead($File)
FileClose($File)
For $i=1 to $Names[0]
	$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
	$Newfile = FileRead($File,4)
	$Files = FileRead($File,4)
	$Newfile &= $Files
	For $f = 1 to $Files
		FileRead($File,_BinaryToInt32(FileRead($File,4)*2))
		$Size = StringLen($NEWdata[$Num])
		$Newtext = Binary("0x00")
		For $c = 1 to $Size
			$S = StringMid($NEWdata[$Num],$c,1)
			If $S = "{" And StringMid($NEWdata[$Num],$c+1,2) = "0x" Then
				$Newtext &= Binary(StringMid($NEWdata[$Num],$c+1,6))
				$c += 7
			Else
				$Pos = StringInStr($Chars,$S,1)
				If $Pos > 0 Then
					$Newtext &= _BinaryFromInt16($Pos-1)
				Else
					$Newtext &= StringToBinary($S,2)
				EndIf
			EndIf
		Next
		If $Size = 0 Then
			$Newtext = Binary("0xFFFF")
		Else
			$Newtext = BinaryMid($Newtext,2) & Binary("0xFFFF")
		EndIf
		$Num += 1
		$Newfile &= _BinaryFromInt32(Int(BinaryLen($Newtext)/2)) & $NewText
	Next
	FileClose($File)
	$hNewfile = FileOpen($Dir &"\"& $Names[$i], 2+16)
	FileWrite($hNewfile, $Newfile)
	FileClose($hNewfile)
	FileClose($File)
Next
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc