#Include <File.au3>
#include <ArrayNaturalSort.au3>
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.DisConv_Blurb", 1,1)
If $Names = "" Then
	MsgBox(0,"No files","There are no DisConv_Blurb files in the folder.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
Dim $Text
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,110,0)
	$Id = _BinaryToInt32(FileRead($File,4))
;~ 	MsgBox("","",$Id)
	If $Id < 2000 Then
		FileSetPos($File,171,0)
	Else
		FileSetPos($File,146,0)
	EndIf
;~ 	MsgBox("","",FileGetPos($File))
	$FirstSize = FileRead($File,4)
	If $FirstSize <> "0x04000000" Then
	FileRead($File,4)
		$Len = _BinaryToInt32(FileRead($File,4))
		If $Len < 0 Then
			$Len = -$Len*2
			$Str = BinaryToString(FileRead($File,$Len),2)
			$Str = StringTrimRight($Str,1)
		Else
			$Str = BinaryToString(FileRead($File,$Len))
			$Str = StringTrimRight($Str,1)
		EndIf
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
	EndIf
	FileClose($File)
Next
$hAllTextFil = FileOpen (CompGetFileName($Dir)&".txt", 2)
FileWrite ($hAllTextFil, $Text)
FileClose ($hAllTextFil)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func _BinaryToInt32($Binary)
	Return BitAND(Int(Binary($Binary)), 0xFFFFFFFF)
EndFunc