#include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3>
Dim $NEWdata, $Num = 0
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = StringTrimRight($TxtPath,4)
$Names = _FileListToArrayRec($Dir, "*.DisConv_Blurb", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .DisConv_Blurb files in the "&@cr&CompGetFileName($Dir)&" folder, or the folder not exist.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	$bFile = FileRead($File)
	FileSetPos($File,110,0)
	$Id = _BinaryToInt32(FileRead($File,4))
	If $Id < 2000 Then
		FileSetPos($File,171,0)
	Else
		FileSetPos($File,146,0)
	EndIf
	$BlockSize = FileRead($File,4)
	If $BlockSize <> "0x04000000" Then
	$OldBlock = $BlockSize & FileRead($File,_BinaryToInt32($BlockSize)+4)
		$Str = $NEWdata[$i]
		$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
		$Str = StringRegExpReplace($Str,"<lf>",@LF)
		$Str = StringRegExpReplace($Str,"<cr>",@CR)
		If $Str = "" Then
			$NewText = ""
		Else
			$NewText = StringToBinary($Str,2) & Binary("0x0000")
		EndIf
		$NewLen = BinaryLen($NewText)
		$NewBlock = _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex(-int($NewLen/2),8))) & $NewText
	If $NewBlock <> $OldBlock Then
		$bFile = _BinaryReplace($bFile, $OldBlock, $NewBlock, 1)
		$hNewfile = FileOpen ($Dir &"\"& $Names[$i], 2+16)
		FileWrite ($hNewfile, $bFile)
		FileClose ($hNewfile)
	EndIf
EndIf
FileClose ($File)
Next
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc