#include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3>
Dim $NEWdata, $Num = 0
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = StringTrimRight($TxtPath,4)
$Names = _FileListToArrayRec($Dir, "*.SoundNodeWave", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .SoundNodeWave files in the "&@cr&CompGetFileName($Dir)&" folder, or the folder not exist.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	$bFile = FileRead($File)
	FileSetPos($File,207,0)
	$BlockSize = FileRead($File,4)
	If $BlockSize <> "0x04000000" Then
	FileSetPos($File,231+_BinaryToInt32($BlockSize),0)
	$BlockSize = FileRead($File,4)
	$Old1 = FileRead($File, 52)
	$StringBlock = FileRead($File,4)
	$Old2 = FileRead($File, 4)
	$BlockPos = FileGetPos($File)
	$StrNum = FileRead($File, 4)
	$NewBlock = $StrNum & FileRead($File,16)
	FileRead($File,8)
	$BlockPlus = 28
	For $n = 1 to $StrNum
		$Str = $NEWdata[$Num+$i]
		$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
		$Str = StringRegExpReplace($Str,"<lf>",@LF)
		$Str = StringRegExpReplace($Str,"<cr>",@CR)
		$OldStrLen = _BinaryToInt32(FileRead($File, 4))
		If $OldStrLen = 0 Then
			$NewBlock &= _BinaryReverse(Binary("0x" & Hex(4,8))) & Binary("0x" & Hex(0,16))
			$BlockPlus += 4
		Else
		If $OldStrLen < 0 Then
			$OldLen = -_BinaryToInt32($OldStrLen)*2
			$NewText = StringToBinary($Str,2) & Binary("0x0000")
			$NewLen = BinaryLen($NewText)
			$NewBlock &= _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex(-int($NewLen/2),8))) & $NewText
			FileRead($File,$OldLen)
			$BlockPlus += 4+$OldLen
		Else
			$OldLen = _BinaryToInt32($OldStrLen)
			$NewText = StringToBinary($Str) & Binary("0x00")
			$NewLen = BinaryLen($NewText)
			$NewBlock &= _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex($NewLen,8))) & $NewText
			FileRead($File,$OldLen)
			$BlockPlus += 4+$OldLen
		EndIf
		EndIf
		If $StrNum > 1 And $n < $StrNum Then
			$NewBlock &= FileRead($File,52)
			FileRead($File,8)
			$BlockPlus += 60
		EndIf
		$Num += 1
	Next
	$Num -= 1
	FileSetPos($File,$BlockPos,0)
	$OldBlock = FileRead($File,$StringBlock)
	$NewBlock &= BinaryMid($OldBlock,$BlockPlus+1)
	If $NewBlock <> $OldBlock Then
		$Dif = BinaryLen($NewBlock) - _BinaryToInt32($StringBlock)
		$OldBlock = $BlockSize & $Old1 & $StringBlock & $Old2 & $OldBlock
		$NewBlock = _BinaryReverse(Binary("0x" & Hex(_BinaryToInt32($BlockSize)+$Dif,8))) & $Old1 & _BinaryReverse(Binary("0x" & Hex(_BinaryToInt32($StringBlock)+$Dif,8))) & $Old2 & $NewBlock
		$Asize = FileGetSize($Dir &"\"& $Names[$i]) - 68
		FileSetPos($File,$Asize,0)
		$End1 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileRead($File, 12)
		$End2 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileRead($File, 12)
		$End3 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileRead($File, 12)
		$End4 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileRead($File, 12)
		$End5 = _BinaryToInt32(FileRead($File, 4))+$Dif
		$bFile = _BinaryPoke($bFile, $Asize+1, $End1, "dword")
		$bFile = _BinaryPoke($bFile, $Asize+17, $End2, "dword")
		$bFile = _BinaryPoke($bFile, $Asize+33, $End3, "dword")
		$bFile = _BinaryPoke($bFile, $Asize+49, $End4, "dword")
		$bFile = _BinaryPoke($bFile, $Asize+65, $End5, "dword")
		$bFile = _BinaryReplace($bFile, $OldBlock, $NewBlock, 1)
		$hNewfile = FileOpen ($Dir &"\"& $Names[$i], 2+16)
		FileWrite ($hNewfile, $bFile)
		FileClose ($hNewfile)
	EndIf
Else
	$Num -= 1
EndIf
FileClose ($File)
Next
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc