#include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
#include <ArrayNaturalSort.au3> ;NaturalCompare, https://www.autoitscript.com/forum/topic/83626-natural-order-string-comparison/
Dim $NEWdata, $k = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = StringTrimRight($TxtPath,4)
$Names = _FileListToArrayRec($Dir, "*.SoundNodeWave", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .SoundNodeWave files in the "&@cr&CompGetFileName($Dir)&" folder, or the folder not exist.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	$skip = 0
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	$Asize = FileGetSize($Dir &"\"& $Names[$i])
	FileSetPos($File,132,0)
	$FirstSize = FileRead($File,4)
	If $FirstSize <> 1294 Then
		$Dif = 0
		If $FirstSize <> "0x04000000" Then
			FileSetPos($File,132+24+_BinaryToInt32($FirstSize),0)
			$Val = _BinaryToInt32(FileRead($File,4))
			FileSetPos($File,132+60+_BinaryToInt32($FirstSize),0)
			$Num = FileRead($File,4)
			FileSetPos($File,132+80+_BinaryToInt32($FirstSize),0)
			$Dif = 0
			FileSetPos($File,0,0)
			$Newfile = FileRead($File,132+80+_BinaryToInt32($FirstSize))
			For $n = 1 to $Num
				FileRead($File,8)
				$Str = $NEWdata[$k]
				$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
				$Str = StringRegExpReplace($Str,"<lf>",@LF)
				$Str = StringRegExpReplace($Str,"<cr>",@CR)
				$Len = _BinaryToInt32(FileRead($File,4))
				If $Len = 0 Then
					$Newfile &= _BinaryReverse(Binary("0x" & Hex(4,8))) & Binary("0x" & Hex(0,16))
				Else
					If $Len < 0 Then
						$Len = -$Len*2
						FileRead($File,$Len)
						$NewText = StringToBinary($Str,2) & Binary("0x0000")
						$NewLen = BinaryLen($NewText)
						$Dif += $NewLen - $Len
						$Newfile &= _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex(-int($NewLen/2),8))) & $NewText
					Else
						FileRead($File,$Len)
						$NewText = StringToBinary($Str) & Binary("0x00")
						$NewLen = BinaryLen($NewText)
						$Dif += $NewLen - $Len
						$Newfile &= _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex($NewLen,8))) & $NewText
					EndIf
				EndIf
				$Newfile &= FileRead($File,52)
				$k += 1
			Next
		EndIf
		$Newfile &= FileRead($File)
		FileSetPos($File,$Asize-4,0)
		$End1 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileSetPos($File,$Asize-20,0)
		$End2 = _BinaryToInt32(FileRead($File, 4))+$Dif
		$Asize = BinaryLen($Newfile)
		$Newfile = _BinaryPoke($Newfile, $Asize-3, $End1, "dword")
		$Newfile = _BinaryPoke($Newfile, $Asize-19, $End2, "dword")
		$Newfile = _BinaryPoke($Newfile, 132+25+_BinaryToInt32($FirstSize), $Val+$Dif, "dword")
		$hNewfile = FileOpen($Dir &"\"& $Names[$i], 2+16)
		FileWrite($hNewfile, $Newfile)
		FileClose($hNewfile)
	EndIf
	FileClose($File)
Next
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc