#Include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
#include <ArrayNaturalSort.au3> ;NaturalCompare, https://www.autoitscript.com/forum/topic/83626-natural-order-string-comparison/
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.SoundNodeWave", 1,1)
If $Names = "" Then
	MsgBox(0,"No files","There are no SoundNodeWave files in the folder.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
Dim $Text, $Skiplist
For $i=1 to $Names[0]
	$skip = 0
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,4,0)
	$Id = _BinaryToInt32(FileRead($File,4))
	If ($Id > 1 And $Id < 49) Or $Id = 126 Then
		$pos = 132
	ElseIf $Id = 87 Or $Id = 96 Or $Id = 82 Or $Id = 165 Or $Id = 189 Then
		FileSetPos($File,60,0)
		$Size = _BinaryToInt32(FileRead($File,4))
		If $Size = 4 Then
			$pos = 172
		Else
			$pos = $Size + 196
		EndIf
	ElseIf $Id = 68 Or $Id = 91 Or $Id = 136 Or $Id = 160 Then
		FileSetPos($File,20,0)
		$Size = _BinaryToInt32(FileRead($File,4))
		If $Size = 4 Then
			$pos = 132
		Else
			$pos = $Size + 156
		EndIf
	ElseIf $Id = 1 Then
		$skip = 1
	EndIf
	If $skip <> 1 Then
		FileSetPos($File,$pos,0)
		$FirstSize = FileRead($File,4)
		$Str = ""
		If $FirstSize <> "0x04000000" Then
			FileSetPos($File,$pos+60+_BinaryToInt32($FirstSize),0)
			$Num = FileRead($File,4)
			FileSetPos($File,$pos+88+_BinaryToInt32($FirstSize),0)
			For $n = 1 to $Num
				$Len = _BinaryToInt32(FileRead($File,4))
				If $Len < 0 Then
					$Len = -$Len*2
					$Str = BinaryToString(FileRead($File,$Len),2)
					$Str = StringTrimRight($Str,1)
				Else
					$Str = BinaryToString(FileRead($File,$Len))
					$Str = StringTrimRight($Str,1)
				EndIf
				FileRead($File,60)
				$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
				$Str = StringRegExpReplace($Str,@LF,"<lf>")
				$Str = StringRegExpReplace($Str,@CR,"<cr>")
				$Text &= $Str & @CRLF
			Next
		EndIf
	Else
		$Skiplist &= $Names[$i] & @CRLF
	EndIf
	FileClose($File)
Next
$hFile = FileOpen (CompGetFileName($Dir)&".txt", 2)
FileWrite($hFile, $Text)
FileClose($hFile)
If $Skiplist <> "" Then
	$hFile = FileOpen ("ignoredfiles.txt", 2)
	FileWrite($hFile, $Skiplist)
	FileClose($hFile)
EndIf
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
