#include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
$Newfile = FileRead($File,4)
$Files = FileRead($File,4)
$Newfile &= $Files
For $i = 1 to $Files
	$Newfile &= FileRead($File,8)
	$Size = _BinaryToInt32(FileRead($File,1))
	If $Size >= 128 Then
		$Size += (_BinaryToInt32(FileRead($File,1))-1)*128
	EndIf
	FileRead($File,$Size)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$NewText = StringToBinary($NEWdata[$i],4)
	$Size = BinaryLen($NewText)
	If $Size >= 128 Then
		$Div = Int($Size/128)
		$Newfile &= Binary("0x" & Hex($Size-(128*($Div-1)),2)) & Binary("0x" & Hex($Div,2)) & $NewText
	Else
		$Newfile &= Binary("0x" & Hex($Size,2)) & $NewText
	EndIf
Next
$Asize = BinaryLen($Newfile)-4
$Newfile = _BinaryPoke($Newfile,1,$Asize,"dword")
$Pad = 4 - Mod($Asize,4)
If $Pad > 0 And $Pad < 4 Then
	$Newfile &= Binary("0x" & Hex(0,$Pad*2)) & Binary("0x00000000")
Else
	$Newfile &= Binary("0x00000000")
EndIf
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile)
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc