#include <Binary.au3>
#include <file.au3>
#include <winapi.au3>
#include <ArrayNaturalSort.au3>
$AssetsPath = FileOpenDialog("Select the CustomAssetBundle file", @ScriptDir, "cab files (CustomAssetBundle*)",1)
If @error = 1 Then Exit
$Names = _FileListToArray("unpacked", "*", 1)
_ArrayNaturalSort($Names,0,1)
$ID = Binary("0x55496e743332007365636f6e64")
$Pos = _HexSearch($AssetsPath, $ID) +42
$AssetsFile = FileOpen($AssetsPath, 16)
$NewAssetsFile = FileRead($AssetsFile)
FileSetPos($AssetsFile,12,0)
$Baseoff = Dec(Hex(FileRead($AssetsFile,4)))
FileSetPos($AssetsFile,$Pos,0)
$Files = _BinaryToInt32(FileRead($AssetsFile,4))
FileSetPos($AssetsFile,0,0)
$NewfileHead = FileRead($AssetsFile,$Baseoff)
$Offset = 0
$Data = Binary("0x00")
For $i = 1 to $Names[0]
	$NewSize = FileGetSize("unpacked\"&$Names[$i])
	$hNewfile = FileOpen ("unpacked\"&$Names[$i], 0+16)
	If CompGetFileExt($Names[$i]) = ".xml" Then
		$v = 0
		Do
			$v += 1
		Until StringMid($Names[$i],$v,1) = "_"
		$Name = StringTrimRight(StringMid($Names[$i],$v+1),4)
		$Name = StringToBinary($Name)
		$Namelen = BinaryLen($Name)
		$Pad = 4-Mod($Namelen,4)
		If $Pad < 4 Then
			$Name &= Binary("0x"&Hex(0,$Pad*2))
		EndIf
		$Pad = 4-Mod($NewSize,4)
		If $Pad < 4 Then
			$Pad = _BinaryRandom($Pad+4,0,0)
		Else
			$Pad = Binary("0x"&Hex(0,8))
		EndIf
		$Newfile = _BinaryReverse(Binary("0x"&Hex($Namelen,8))) & $Name & _BinaryReverse(Binary("0x"&Hex($NewSize,8))) & FileRead($hNewfile) & $Pad
		$NewSize = BinaryLen($Newfile)
		$Pad = 8-Mod($NewSize,8)
		If $Pad < 8 And $i <> $Names[0] Then
			$Data &= $Newfile & Binary("0x"&Hex(0,8))
		Else
			$Data &= $Newfile
		EndIf
	Else
		$Pad = 8-Mod($NewSize,8)
		If $Pad < 8 And $i <> $Names[0] Then
			$Data &= FileRead($hNewfile) & Binary("0x"&Hex(0,8))
		Else
			$Data &= FileRead($hNewfile)
		EndIf
	EndIf
	$NewfileHead = _BinaryPoke($NewfileHead,$Pos+9,$Offset,"dword")
	$NewfileHead = _BinaryPoke($NewfileHead,$Pos+13,$NewSize,"dword")
	If $Pad < 8 Then
		$Offset += $NewSize + 4
	Else
		$Offset += $NewSize
	EndIf
	$Pos += 20
	FileClose($hNewfile)
Next
$NewfileHead = _BinaryPoke($NewfileHead,5,Binary("0x"&Hex(BinaryLen($NewfileHead)+BinaryLen($Data)-1,8)),"dword")
$hAssetsfile =FileOpen (CompGetFileName($AssetsPath), 2+16)
FileWrite ($hAssetsfile, $NewfileHead & BinaryMid($Data,2))
FileClose ($hAssetsfile)
TrayTip ("Inserter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func CompGetFileExt($Path,$Dot=True)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        $ret = StringSplit($ret[UBound($ret)-1],".",2)
        If IsArray($ret) Then
            If $Dot Then
                $Dot = "."
            Else
                $Dot = ""
            EndIf
            Return $Dot & $ret[UBound($ret)-1]
        EndIf
    EndIf
    If @error Then Return -1
EndFunc
Func _HexSearch($FilePath, $BinaryValue, $StartOffset = Default)
        Local $Buffer, $ptr, $hFile, $Result, $Read, $SearchValue, $Pos, $BufferSize = 2048
            If $StartOffset = Default       Then    $StartOffset = 0
            If Not FileExists($FilePath)    Then    Return SetError(1, @error, 0)
            $fLen = FileGetSize($FilePath)
            If $StartOffset > $fLen         Then    Return SetError(2, @error, 0)
            If Not IsBinary($BinaryValue)   Then    Return SetError(3, @error, 0)
            If Not IsNumber($StartOffset)   Then    Return SetError(4, @error, 0)
            $SearchValue = BinaryToString($BinaryValue)
            $Buffer = DllStructCreate("byte[" & $BufferSize & "]")
            $ptr = DllStructGetPtr($Buffer)
                $hFile = _WinAPI_CreateFile($FilePath, 2, 2, 1)
                If $hFile = 0 Then Return SetError(5, @error, 0)
            $Result = _WinAPI_SetFilePointer($hFile, $StartOffset)
            $err = @error
            If $Result = 0xFFFFFFFF Then
                _WinAPI_CloseHandle($hFile)
                Return SetError(5, $err, 0)
            EndIf
            $Pos = $StartOffset
            While True
                    $Read = 0
                    $Result = _WinAPI_ReadFile($hFile, $ptr, $BufferSize, $Read)
                    $err = @error
                    If Not $Result Then
                        _WinAPI_CloseHandle($hFile)
                        Return SetError(6, $err, 0)
                    EndIf
                    $Result = DllStructGetData($Buffer, 1)
                    $Result = BinaryToString($Result)
                    $Result = StringInStr($Result, $SearchValue)
                    If $Result > 0 Then ExitLoop
                    If $Read < $BufferSize Then
                        _WinAPI_CloseHandle($hFile)
                        Return -1
                    EndIf
                    $Pos += $Read
            WEnd
            _WinAPI_CloseHandle($hFile)
            If Not $Result Then Return SetError(7, @error, 0)
            $Result = $Pos + $Result - 1
            Return $Result
		EndFunc