#Include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata,$Num = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = FileSelectFolder ( "Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArray($Dir, "*.atf", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no atf files in the folder.")
	Exit
EndIf
$File = FileOpen ($Dir &"\"& $Names[1], 0+16)
$Id = FileRead($File,3)
FileClose($File)
If $Id = "ATF" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,4,0)
	If $Endian = 0 Then
		$Files = _BinaryToInt32(FileRead ($File, 4))
	Else
		$Files = Dec(Hex(FileRead($File, 4)))
	EndIf
	FileSetPos($File,32,0)
	If $Endian = 0 Then
		$DataPos = _BinaryToInt32(FileRead ($File, 4))
	Else
		$DataPos = Dec(Hex(FileRead($File, 4)))
	EndIf
	FileSetPos($File,64,0)
	If $Endian = 0 Then
		$TextPos = _BinaryToInt32(FileRead ($File, 4))
	Else
		$TextPos = Dec(Hex(FileRead($File, 4)))
	EndIf
	FileSetPos($File,0,0)
	$Newfile = FileRead($File,$TextPos)
	$Newfiletext = Binary("0x00")
	$Offset = 0
	for $n = 1 to $Files
		$Str = $NEWdata[$Num]
		$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
		$Str = StringRegExpReplace($Str,"<lf>",@LF)
		$Str = StringRegExpReplace($Str,"<cr>",@CR)
		If $Endian = 0 Then
			$Newtext = StringToBinary($Str,2) & Binary("0x0000")
		Else
			$Newtext = StringToBinary($Str,3) & Binary("0x0000")
		EndIf
		$Size = int(BinaryLen($Newtext)/2)
		If $Endian = 0 Then
			$Newfile = _BinaryPoke($Newfile,$DataPos+21,$Size-1,"dword")
			$Newfile = _BinaryPoke($Newfile,$DataPos+17,$Offset,"dword")
		Else
			$Newfile = _BinaryPoke($Newfile,$DataPos+21,Binary("0x"&Hex($Size-1,8)),"dword")
			$Newfile = _BinaryPoke($Newfile,$DataPos+17,Binary("0x"&Hex($Offset,8)),"dword")
		EndIf
		$Offset += $Size
		$DataPos += 32
		$Newfiletext &= $Newtext
		$Num += 1
	Next
	$Newfiletext = BinaryMid($Newfiletext,2)
	If $Endian = 0 Then
		$Newfile = _BinaryPoke($Newfile,73,BinaryLen($Newfiletext),"dword")
	Else
		$Newfile = _BinaryPoke($Newfile,73,Binary("0x"&Hex(BinaryLen($Newfiletext),8)),"dword")
	EndIf
	$hNewfile = FileOpen ($Dir &"\"& $Names[$i], 2+16)
	FileWrite($hNewfile,$Newfile&$Newfiletext)
	FileClose($hNewfile)
	FileClose($File)
Next
TrayTip("Importer", "Finish!", 3)
sleep(3000)