#include <Binary.au3>
$sAllTextFilePath = FileOpenDialog("Select the TXT file...", @ScriptDir, "Text files (*.txt)|All (*.*)", 1)
If $sAllTextFilePath = "" Then
   Exit
EndIf
$hAllTextFile = FileOpen ($sAllTextFilePath, 0)
$sAllText = FileRead($hAllTextFile)
FileClose ($hAllTextFile)
$a=StringRegExp($sAllText&'[', '(?s)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n=UBound($a)
Dim $aAllText[Int($n/2)]
For $i = 0 to $n-1 Step 2
    $aAllText[$i/2]=$a[$i+1]
Next
$sLocbFilePath = FileOpenDialog("Select the CLU file", @ScriptDir, "clu files (*.clu)|All (*.*)",1)
If @error = 1 Then Exit
Dim $sAllText, $Str
$hLocbfile = FileOpen ($sLocbFilePath, 0+16)
$bLocbfile = FileRead ($hLocbfile)
FileClose ($hLocbfile)
$Table = _BinaryToInt32(Binarymid ($bLocbfile, 1, 4))
$Size = FileGetSize($sLocbFilePath)
$TextResNum = int(($Size - $Table)/8)
Dim $TableSizes[$TextResNum][2], $NewFile = Binary ("0x" & Hex (0, 8)), $Num = 0, $Allsize = 8, $plus = Binary ("0x" & Hex (0, 4))
$NewFile = StringRegExpReplace($NewFile,"0x","")
For $i = 0 to $TextResNum-1
$Troff = _BinaryToInt32(Binarymid ($bLocbfile, $Table+1, 4))
$Files = _BinaryToInt32(Binarymid ($bLocbfile, $Troff+33, 4))
$Offset = $Files*4+$Files*2+36
$TextResSize = $Offset
$TextRes = Binarymid($bLocbfile,$Troff+1,$Offset)
$Pos = 0
   For $k = 0 to $Files-1
	  $bNewText = StringToBinary ($aAllText[$k+$Num],2) & $plus
	  $NewLen = Dec(Hex (BinaryLen ($bNewText), 8))
	  $bNewOff = _BinaryReverse(Binary ("0x" & Hex (Int($Offset/2), 8)))
	  $Offset += $NewLen
	  $TextRes = _BinaryPoke($TextRes, 37+$Pos, $bNewOff, "dword")
	  $TextRes &= $bNewText
	  $Pos += 4
	  $TextResSize += $NewLen
   Next
$TextRes = "0x" & StringRegExpReplace($TextRes,"0x","")
	$NewTlen = BinaryLen($TextRes)
	$TextRes = StringTrimLeft($TextRes,2)
	$Pad = 4-Mod($NewTlen,4)
	If $Pad < 4 and $pad <> 0 Then
		$TextRes &= "0000"
		$TextResSize += 2
		$TableSizes[$i][1] = 1
	EndIf
$TableSizes[$i][0] = $TextResSize
$NewFile &= $TextRes
$Num += $Files
$Allsize += $TextResSize
$Table += 8
Next
$OffTable = _BinaryReverse(Binary ("0x" & Hex ($Allsize, 8)))
$Offset = 8
For $i = 0 to $TextResNum-1
$bNewOff = _BinaryReverse(Binary ("0x" & Hex ($Offset, 8)))
$Offset += int($TableSizes[$i][0])
if $TableSizes[$i][1] <> 1 Then
$bNewSize = _BinaryReverse(Binary ("0x" & Hex ($TableSizes[$i][0], 8)))
Else
	$bNewSize = _BinaryReverse(Binary ("0x" & Hex ($TableSizes[$i][0]-2, 8)))
	EndIf
$OffTable &= $bNewOff & $bNewSize
Next
$OffTable = StringRegExpReplace($OffTable,"0x","")
$bOffTablePos = _BinaryReverse(Binary ("0x" & Hex ($Allsize+4, 8)))
$NewFile = $bOffTablePos & $NewFile & $OffTable
TrayTip ("Text import", "Finish!", 3)
sleep (2000)
   $hFile = FileOpen ("NEW_Text.clu", 2+16)
   FileWrite ($hFile, $NewFile)
   FileClose ($hFile)