#include<Binary.au3>
$Path = FileOpenDialog("Select the BIN file", @ScriptDir, "bin files (*.bin)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
$Files = _BinaryToInt32(FileRead($File,4))
If $Files > 10000000 Or $Files < 0 Then
	FileSetPos($File,0,0)
	$Files = Dec(Hex(FileRead($File,4)))
	$Endian = 0
Else
	$Endian = 1
EndIf
for $i = 1 to $Files
	$Text = ""
	If $Endian = 0 Then
		$Namesize = Dec(Hex(FileRead($File,4)))*-2
	Else
		$Namesize = _BinaryToInt32(FileRead($File,4))*-2
	EndIf
	$pos = FileGetPos($File)
	$p = -1
	Do
		$p += 1
		$S = BinaryToString(FileRead($File,2),2)
	Until $S <> "\" And $S <> "."
	FileSetPos($File,$pos,0)
	$Name = StringTrimRight(StringTrimLeft(BinaryToString(FileRead ($File, $Namesize),2),$p),1)
	If $Endian = 0 Then
		$Num1 = Dec(Hex(FileRead($File,4)))
	Else
		$Num1 = _BinaryToInt32(FileRead($File,4))
	EndIf
	For $n = 1 to $Num1
		If $Endian = 0 Then
			$Size = Dec(Hex(FileRead($File,4)))*-2
		Else
			$Size = _BinaryToInt32(FileRead($File,4))*-2
		EndIf
		$Str = StringTrimRight(BinaryToString(FileRead ($File, $Size),2),1)
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
		If $Endian = 0 Then
			$Num2 = Dec(Hex(FileRead($File,4)))*2
		Else
			$Num2 = _BinaryToInt32(FileRead($File,4))*2
		EndIf
		For $k = 1 to $Num2
			If $Endian = 0 Then
				$Size = Dec(Hex(FileRead($File,4)))*-2
			Else
				$Size = _BinaryToInt32(FileRead($File,4))*-2
			EndIf
			$Str = StringTrimRight(BinaryToString(FileRead ($File, $Size),2),1)
			$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
			$Str = StringRegExpReplace($Str,@LF,"<lf>")
			$Str = StringRegExpReplace($Str,@CR,"<cr>")
			$Text &= $Str & @CRLF
		Next
	Next
	$hFile = FileOpen("unpacked\"&$Name, 2+8+32)
	FileWrite($hFile, $Text)
	FileClose($hFile)
Next
TrayTip ("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc