#include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3>
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.Ms01DataMessage", 1,1)
If $Names = "" Then
	MsgBox(0,"No files","There are no Ms01DataMessage files in the folder.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
Dim $Text, $I1 = Binary("0x210000000000000003000000"), $I2 = Binary("0x1F0000000000000003000000")
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	$bFile = FileRead($File)
	$Pos = _BinaryInBin($bFile, $I1, 1, 1)
	If $Pos = 0 Then $Pos = _BinaryInBin($bFile, $I2, 1, 1)
	If $Pos <> 0 Then
		Do
			FileSetPos($File,$Pos+23,0)
			$Num = FileRead($File,4)
			For $n = 1 to $Num
				$Len = _BinaryToInt32(FileRead($File,4))
				If $Len < 0 Then
					$Len = -$Len*2
					$Str = BinaryToString(FileRead($File,$Len),2)
					$Str = StringTrimRight($Str,1)
				Else
					$Str = BinaryToString(FileRead($File,$Len))
					$Str = StringTrimRight($Str,1)
				EndIf
				$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
				$Str = StringRegExpReplace($Str,@LF,"<lf>")
				$Str = StringRegExpReplace($Str,@CR,"<cr>")
				$Text &= $Str & @CRLF
			Next
			$Pos = FileGetPos($File)+1
			FileRead($File,8)
		Until FileRead($File,1) <> "0x03"
	EndIf
	FileClose($File)
Next
$hFile = FileOpen(CompGetFileName($Dir)&".txt", 2+32)
FileWrite($hFile, $Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc