#include<Binary.au3>
#include<File.au3>
#include<MultidimensionalSearch.au3> ;https://www.autoitscript.com/forum/topic/57360-recursive-multidimensional-array-search/
If Not FileExists("PossibleFilenames.csv") Then
	MsgBox(16, "Error", "Can't find PossibleFilenames.csv")
	Exit
EndIf
$BdtPath = FileOpenDialog("Select the BDT file", @ScriptDir,"bdt files (*.bdt)",1)
If @error = 1 Then Exit
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.fmg",1,1)
_ArrayColInsert($Names,1)
Dim $Filenames
_FileReadToArray("PossibleFilenames.csv",$Filenames,1,@TAB)
For $i=1 to $Names[0][0]
	$Val = _SearchMultiDimensional($Filenames,StringReplace($Names[$i][0],"\","/"),False, True)
	If $Val <> "" Then
		$Names[$i][1] = $Filenames[$Val][0]
	EndIf
Next
$BhdFile = Fileopen(StringTrimRight(CompGetFileName($BdtPath),3)&"bhd",1+16)
FileSetPos($BhdFile,16,0)
$Tables = FileRead($BhdFile,4)
FileSetPos($BhdFile,FileRead($BhdFile,4),0)
Dim $Hashes[1], $Offsets[1]
For $i = 1 to $Tables
	$Files = FileRead($BhdFile,4)
	$Offset = FileRead($BhdFile,4)
	$pos = FileGetPos($BhdFile)
	FileSetPos($BhdFile,$Offset,0)
	For $f = 1 to $Files
		_ArrayAdd($Hashes,_BinaryToInt64(FileRead($BhdFile,4)))
		_ArrayAdd($Offsets,FileGetPos($BhdFile))
		FileRead($BhdFile,28)
	Next
	FileSetPos($BhdFile,$pos,0)
Next
$BdtFile = Fileopen($BdtPath,1+16)
$Baseoff = FileGetSize($BdtPath)
For $i=1 to $Names[0][0]
	$Val = _ArraySearch($Hashes,$Names[$i][1])
	If @error = 0 Then
		$File = FileOpen($Dir &"\"& $Names[$i][0], 0+16)
		$Size = FileGetSize($Dir&"\"&$Names[$i][0])
		FileSetPos($BdtFile,$Baseoff,0)
		FileWrite($BdtFile,FileRead($File))
		FileSetPos($BhdFile,$Offsets[$Val],0)
		FileWrite($BhdFile,_BinaryReverse(Binary("0x" & Hex($Size,8))))
		FileSetPos($BhdFile,$Offsets[$Val]+4,0)
		FileWrite($BhdFile,_BinaryReverse(Binary("0x" & Hex($Baseoff,16))))
		$Baseoff += $Size
	EndIf
Next
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc