#include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata, $Num = 0, $plus = Binary ("0x" & Hex (0, 4))
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.fmg", 1,1)
$File = FileOpen ($Dir &"\"& $Names[1], 0+16)
$Id = FileRead($File,2)
FileClose($File)
If $Id = 0 Then
	$Endian = 0
Else
	$Endian = 1
EndIf
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,8,0)
	If $Endian = 0 Then
		$One = FileRead($File, 4)
	Else
		$One = Dec(Hex(FileRead($File, 4)))
	EndIf
	If $One = 1 Then
		FileSetPos($File,16,0)
		If $Endian = 0 Then
			$Files = _BinaryToInt32(FileRead($File, 4))
		Else
			$Files = Dec(Hex(FileRead($File, 4)))
		EndIf
		FileRead($File, 4)
		If $Endian = 0 Then
			$OffTable = _BinaryToInt32(FileRead($File, 4))
		Else
			$OffTable = Dec(Hex(FileRead($File, 4)))
		EndIf
		$BaseOffset = $OffTable + $Files * 8
		FileSetPos($File,0,0)
		$NewfileHead = FileRead($File,$BaseOffset)
		$NewfileText = Binary("0x00")
		FileSetPos($File,$OffTable,0)
		$f = 1
		For $n = 1 to $Files
			$Offset = _BinaryReverse(FileRead($File, 4))
			FileRead($File, 4)
			If $Offset <> 0 Then
				$NEWdata[$f+$Num] = StringRegExpReplace($NEWdata[$f+$Num],"<cf>",@CRLF)
				$NEWdata[$f+$Num] = StringRegExpReplace($NEWdata[$f+$Num],"<lf>",@LF)
				$NEWdata[$f+$Num] = StringRegExpReplace($NEWdata[$f+$Num],"<cr>",@CR)
				If $Endian = 0 Then
					$NewText = StringToBinary($NEWdata[$f+$Num],2) & $plus
				Else
					$NewText = StringToBinary($NEWdata[$f+$Num],3) & $plus
				EndIf
				$Size = BinaryLen($NewText)
				$NewfileText &= $NewText
				$Pos = FileGetPos($File)-4
				If $Endian = 0 Then
					$NewfileHead = _BinaryPoke($NewfileHead, $Pos-3, $BaseOffset, "dword")
				Else
					$NewfileHead = _BinaryPoke($NewfileHead, $Pos-3, Binary("0x" & Hex($BaseOffset,8)), "dword")
				EndIf
				$BaseOffset += $Size
				$f += 1
			EndIf
		Next
		$Newfile = $NewfileHead&BinaryMid($NewfileText,2)
		$Pad = 16-Mod(BinaryLen($Newfile),16)
		If $Pad < 16 Then
			$Newfile &= _BinaryRandom($Pad,0,0)
		EndIf
		If $Endian = 0 Then
			$Newfile = _BinaryPoke($Newfile, 5,  BinaryLen($Newfile), "dword")
		Else
			$Newfile = _BinaryPoke($Newfile, 5,  Binary("0x" & Hex(BinaryLen($Newfile),8)), "dword")
		EndIf
		$hNewfile = FileOpen($Dir &"\"& $Names[$i], 2+16)
		FileWrite($hNewfile,$Newfile)
		FileClose($hNewfile)
		$Num += $f-1
	EndIf
	FileClose($File)
Next
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc