#include<Binary.au3>
#include<File.au3>
$BndPath = FileOpenDialog("Select the BND file", @ScriptDir,"bnd files (*.bnd)",1)
If @error = 1 Then Exit
$BndFile = fileopen($BndPath,16)
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
Dim $Names, $Pos = 33
_FileReadToArray($Dir &"\"& "names.txt",$Names)
FileSetPos($BndFile,20,0)
$BaseOffset = _BinaryToInt32(FileRead ($BndFile, 4))
$Basepad = 16 - Mod($BaseOffset,16)
If $Basepad < 16 Then
	$BaseOffset += $Basepad
EndIf
FileSetPos($BndFile,0,0)
$NewfileHead = FileRead($BndFile,$BaseOffset)
$NewfileText = Binary("0x00")
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	$Size = FileGetSize($Dir &"\"& $Names[$i])
	$Padding = 16 - Mod($Size,16)
	If $Padding < 16 Then
		$NewfileText &= FileRead($File) & _BinaryRandom($Padding,0,0)
	Else
		$NewfileText &= FileRead($File)
	EndIf
	$NewfileHead = _BinaryPoke($NewfileHead, $Pos+4, $Size, "dword")
	$NewfileHead = _BinaryPoke($NewfileHead, $Pos+8, $BaseOffset, "dword")
	$NewfileHead = _BinaryPoke($NewfileHead, $Pos+20, $Size, "dword")
	$Pos += 24
	If $Padding < 16 Then
		$BaseOffset += $Size + $Padding
	Else
		$BaseOffset += $Size
	EndIf
	FileClose($File)
Next
$hNewfile = FileOpen(CompGetFileName($BndPath), 2+16)
FileWrite($hNewfile,$NewfileHead&BinaryMid($NewfileText,2))
FileClose($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc