#include <File.au3>
#include <Binary.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$Ext = CompGetFileExt($Name)
$File = FileOpen($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
If $Ext = ".bin" Then
	$k = 1
	$Newfiletext = Binary("0x00")
	$Newfile = FileRead($File,8)
	$Files = FileRead($File,4)
	$Newfile &= $Files
	$NewOffset = _BinaryToInt32($Files)*44
	For $i = 1 to $Files
		$Newfile &= FileRead($File,4)
		For $n = 1 to 5
			$Offset = _BinaryToInt32(FileRead ($File, 4)) + 12
			$Size = _BinaryToInt32(FileRead ($File, 4))
			$pos = FileGetPos($File)
			FileSetPos($File,$Offset,0)
			If $Size <> 0 Then
				If FileRead($File,1) = "0xff" Then
					$ac = FileRead($File,1)
					If $ac = "0x0a" Then
						FileSetPos($File,$Offset,0)
						$NewText = FileRead($File,16)
					Else
						FileSetPos($File,$Offset,0)
						$NewText = FileRead($File,8)
					EndIf
					$NEWdata[$k] = StringRegExpReplace($NEWdata[$k],"<cf>",@CRLF)
					$NEWdata[$k] = StringRegExpReplace($NEWdata[$k],"<lf>",@LF)
					$NEWdata[$k] = StringRegExpReplace($NEWdata[$k],"<cr>",@CR)
					$NewText &= StringToBinary($NEWdata[$k]) & Binary("0x00")
				Else
					$NEWdata[$k] = StringRegExpReplace($NEWdata[$k],"<cf>",@CRLF)
					$NEWdata[$k] = StringRegExpReplace($NEWdata[$k],"<lf>",@LF)
					$NEWdata[$k] = StringRegExpReplace($NEWdata[$k],"<cr>",@CR)
					$NewText = StringToBinary($NEWdata[$k]) & Binary("0x00")
				EndIf
				$Newfiletext &= $NewText
				$Size = BinaryLen($NewText)
				$Newfile &= _BinaryReverse(Binary("0x" & Hex($NewOffset,8))) & _BinaryReverse(Binary("0x" & Hex($Size,8)))
				$NewOffset += $Size
				$k += 1
			Else
				$Newfile &= _BinaryReverse(Binary("0x" & Hex($NewOffset,8))) & _BinaryReverse(Binary("0x" & Hex(0,8)))
			EndIf
			FileSetPos($File,$pos,0)
		Next
	Next
	$hNewfile = FileOpen("NEW_"&$Name, 2+16)
	FileWrite($hNewfile, $Newfile&BinaryMid($Newfiletext,2))
	FileClose($hNewfile)
Else
	$pos = 21
	$Newfiletext = Binary("0x00")
	If StringInStr($Name,"speech") > 0 Then
		$Files = FileRead($File,4)
		$Newfile = $Files
		$Offset = _BinaryToInt32($Files)*32+4
		For $i = 1 to $Files
			$Newfile &= FileRead($File,24)
			$Off = Filegetpos($File)+_BinaryToInt32(FileRead ($File, 4))
			$Off2 = Filegetpos($File)+_BinaryToInt32(FileRead ($File, 4))
			$pos = FileGetPos($File)
			FileSetPos($File,$Off,0)
			$len = 0
			Do
				$len += 1
			Until FileRead($File,1) = 0
			FileSetPos($File,$Off,0)
			$Newfiletext &= FileRead($File,$len)
			$Newfile &= _BinaryReverse(Binary("0x" & Hex($Offset-($pos-8),8)))
			$Offset += $len
			$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
			$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
			$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
			$NewText = StringToBinary($NEWdata[$i]) & Binary("0x00")
			$Newfiletext &= $NewText
			$Newfile &= _BinaryReverse(Binary("0x" & Hex($Offset-($pos-4),8)))
			$Offset += BinaryLen($NewText)
			FileSetPos($File,$pos,0)
		Next
	Else
		$Files = FileRead($File,4)
		$Newfile = $Files
		$Offset = _BinaryToInt32($Files)*8+4
		For $i = 1 to $Files
			$Off = Filegetpos($File)+_BinaryToInt32(FileRead ($File, 4))
			$Off2 = Filegetpos($File)+_BinaryToInt32(FileRead ($File, 4))
			$pos = FileGetPos($File)
			FileSetPos($File,$Off,0)
			$len = 0
			Do
				$len += 1
			Until FileRead($File,1) = 0
			FileSetPos($File,$Off,0)
			$Newfiletext &= FileRead($File,$len)
			$Newfile &= _BinaryReverse(Binary("0x" & Hex($Offset-($pos-8),8)))
			$Offset += $len
			$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
			$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
			$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
			$NewText = StringToBinary($NEWdata[$i]) & Binary("0x00")
			$Newfiletext &= $NewText
			$Newfile &= _BinaryReverse(Binary("0x" & Hex($Offset-($pos-4),8)))
			$Offset += BinaryLen($NewText)
			FileSetPos($File,$pos,0)
		Next
	EndIf
	FileSetPos($File,$Off2,0)
	Do
	Until FileRead($File,1) = 0
	$hNewfile = FileOpen("NEW_"&$Name, 2+16)
	FileWrite($hNewfile, $Newfile&BinaryMid($Newfiletext,2)&FileRead($File))
	FileClose($hNewfile)
EndIf
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func CompGetFileExt($Path,$Dot=True)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
$ret = StringSplit($ret[UBound($ret)-1],".",2)
If IsArray($ret) Then
If $Dot Then
$Dot = "."
Else
$Dot = ""
EndIf
Return $Dot & $ret[UBound($ret)-1]
EndIf
EndIf
If @error Then Return -1
EndFunc