#include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3>
Dim $NEWdata, $Num = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = StringTrimRight($TxtPath,4)
$Names = _FileListToArrayRec($Dir, "*.DOSeqAct_AddMission", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .DOSeqAct_AddMission files in the "&@cr&CompGetFileName($Dir)&" folder, or the folder not exist.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	$bFile = FileRead($File)
	FileSetPos($File,20,0)
	$BlockSize = _BinaryToInt32(FileRead($File, 4))
	FileSetPos($File,52,0)
	If FileRead($File,4) =  "0x04000000" Then
		FileRead($File,32)
		$Pos = FileGetPos($File)-8
	Else
		$Pos = 52
		FileRead($File,4)
	EndIf
	$Str = $NEWdata[$Num]
	$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
	$Str = StringRegExpReplace($Str,"<lf>",@LF)
	$Str = StringRegExpReplace($Str,"<cr>",@CR)
	$OldStrLen = _BinaryToInt32(FileRead($File, 4))
	If $OldStrLen = 0 Then
		$NewText = _BinaryReverse(Binary("0x" & Hex(4,8))) & Binary("0x" & Hex(0,16))
	ElseIf $OldStrLen < 0 Then
		$NewText = StringToBinary($Str,2) & Binary("0x0000")
		$NewLen = BinaryLen($NewText)
		$NewText = _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex(-int($NewLen/2),8))) & $NewText
	Else
		$NewText = StringToBinary($Str) & Binary("0x00")
		$NewLen = BinaryLen($NewText)
		$NewText = _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex($NewLen,8))) & $NewText
	EndIf
	FileRead($File,$OldStrLen)
	$Data1 = FileRead($File,16)
	If FileRead($File,4) <>  "0x04000000" Then
		FileRead($File,4)
		$Str = $NEWdata[$Num+1]
		$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
		$Str = StringRegExpReplace($Str,"<lf>",@LF)
		$Str = StringRegExpReplace($Str,"<cr>",@CR)
		$OldStrLen = _BinaryToInt32(FileRead($File, 4))
		If $OldStrLen = 0 Then
			$NewText2 = _BinaryReverse(Binary("0x" & Hex(4,8))) & Binary("0x" & Hex(0,16))
		ElseIf $OldStrLen < 0 Then
			$NewText2 = StringToBinary($Str,2) & Binary("0x0000")
			$NewLen = BinaryLen($NewText2)
			$NewText2 = _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex(-int($NewLen/2),8))) & $NewText2
		Else
			$NewText2 = StringToBinary($Str) & Binary("0x00")
			$NewLen = BinaryLen($NewText2)
			$NewText2 = _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex($NewLen,8))) & $NewText2
		EndIf
	EndIf
	FileRead($File,$OldStrLen)
	$Size = FileGetPos($File) - $Pos
	FileSetPos($File,$Pos,0)
	$OldBlock = FileRead($File,$Size)
	$NewBlock = $NewText & $Data1 & $NewText2
	$Dif = BinaryLen($NewBlock) - BinaryLen($OldBlock)
	If $NewBlock <> $OldBlock Then
		$bFile = _BinaryReplace($bFile, $OldBlock, $NewBlock, 1)
		$bFile = _BinaryPoke($bFile,21,$BlockSize + $Dif,"dword")
		$hNewfile = FileOpen ($Dir &"\"& $Names[$i], 2+16)
		FileWrite ($hNewfile, $bFile)
		FileClose ($hNewfile)
	EndIf
	$Num += 2
	FileClose ($File)
Next
$Names = _FileListToArrayRec($Dir, "*.DOSeqAct_Announcement", 1,1)
If $Names = "" Then
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	$bFile = FileRead($File)
	FileSetPos($File,20,0)
	If FileRead($File,4) <>  "0x04000000" Then
		FileRead($File,4)
		$Str = $NEWdata[$Num]
		$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
		$Str = StringRegExpReplace($Str,"<lf>",@LF)
		$Str = StringRegExpReplace($Str,"<cr>",@CR)
		$OldStrLen = _BinaryToInt32(FileRead($File, 4))
		If $OldStrLen = 0 Then
			$NewBlock = _BinaryReverse(Binary("0x" & Hex(4,8))) & Binary("0x" & Hex(0,16))
		ElseIf $OldStrLen < 0 Then
			$NewText = StringToBinary($Str,2) & Binary("0x0000")
			$NewLen = BinaryLen($NewText)
			$NewBlock = _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex(-int($NewLen/2),8))) & $NewText
		Else
			$NewText = StringToBinary($Str) & Binary("0x00")
			$NewLen = BinaryLen($NewText)
			$NewBlock = _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex($NewLen,8))) & $NewText
		EndIf
	EndIf
	FileRead($File,$OldStrLen)
	$Size = FileGetPos($File) - 20
	FileSetPos($File,20,0)
	$OldBlock = FileRead($File,$Size)
	$Dif = BinaryLen($NewBlock) - BinaryLen($OldBlock)
	If $NewBlock <> $OldBlock Then
		$bFile = _BinaryReplace($bFile, $OldBlock, $NewBlock, 1)
		$hNewfile = FileOpen ($Dir &"\"& $Names[$i], 2+16)
		FileWrite ($hNewfile, $bFile)
		FileClose ($hNewfile)
	EndIf
	$Num += 1
	FileClose ($File)
Next

TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc