#include<Binary.au3>
$Path = FileOpenDialog("Select the LH2 file", @ScriptDir, "lh2 files (*.lh2)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
Dim $Text
If FileRead($File,4) = "LCH2" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
FileSetPos($File,16,0)
If $Endian = 0 Then
	$Files = _BinaryToInt32(FileRead($File,4))
Else
	$Files = Dec(Hex(FileRead($File,4)))
endif
FileSetPos($File,$Files*4+32,0)
For $i = 1 to $Files
	If $Endian = 0 Then
		$Offset = _BinaryToInt32(FileRead($File,4))
	Else
		$Offset = Dec(Hex(FileRead($File,4)))
	endif
	$pos = FileGetPos($File)
	FileSetPos($File,$Offset,0)
	$S = ""
	$Str = ""
	Do
		$Str &= BinaryToString($S)
		$S = FileRead($File, 1)
	Until $S = 0
	$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
	$Str = StringRegExpReplace($Str,@LF,"<lf>")
	$Str = StringRegExpReplace($Str,@CR,"<cr>")
	$Text &= $Str & @CRLF
	FileSetPos($File,$pos,0)
Next
$hFile = FileOpen (CompGetFileName($Path)&".txt", 2+512)
FileWrite($hFile, $Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc