#include <File.au3>
#include <Binary.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
If FileGetEncoding($TxtPath) = 512 Then
	$Encoding = 1
Else
	$Encoding = 4
EndIf
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
If FileRead($File,4) = "LCH2" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
FileSetPos($File,16,0)
If $Endian = 0 Then
	$Files = _BinaryToInt32(FileRead($File,4))
Else
	$Files = Dec(Hex(FileRead($File,4)))
endif
$Offset = $Files*8+32
$pos = $Files*4+33
FileSetPos($File,0,0)
$Newfile = FileRead($File,$Offset)
$Newfiletext = Binary("0x00")
For $i = 1 to $Files
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$NewText = StringToBinary($NEWdata[$i],$Encoding) & Binary("0x00")
	$Len = BinaryLen($NewText)
	If $Endian = 0 Then
		$Newfile = _BinaryPoke($Newfile,$pos,$Offset,"dword")
	Else
		$Newfile = _BinaryPoke($Newfile,$pos,Binary("0x" & Hex($Offset,8)),"dword")
	endif
	$pos += 4
	$Newfiletext &= $NewText
	$Offset += $Len
Next
If $Endian = 0 Then
	$Newfile = _BinaryPoke($Newfile,5,$Offset,"dword")
Else
	$Newfile = _BinaryPoke($Newfile,5,Binary("0x" & Hex($Offset,8)),"dword")
endif
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile&BinaryMid($Newfiletext,2))
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc