#Include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3> ;NaturalCompare, https://www.autoitscript.com/forum/topic/83626-natural-order-string-comparison/
Dim $NEWdata,$Num = 1,$plus = Binary ("0x" & Hex (0, 2)), $pos = 13
$Path = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($Path,$NEWdata)
$Name = StringTrimRight(CompGetFileName($Path),4)
$Names = _FileListToArray("unpacked\", "*.gmd", 1)
_ArrayNaturalSort($Names,0,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no gmd files in the folder.")
	Exit
EndIf
$File = FileOpen("unpacked\" & $Names[1], 0+16)
$Id = FileRead($File,3)
FileClose($File)
If $Id = "GMD" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
For $i=1 to $Names[0]
	$File = FileOpen("unpacked\" & $Names[$i], 0+16)
	FileSetPos($File,8,0)
	If $Endian = 0 Then
		$Lang = FileRead($File,4)
	Else
		$Lang = Dec(Hex(FileRead($File,4)))
	EndIf
	If $Lang = 1 Then
		$Asize = FileGetSize("unpacked\" & $Names[$i])
		FileSetPos($File,24,0)
		If $Endian = 0 Then
			$Files = FileRead ($File, 4)
			FileRead ($File, 4)
			$Size = _BinaryToInt32(FileRead ($File, 4))
		Else
			$Files = Dec(Hex(FileRead($File, 4)))
			FileRead($File, 4)
			$Size = Dec(Hex(FileRead($File, 4)))
		EndIf
		$DataSize = $Asize-$Size
		FileSetPos($File,0,0)
		$Newfile = FileRead($File,$DataSize)
		For $n = 1 to $Files
			$Str = $NEWdata[$Num]
			$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
			$Str = StringRegExpReplace($Str,"<lf>",@LF)
			$Str = StringRegExpReplace($Str,"<cr>",@CR)
			$Newfile &= StringToBinary($Str,4)&$plus
			$Num += 1
		Next
		If $Endian = 0 Then
			$Newfile = _BinaryPoke($Newfile,33,BinaryLen($Newfile)-$DataSize,"dword")
		Else
			$Newfile = _BinaryPoke($Newfile,33,Binary("0x" & Hex(BinaryLen($Newfile)-$DataSize,8)),"dword")
		EndIf
		$hNewfile = FileOpen("unpacked\" & $Names[$i], 2+16)
		FileWrite($hNewfile,$Newfile)
		FileClose($hNewfile)
	EndIf
	FileClose($File)
Next
$File = fileopen($Name,16)
FileSetPos($File,4,0)
If $Endian = 0 Then
	$Files = _Binarytoint32(FileRead($File,4))
Else
	$Files = Dec(Hex(FileRead($File, 4)))
EndIf
FileSetPos($File,0,0)
$Offset = $Files*12+8
$Newfile = FileRead($File,$Offset)
$Newdata = Binary("0x00")
FileClose($File)
For $i = 1 to $Files
	$File = FileOpen("unpacked\" & $Names[$i], 0+16)
	$Asize = FileGetSize("unpacked\" & $Names[$i])
	$Newdata &= FileRead($File)
	FileClose($File)
	If $Endian = 0 Then
		$Newfile = _BinaryPoke($Newfile,$pos,$Offset,"dword")
	Else
		$Newfile = _BinaryPoke($Newfile,$pos,Binary("0x" & Hex($Offset,8)),"dword")
	EndIf
	$Offset += $Asize
	If $Endian = 0 Then
		$Newfile = _BinaryPoke($Newfile,$pos+4,$Asize,"dword")
	Else
		$Newfile = _BinaryPoke($Newfile,$pos+4,Binary("0x" & Hex($Asize,8)),"dword")
	EndIf
	$pos += 12
Next
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile & BinaryMid($Newdata,2))
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc