#Include <File.au3>
#include <Binary.au3>
#Include <ArrayNaturalSort.au3>
$Path = FileOpenDialog("Select the PAK file", @ScriptDir, "pak files (*.pak)",1)
If @error = 1 Then Exit
$Names = _FileListToArray("unpacked", "*", 1)
If @error = 1 Then
	MsgBox(0,"Error!","Can't open unpacked folder!")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
Dim $NEWdata
_FileReadToArray("NPCDATA.txt",$NEWdata)
If @error = 1 Then
	MsgBox(0,"Error!","Can't open NPCDATA.txt!")
	Exit
EndIf
$File = FileOpen ("unpacked\"& $Names[1], 0+16)
$Files = _BinaryToInt32(FileRead ($File, 4))
FileSetPos($File,0,0)
$Offset = $Files*5+4
$Newfile = FileRead($File,$Offset)
Dim $Pos = 5, $plus = Binary ("0x" & Hex (0, 2))
For $n = 1 to $Files
	$NEWdata[$n] = StringRegExpReplace($NEWdata[$n],"<cf>",@CRLF)
	$NEWdata[$n] = StringRegExpReplace($NEWdata[$n],"<lf>",@LF)
	$NEWdata[$n] = StringRegExpReplace($NEWdata[$n],"<cr>",@CR)
	$Newstr = StringToBinary($NEWdata[$n])&$plus
	$Strlen = BinaryLen($Newstr)
	$Newfile &= $Newstr
	$Newfile = _BinaryPoke($Newfile,$Pos,$Offset,"dword")
	$Offset += $Strlen
	$Pos += 5
Next
$hNewfile = FileOpen ("unpacked\"& $Names[1], 2+16)
FileWrite($hNewfile,$Newfile)
FileClose($hNewfile)
FileClose($File)
$Num = $Files
For $i = 2 to $Names[0]
	$File = FileOpen ("unpacked\"& $Names[$i], 0+16)
	If FileRead($File,8) <> "0x0300000000000100" Then
		Filesetpos($File,0,0)
		$Files = _BinaryToInt32(FileRead ($File, 4))
		If $Files <> 0 Then
			$Pos = 5
			$Offset = $Files*4+4
			FileSetPos($File,0,0)
			$Newfile = FileRead($File,$Offset)
			For $n = 1 to $Files
				$NEWdata[$n+$Num] = StringRegExpReplace($NEWdata[$n+$Num],"<cf>",@CRLF)
				$NEWdata[$n+$Num] = StringRegExpReplace($NEWdata[$n+$Num],"<lf>",@LF)
				$NEWdata[$n+$Num] = StringRegExpReplace($NEWdata[$n+$Num],"<cr>",@CR)
				$Newstr = StringToBinary($NEWdata[$n+$Num])&$plus
				$Strlen = BinaryLen($Newstr)
				$Newfile &= $Newstr
				$Newfile = _BinaryPoke($Newfile,$Pos,$Offset,"dword")
				$Offset += $Strlen
				$Pos += 4
			Next
			$Num += $n-1
			$hNewfile = FileOpen ("unpacked\"& $Names[$i], 2+16)
			FileWrite($hNewfile,$Newfile)
			FileClose($hNewfile)
		EndIf
	EndIf
	FileClose($File)
Next
$PakFile = FileOpen($Path, 0+16)
$Offset = _BinaryToInt32(FileRead ($PakFile, 4))
FileSetPos($PakFile,0,0)
$Newfile = FileRead($PakFile,$Offset)
FileSetPos($PakFile,0,0)
$Pos = 1
For $i = 1 to $Names[0]
	$File = FileOpen ("unpacked\"& $Names[$i], 0+16)
	$Size = FileGetSize("unpacked\"& $Names[$i])
	$Newfile &= Fileread($File)
	Do
		$Off = _BinaryToInt32(FileRead ($PakFile, 4))
		If $Off = 0 Then
		$Pos += 8
		EndIf
		FileRead($PakFile,4)
	Until $Off <> 0
	$Newfile = _BinaryPoke($Newfile,$Pos,$Offset,"dword")
	$Newfile = _BinaryPoke($Newfile,$Pos+4,$Size,"dword")
	$Offset += $Size
	FileClose($File)
	$Pos += 8
Next
$hNewfile = FileOpen ("NEW_"&CompGetFileName($Path), 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc