#include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata, $Offsets, $k =0
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error!","Can't open "&$Name&" file.")
Exit
EndIf
$Asize = FileGetSize($Name)
Do
	$Offset = _BinaryToInt32(FileRead($File,4))*2
	If IsArray($Offsets) = 1 Then
		$Bound = UBound($Offsets)
		ReDim $Offsets[$Bound+1]
		$Offsets[$Bound] = $Offset
	Else
		Dim $Offsets[1]
		$Offsets[0] = $Offset
	EndIf
Until $Offset > $Asize
$Offset = FileGetPos($File)-4
$Num = UBound($Offsets)-1
For $i = 1 to $Num
	FileSetPos($File,$Offset+$Offsets[$i-1],0)
	$n = 0
	While FileRead($File,2) <> 0
		FileSetPos($File,FileGetPos($File)-2,0)
		$S = ""
		Do
			$S = FileRead ($File, 2)
		Until $S = 0
		FileRead ($File, 2)
		$n += 1
	WEnd
	$Offsets[$i-1] = $n
Next
$Offset = 0
$Newfilehead = Binary("0x00")
$Newfiletext = Binary("0x00")
For $i = 1 to $Num
	For $n = 1 to $Offsets[$i-1]
		$NEWdata[$i+$k] = StringRegExpReplace($NEWdata[$i+$k],"<cf>",@CRLF)
		$NEWdata[$i+$k] = StringRegExpReplace($NEWdata[$i+$k],"<lf>",@LF)
		$NEWdata[$i+$k] = StringRegExpReplace($NEWdata[$i+$k],"<cr>",@CR)
		$Newfiletext &= StringToBinary($NEWdata[$i+$k],2) & Binary("0x" & Hex(0,8))
		$k += 1
	Next
	$k -= 1
	$Newfiletext &= Binary("0x" & Hex(0,12))
	$Newfilehead &= _BinaryReverse(Binary("0x" & Hex(int($Offset),8)))
	$Offset = (BinaryLen($Newfiletext)-1)/2
Next
$Null = $Asize - (BinaryLen($Newfilehead)-1 + $Offset*2)
$Newfile = BinaryMid($Newfilehead,2) & BinaryMid($Newfiletext,2) & _BinaryRandom($Null,0,0)
$hNewfile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc