#Include<File.au3>
#include<Binary.au3>
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArray($Dir, "*.subb", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no subb files in the folder.")
	Exit
EndIf
$Lang = InputBox("Language", 'Type "eng" if you want to export english only.'&@CR&@CR&'Type "all" if you want to export all languages.', "", " M3")
If $Lang <> "eng" and $Lang <> "all" Then Exit
Dim $Text
For $i=1 to $Names[0]
	$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,24,0)
	$Files = FileRead($File,4)
	For $f = 1 to $Files
		For $l = 1 to 13
			$S = ""
			$Str = ""
			Do
				$Str &= $S
				$S = FileRead($File, 1)
			Until $S = 0
			$Str = BinaryToString(Binary("0x" & StringRegExpReplace($Str,"0x","")),4)
			$pad = Mod(4 - Mod(FileGetPos($File),4),4)
			FileRead($File,$pad)
			$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
			$Str = StringRegExpReplace($Str,@LF,"<lf>")
			$Str = StringRegExpReplace($Str,@CR,"<cr>")
			If $Lang = "all" Then
				$Text &= $Str & @CRLF
			ElseIf $l = 1 Then
				$Text &= $Str & @CRLF
			EndIf
		Next
		FileRead($File,8)
	Next
	FileClose($File)
Next
$hTextFile = FileOpen(CompGetFileName($Dir)&".txt", 2+256)
FileWrite($hTextFile,$Text)
FileClose($hTextFile)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
EndFunc