#Include <File.au3>
#Include <binary.au3>
$Dir = FileSelectFolder("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.txb", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .txb files in the folder.")
	Exit
EndIf
$Name = CompGetFileName($Dir)
Dim $Text
For $i=1 to $Names[0]
	$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,12,0)
	$Files = _BinaryToInt32(FileRead($File,4))
	$Baseoff = 16 + $Files*8
	FileSetPos($File,16 + $Files*4,0)
	For $f = 1 to $Files
		$Offset = _BinaryToInt32(FileRead($File,4)) + $Baseoff
		$pos = FileGetPos($File)
		FileSetPos($File,$Offset,0)
		FileRead($File,2)
		$Size = FileRead($File,2)
		FileRead($File,4)
		$Str = BinaryToString(FileRead($File,$Size),4)
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
		FileSetPos($File,$pos,0)
	Next
	FileClose($File)
Next
$hFile = FileOpen($Name&".txt", 2+256)
FileWrite($hFile,$Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc