#include <File.au3>
#include <Binary.au3>
Dim $NEWdata, $Num = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$Dir = FileSelectFolder("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.txb", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .txb files in the folder.")
	Exit
EndIf
For $i=1 to $Names[0]
	$File = FileOpen($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,12,0)
	$Files = _BinaryToInt32(FileRead($File,4))
	$Baseoff = 16 + $Files*8
	FileSetPos($File,0,0)
	$Newfile = FileRead($File,$Baseoff)
	FileSetPos($File,16 + $Files*4,0)
	$Newoffset = 0
	For $f = 1 to $Files
		$Offset = _BinaryToInt32(FileRead($File,4)) + $Baseoff
		$pos = FileGetPos($File)
		FileSetPos($File,$Offset,0)
		FileRead($File,2)
		$Size = _BinaryToInt16(FileRead($File,2))+1
		$Val = FileRead($File,2)
		$Val2 = FileRead($File,2)
		FileRead($File,$Size)
		$Pad = 4 - Mod($Size,4)
		If $Pad > 0 And $Pad < 4 Then
			FileRead($File,$Pad)
		EndIf
		$NEWdata[$Num] = StringRegExpReplace($NEWdata[$Num],"<cf>",@CRLF)
		$NEWdata[$Num] = StringRegExpReplace($NEWdata[$Num],"<lf>",@LF)
		$NEWdata[$Num] = StringRegExpReplace($NEWdata[$Num],"<cr>",@CR)
		$NewText = StringToBinary($NEWdata[$Num],4) & Binary("0x00")
		$Len1 = StringLen($NEWdata[$Num])
		$Len2 = BinaryLen($NewText)-1
		$Pad = 4 - Mod($Len2+1,4)
		If $Pad > 0 And $Pad < 4 Then
			$NewText = $NewText & Binary("0x" & Hex(0,$Pad*2))
		EndIf
		$NewText = _BinaryFromInt16($Len1) & _BinaryFromInt16($Len2) & $Val & $Val2 & $NewText & FileRead($File,_BinaryToInt16($Val)*8)
		$Newfile &= $NewText
		$Newfile = _BinaryPoke($Newfile,$pos-3,$Newoffset,"dword")
		$Newoffset += BinaryLen($NewText)
		$Num += 1
		FileSetPos($File,$pos,0)
	Next
	$hNewfile = FileOpen($Dir &"\"& $Names[$i], 2+16)
	FileWrite($hNewfile, $Newfile)
	FileClose($hNewfile)
	FileClose($File)
	FileClose($File)
Next
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc