#include <Binary.au3>
#include <File.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Cant find "&$Name&" file.")
Exit
EndIf
$bFile = FileRead($File)
$plus = Binary ("0x" & Hex (0, 4))
FileSetPos($File,0,0)
$Id = FileRead ($File, 4)
If $Id = "PTXT" Then
	FileSetPos($File,28,0)
	$p = 0
	Do
		$p += 1
		$S = FileRead ($File, 1)
	Until $S = 0
	FileSetPos($File,FileGetPos($File)-1,0)
	FileRead($File,4-Mod($p-1,4))
	$Pos = FileGetPos($File)
	FileSetPos($File,0,0)
	$Newfile = FileRead($File,$Pos)
	For $i = 1 to $NEWdata[0]
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
		$NewText = StringToBinary ($NEWdata[$i],2) & $plus
		$Len = Int(BinaryLen($NewText)/2)
		$Newfile &= _BinaryReverse(Binary ("0x" & Hex ($Len, 8))) & $NewText
	Next
ElseIf $Id = "HTXT" Then
	FileSetPos($File,0,0)
	$Newfile = FileRead($File,20)
	FileSetPos($File,20,0)
	For $i = 1 to $NEWdata[0]
		$Newfile &= FileRead($File,4)
		FileRead($File,_BinaryToInt32(FileRead ($File, 4))*2)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
		$NewText = StringToBinary ($NEWdata[$i],2) & $plus
		If Mod(BinaryLen($NewText),4) <> 0 Then
			$NewText &= $plus
		EndIf
		$Len = Int(BinaryLen($NewText)/2)
		$Newfile &= _BinaryReverse(Binary ("0x" & Hex ($Len, 8))) & $NewText
	Next
ElseIf $Id = "LTXT" Then
	FileSetPos($File,0,0)
	$Newfile = FileRead($File,20)
	For $i = 1 to $NEWdata[0]
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
		$NewText = StringToBinary ($NEWdata[$i],2) & $plus
		$Len = Int(BinaryLen($NewText)/2)
		$Newfile &= _BinaryReverse(Binary ("0x" & Hex ($Len, 8))) & $NewText
	Next
Else
	MsgBox(0,"Error","Not supported format: "&BinaryToString($Id))
	Exit
EndIf
$Asize = BinaryLen($Newfile)
$Newfile = _BinaryPoke($Newfile, 5, Int($Asize), "dword")
$hNewFile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewFile, $Newfile)
FileClose ($hNewFile)
FileClose ($File)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc