#include <File.au3>
#include <Binary.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
$Asize = FileGetSize($Name)
$Newfile = FileRead($File,5)
$Size = FileRead($File,1)
$Newfile &= $Size & FileRead($File,$Size)
$Offset = FileGetPos($File) + 1
$bAsize = FileRead($File,4)
$Newfile &= $bAsize & FileRead($File,20)
$Files = FileRead($File,2)
$Newfile &= $Files
$Files = _BinaryToInt32($Files) - 2048
For $i = 1 to $Files
	$pos = FileGetPos($File)
	$Size = _BinaryToInt32(FileRead($File,1))
	If $Size >= 128 Then
		$Size += (_BinaryToInt32(FileRead($File,1))-1)*128 +2
	Else
		$Size += 1
	EndIf
	$Size -= 5
	FileSetPos($File,$pos,0)
	$Newfile &= FileRead($File,$Size)
	$Size = _BinaryToInt32(FileRead($File,1))
	If $Size >= 128 Then
		$Size += (_BinaryToInt32(FileRead($File,1))-1)*128
	EndIf
	$Size -= 5
	FileRead($File,$Size)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$NewText = StringToBinary($NEWdata[$i],4)
	$Len = BinaryLen($NewText) + 5
	$Div = Int($Len/128)
	If $Div > 0 Then
		$Len = $Len+(128*($Div+1))
		$Newfile &= _BinaryReverse(Binary("0x" & Hex ($Len, 4))) & $NewText
	Else
		$Newfile &= Binary("0x" & Hex($Len,2)) & $NewText
	EndIf
Next
$Newfile &= FileRead($File)
$Newsize = BinaryLen($Newfile)
$Newfile = _Binarypoke($Newfile,$Offset,_BinaryToInt32($bAsize) + ($Newsize - $Asize),"dword")
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile)
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc