#include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata, $f = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
If FileRead($File,4) = 0 Then
	$pos = 36
	$Endian = 0
Else
	$pos = 28
	$Endian = 1
EndIf
FileSetPos($File,0,0)
$Newfile = FileRead($File,$pos)
For $b = 1 to 6
	$Newfile &= FileRead($File,12)
	$Files = FileRead($File,4)
	$Newfile &= $Files
	If $Endian = 0 Then $Files = Dec(Hex($Files))
	For $i = 1 to $Files
		$Size = FileRead($File,4)
		$Newfile &= $Size
		If $Endian = 0 Then
			$Size = Dec(Hex($Size))
		Else
			$Size = _BinaryToInt32($Size)
		EndIf
		$Newfile &= FileRead($File,$Size)
		$Pad = 4 - Mod($Size,4)
		If $Pad > 0 And $Pad < 4 Then
			$Newfile &= FileRead($File,$Pad)
		EndIf
		If $Endian = 0 Then
			$Size = Dec(Hex(FileRead($File,4)))
		Else
			$Size = _BinaryToInt32(FileRead($File,4))
		EndIf
		FileRead($File,$Size)
		$Pad = 4 - Mod($Size,4)
		If $Pad > 0 And $Pad < 4 Then
			FileRead($File,$Pad)
		EndIf
		$NEWdata[$f] = StringRegExpReplace($NEWdata[$f],"<cf>",@CRLF)
		$NEWdata[$f] = StringRegExpReplace($NEWdata[$f],"<lf>",@LF)
		$NEWdata[$f] = StringRegExpReplace($NEWdata[$f],"<cr>",@CR)
		$NewText = StringToBinary($NEWdata[$f],4)
		$f += 1
		$Len = BinaryLen($NewText)
		If $Endian = 0 Then
			$Newfile &= Binary("0x" & Hex($Len,8)) & $NewText
		Else
			$Newfile &= _BinaryReverse(Binary("0x" & Hex($Len,8))) & $NewText
		EndIf
		$Pad = 4 - Mod($Len,4)
		If $Pad > 0 And $Pad < 4 Then
			$Newfile &= Binary("0x" & Hex(0,$Pad*2))
		EndIf
	Next
Next
$Newfile &= FileRead($File)
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile)
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc