#include <Binary.au3>
$VfxPath = FileOpenDialog("Select the content.vfx file", @ScriptDir, "(*.vfx)",1)
If @error = 1 Then Exit
$hVfxFile = FileOpen($VfxPath, 16)
$bVfxFile = FileRead($hVfxFile)
$LngPath = FileOpenDialog("Select the file to insert", @ScriptDir, "(*.*)",1)
If @error = 1 Then Exit
$LngFile = FileOpen($LngPath, 16)
$LngName = CompGetFileName($LngPath)
$VfxName = CompGetFileName($VfxPath)
FileSetPos($hVfxFile,24,0)
$VfsNum = _BinaryToInt32(FileRead($hVfxFile,4))
$Files = _BinaryToInt32(FileRead($hVfxFile,4))
FileRead($hVfxFile,4)
Dim $Vfs[$VfsNum][3]
For $i = 0 to $VfsNum-1
	$S = ""
	$Name = ""
	Do
		$Name &= BinaryToString($S)
		$S = FileRead ($hVfxFile, 1)
	Until $S = 0
	$Num = FileRead($hVfxFile,4)
	For $n = 1 to $Num
		$S = ""
		Do
			$S = FileRead ($hVfxFile, 1)
		Until $S = 0
	Next
	$Vfs[$i][0] = $Name
	$Vfs[$i][1] = FileGetPos($hVfxFile)
	$Vfs[$i][2] = _BinaryToInt32(FileRead($hVfxFile,4))
Next
For $i = 1 to $Files
	$Type = _BinaryToInt32(Fileread($hVfxFile,2))
	If $Type > 0 Then
		Fileread($hVfxFile,6)
		Fileread($hVfxFile,_BinaryToInt32(FileRead($hVfxFile,1))+1)
	Else
		$VfsId = _BinaryToInt32(Fileread($hVfxFile,2))
		$DataPos = Filegetpos($hVfxFile)
		Fileread($hVfxFile,12)
		$Len = _BinaryToInt32(FileRead($hVfxFile,1))-1
		$Xor = Fileread($hVfxFile,1)
		$Name = ""
		for $n = 1 to $Len
			$Name &= Chr(BitXOR(FileRead($hVfxFile,1),$Xor))
		Next
		Fileread($hVfxFile,1)
		If $LngName = $Name Then
		$LngSize = FileGetSize($LngPath)
		$VfsSize = $Vfs[$VfsId][2]
		$VfsName = $Vfs[$VfsId][0]
		$File = FileOpen ($VfsName, 1+16)
		If $File = -1 Then
			MsgBox(0,"Error!","Can't open "&$Name&" file.")
			Exit
		EndIf
		FileSetPos($File,Int($VfsSize),0)
		FileWrite($File,FileRead($LngFile))
		FileClose ($File)
		$bVfxFile = _BinaryPoke($bVfxFile, Int($Vfs[$VfsId][1])+1, Int($VfsSize+$LngSize), "dword")
		$bVfxFile = _BinaryPoke($bVfxFile, $DataPos+1, Int($VfsSize), "dword")
		$bVfxFile = _BinaryPoke($bVfxFile, $DataPos+5, Int($LngSize), "dword")
		$bVfxFile = _BinaryPoke($bVfxFile, $DataPos+9, Int($LngSize), "dword")
		$hNewFile = FileOpen ($VfxName, 2+16)
		FileWrite ($hNewFile, $bVfxFile)
		FileClose ($hNewFile)
		MsgBox(0, "Metro Redux insert", "Finish!")
		Exit
	EndIf
EndIf
Next
MsgBox(0,"Error",'The file "'&$LngName&'" not found!')
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
	EndFunc