#include <Binary.au3>
$VfxPath = FileOpenDialog("Select the patch.vfx0 file", @ScriptDir, "(*.vfx*)",1)
If @error = 1 Then Exit
$hVfxFile = FileOpen($VfxPath, 16)
$bVfxFile = FileRead($hVfxFile)
$VfsPath = FileOpenDialog("Select the patch.vfs0 file", @ScriptDir, "(*.vfs*)",1)
If @error = 1 Then Exit
$VfsFile = FileOpen($VfsPath, 16)
$LngPath = FileOpenDialog("Select the file to insert", @ScriptDir, "(*.*)",1)
If @error = 1 Then Exit
$LngFile = FileOpen($LngPath, 16)
$LngName = CompGetFileName($LngPath)
$VfsName = CompGetFileName($VfsPath)
$VfxName = CompGetFileName($VfxPath)
FileSetPos($hVfxFile,24,0)
$VfsNum = _BinaryToInt32(FileRead($hVfxFile,4))
$Files = _BinaryToInt32(FileRead($hVfxFile,4))
FileRead($hVfxFile,4)
Dim $Vfs[$VfsNum][2]
$VfsSizePos = ""
For $i = 1 to $VfsNum
	$S = ""
	$Name = ""
	Do
		$Name &= BinaryToString($S)
		$S = FileRead ($hVfxFile, 1)
	Until $S = 0
	If $Name = $VfsName Then
		$VfsSizePos = FileGetPos($hVfxFile)+1
		$i = $VfsNum
	EndIf
	Fileread($hVfxFile,4)
Next
If $VfsSizePos = "" Then
	MsgBox(0,"Error",$VfsName&" not found in the vfx file")
	Exit
EndIf
For $i = 1 to $Files
	$Type = _BinaryToInt32(Fileread($hVfxFile,2))
	If $Type > 0 Then
		Fileread($hVfxFile,6)
		Fileread($hVfxFile,_BinaryToInt32(FileRead($hVfxFile,1))+1)
	Else
		Fileread($hVfxFile,2)
		$DataPos = Filegetpos($hVfxFile)
		Fileread($hVfxFile,12)
		$Len = _BinaryToInt32(FileRead($hVfxFile,1))-1
		$Xor = Fileread($hVfxFile,1)
		$Name = ""
		for $n = 1 to $Len
			$Name &= Chr(BitXOR(FileRead($hVfxFile,1),$Xor))
		Next
		Fileread($hVfxFile,1)
If $LngName = $Name Then
$VfsSize = FileGetSize($VfsPath)
$LngSize = FileGetSize($LngPath)
$NewVfs = FileRead($VfsFile) & FileRead($LngFile)
$bVfxFile = _BinaryPoke($bVfxFile, $VfsSizePos, Int($VfsSize+$LngSize), "dword")
$bVfxFile = _BinaryPoke($bVfxFile, $DataPos+1, Int($VfsSize), "dword")
$bVfxFile = _BinaryPoke($bVfxFile, $DataPos+5, Int($LngSize), "dword")
$bVfxFile = _BinaryPoke($bVfxFile, $DataPos+9, Int($LngSize), "dword")
$hNewFile = FileOpen ("NEW_"&$VfxName, 2+16)
FileWrite ($hNewFile, $bVfxFile)
FileClose ($hNewFile)
$hNewFile = FileOpen ("NEW_"&$VfsName, 2+16)
FileWrite ($hNewFile, $NewVfs)
FileClose ($hNewFile)
MsgBox(0, "Metro LL lng insert", "Finish!")
Exit
EndIf
Endif
Next
MsgBox(0,"Error",'The file "'&$LngName&'" not found!')
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
	EndFunc