$Path = FileOpenDialog("Select the ZTD/ZTI file", @ScriptDir, "ztd/zti files (*.ztd;*.zti)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
$Ext = CompGetFileExt($Path)
If $Ext = ".zti" Then
	$Consolse = 1
Else
	$Consolse = 0
EndIf
FileSetPos($File,12,0)
If $Consolse = 1 Then
	$Group = Dec(Hex(FileRead($File, 2)))
Else
	$Group = _BinaryToInt32(FileRead($File, 2))
EndIf
FileSetPos($File,20,0)
Dim $Text
For $i = 0 to $Group-1
	If $Consolse = 1 Then
		$Files = Dec(Hex(FileRead($File, 4)))
	Else
		$Files = _BinaryToInt32(FileRead($File, 4))
	EndIf
	FileRead($File, 4)
	If $Consolse = 1 Then
		$Opos = Dec(Hex(FileRead($File, 4)))
	Else
		$Opos = _BinaryToInt32(FileRead($File, 4))
	EndIf
	$Gpos = FileGetPos($File)
	$Opos += 20 + $i*12
	FileSetPos($File,$Opos,0)
	Dim $Spos[$Files]
	For $n = 1 To $Files
		If $Consolse = 1 Then
			$Spos[$n-1] = Dec(Hex(FileRead($File, 4))) + 20 + $i*12
		Else
			$Spos[$n-1] = _BinaryToInt32(FileRead($File, 4)) + 20 + $i*12
		EndIf
	Next
	For $n = 1 To $Files
		FileSetPos($File,$Spos[$n-1],0)
		$S = ""
		$Str = ""
		Do
			If $Consolse = 1 Then
				$Str &= BinaryToString($S,3)
			Else
				$Str &= BinaryToString($S,2)
			EndIf
			$S = FileRead ($File, 2)
		Until $S = 0
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
	Next
	FileSetPos($File,$Gpos,0)
Next
If $Consolse = 1 Then
	$hAllTextFil = FileOpen (CompGetFileName($Path)&".txt", 2+64)
Else
	$hAllTextFil = FileOpen (CompGetFileName($Path)&".txt", 2+32)
EndIf
FileWrite ($hAllTextFil, $Text)
FileClose ($hAllTextFil)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func _BinaryToInt32($Binary)
	Return BitAND(Int(Binary($Binary)), 0xFFFFFFFF)
EndFunc
Func CompGetFileExt($Path,$Dot=True)
       ;by 1234hotmaster
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        $ret = StringSplit($ret[UBound($ret)-1],".",2)
        If IsArray($ret) Then
            If $Dot Then
                $Dot = "."
            Else
                $Dot = ""
            EndIf
            Return $Dot & $ret[UBound($ret)-1]
        EndIf
    EndIf
    If @error Then Return -1
EndFunc