#include <File.au3>
#include <Binary.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error!","Can't open "&$Name&" file.")
Exit
EndIf
$Id = FileRead($File,4)
If $Id = 16 Then
	FileRead($File,4)
EndIf
$Files = _BinaryToInt32(FileRead($File,4))
FileSetPos($File,0,0)
If $Id = 16 Then
	$Offpos = $Files*4+17
	$Offset = $Files*20+16
Else
	$Offpos = $Files*4+9
	$Offset = $Files*12+8
EndIf
$Newfile = FileRead($File,$Offset)
$plus = Binary("0x0000")
$Newtext = Binary("0x00")
For $i = 1 To $Files
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$bNewText = StringToBinary ($NEWdata[$i],2) & $plus
	$NewLen = BinaryLen ($bNewText)
	$padding = 4 - Mod($NewLen, 4)
	If $padding < 4 Then
		$Newtext &= $bNewText & _binaryrandom($padding, 0, 0)
		$NewLen += $padding
	Else
		$Newtext &= $bNewText
	EndIf
	$Newfile = _BinaryPoke($Newfile,$Offpos,$Offset,"dword")
	$Offset += $NewLen
	If $Id = 16 Then
		$Offpos += 16
	Else
		$Offpos += 8
	EndIf

Next
$Newfile = $Newfile & BinaryMid($Newtext,2)
$hNewfile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc