#include <File.au3>
#include <Binary.au3>
Dim $NEWdata, $Num = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error!","Can't open "&$Name&" file.")
Exit
EndIf
FileSetPos($File,280,0)
$End = Dec(Hex(FileRead($File,4))) + 284
FileSetPos($File,288,0)
$Files = _BinaryToInt32(FileRead($File,4))
If $Files > 10000000 Or $Files < 0 Then
	FileSetPos($File,288,0)
	$Files = Dec(Hex(FileRead($File,4)))
	$Endian = 0
Else
	$Endian = 1
EndIf
$Offset = 300+$Files*40
FileSetPos($File,0,0)
$Newfile = FileRead($File,$Offset)
$Newtext = Binary("0x00")
$k = 0
FileSetPos($File,296,0)
For $i = 1 To $Files
	FileRead($File,12)
	$pos = FileGetPos($File)
	$Offset1 = FileRead($File,4)
	FileRead($File,4)
	$Offset2 = FileRead($File,4)
	FileRead($File,16)
	If $Offset1 <> 0 Then
		$NEWdata[$Num] = StringReplace($NEWdata[$Num],"<cf>",@CRLF)
		$NEWdata[$Num] = StringReplace($NEWdata[$Num],"<lf>",@LF)
		$NEWdata[$Num] = StringReplace($NEWdata[$Num],"<cr>",@CR)
		$bNewText = StringToBinary($NEWdata[$Num],4) & Binary("0x00")
		$Num += 1
		$NewLen = BinaryLen ($bNewText)
		$padding = 8 - Mod($NewLen,8)
		If $padding < 8 Then
			$Newtext &= $bNewText & _binaryrandom($padding, 0, 0)
			$NewLen += $padding
		Else
			$Newtext &= $bNewText
		EndIf
		If $Endian = 0 Then
			$Newfile = _BinaryPoke($Newfile,$pos+1,Binary("0x" & Hex($Offset-$pos,8)),"dword")
		Else
			$Newfile = _BinaryPoke($Newfile,$pos+1,$Offset-$pos,"dword")
		EndIf
		$Offset += $NewLen
	EndIf
	If $Offset2 <> 0 Then
		$NEWdata[$Num] = StringReplace($NEWdata[$Num],"<cf>",@CRLF)
		$NEWdata[$Num] = StringReplace($NEWdata[$Num],"<lf>",@LF)
		$NEWdata[$Num] = StringReplace($NEWdata[$Num],"<cr>",@CR)
		$bNewText = StringToBinary($NEWdata[$Num],4) & Binary("0x00")
		$Num += 1
		$NewLen = BinaryLen ($bNewText)
		$padding = 8 - Mod($NewLen, 8)
		If $padding < 8 Then
			$Newtext &= $bNewText & _binaryrandom($padding, 0, 0)
			$NewLen += $padding
		Else
			$Newtext &= $bNewText
		EndIf
		If $Endian = 0 Then
			$Newfile = _BinaryPoke($Newfile,$pos+9,Binary("0x" & Hex($Offset-($pos+8),8)),"dword")
		Else
			$Newfile = _BinaryPoke($Newfile,$pos+9,$Offset-($pos+8),"dword")
		EndIf
		$Offset += $NewLen
	EndIf
Next
FileSetPos($File,$End,0)
$Asize = BinaryLen($Newfile) + BinaryLen($Newtext)-1 - 284
$Newfile = _BinaryPoke($Newfile,269,Binary("0x" & Hex($Asize+4,8)),"dword")
$Newfile = _BinaryPoke($Newfile,281,Binary("0x" & Hex($Asize,8)),"dword")
$Newfile = $Newfile & BinaryMid($Newtext,2) & FileRead($File)
$hNewfile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc