#include<File.au3>
#include<Binary.au3>
#include<zlib.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name&".dec", 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&".dec"&" file.")
Exit
EndIf
FileRead($File, 4)
$Files = _BinaryToInt32(FileRead($File, 4))
$Offset = 16+$Files*12
FileSetPos($File,0,0)
$NewfileHead = FileRead($File,$Offset)
$NewfileText = Binary("0x" & Hex (0, 2))
$null = Binary("0x" & Hex (0, 4))
$Pos = 17+$Files*4
For $i = 1 To $Files
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$bNewText = StringToBinary ($NEWdata[$i],2) & $null
	$NewLen = Int(BinaryLen($bNewText)/2)
	$NewfileHead = _BinaryPoke($NewfileHead, $Pos, $Offset, "dword")
	$NewfileHead = _BinaryPoke($NewfileHead, $Pos+4, $NewLen, "dword")
	$NewfileText &= $bNewText
	$Offset += $NewLen*2
	$Pos += 8
Next
$Newfile = $NewfileHead & BinaryMid($NewfileText,2)
$Pad = 16-Mod(BinaryLen($Newfile),16)
$Newfile &= _BinaryRandom($Pad,0,0)
$Compressed = _ZLIB_Compress($Newfile, 9)
FileClose($File)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
FileRead($File, 4)
$Ver = FileRead($File, 1)
If $Ver == "0x03" Then
	FileSetPos($File,24,0)
	$Pos1 = 13
	$Pos2 = 81
Else
	FileSetPos($File,20,0)
	$Pos1 = 9
	$Pos2 = 137
EndIf
$Zsize = BinaryLen($Compressed)
$Headersize = _BinaryToInt32(FileRead($File, 4))
$Asize = $Headersize + $Zsize
FileSetPos($File,0,0)
$Newfile = FileRead($File,$Headersize) & $Compressed
FileClose($File)
$Newfile = _BinaryPoke($Newfile, $Pos1, $Asize, "dword")
$Newfile = _BinaryPoke($Newfile, $Pos1+16, $Asize, "dword")
$Newfile = _BinaryPoke($Newfile, $Pos1+20, $Asize, "dword")
$Newfile = _BinaryPoke($Newfile, $Pos1+24, $Asize, "dword")
$Newfile = _BinaryPoke($Newfile, $Pos2, $Zsize, "dword")
$hNewfile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc