#Include <File.au3>
#include <ArrayNaturalSort.au3>
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*", 1,1)
_ArrayNaturalSort($Names,0,1)
Dim $Text,$List
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	$Asize = FileGetSize($Dir &"\"& $Names[$i])
	If $Asize > 16 Then
		FileSetPos($File,20,0)
		If FileRead($File,2) = "0xd104" Then
			$List &= $Names[$i] & @CRLF
			FileSetPos($File,28,0)
			$Size = _BinaryToInt32(FileRead($File, 4))
			FileRead($File, $Size)
			$pad = 4 - Mod($Size, 4)
			If $pad < 4 Then
				FileRead($File,$pad)
			EndIf
			$Files = FileRead($File, 4)
			For $f = 1 to $Files
				For $n = 1 to 9
					$Size = _BinaryToInt32(FileRead($File, 4))
					$Str =  BinaryToString(FileRead($File,$Size),4)
					$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
					$Str = StringRegExpReplace($Str,@LF,"<lf>")
					$Str = StringRegExpReplace($Str,@CR,"<cr>")
					$Text &= $Str & @CRLF
					$pad = 4 - Mod($Size, 4)
					If $pad < 4 Then
						FileRead($File,$pad)
					EndIf
				Next
				FileRead($File,16)
			Next
		EndIf
	EndIf
	FileClose($File)
Next
$hFile = FileOpen (CompGetFileName($Dir)&".txt", 2+256)
FileWrite ($hFile, $Text)
FileClose ($hFile)
$hFile = FileOpen (CompGetFileName($Dir)&"_list.txt", 2)
FileWrite ($hFile, $List)
FileClose ($hFile)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
EndFunc
Func _BinaryToInt32($Binary)
	Return BitAND(Int(Binary($Binary)), 0xFFFFFFFF)
EndFunc