#include<File.au3>
#include<Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
$Files = FileRead($File,4)
$Newfile = $Files
ProgressOn("Pathologic Importer", "Working...","",300,300,2+16)
For $i = 1 to $Files
	$Newfile &= FileRead($File,4)
	$Size = Dec(Hex((FileRead($File,1))))
	If $Size >= 128 Then
		$Size += (Dec(Hex(FileRead($File,1)))-1)*128
	EndIf
	FileRead($File,$Size*2)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$NewText = StringToBinary($NEWdata[$i],2)
	$Size = Int(BinaryLen($NewText)/2)
	If $Size >= 128 Then
		$Div = Int($Size/128)
		$Newfile &= Binary("0x" & Hex($Size-(128*($Div-1)),2)) & Binary("0x" & Hex($Div,2)) & $NewText
	Else
		$Newfile &= Binary("0x" & Hex($Size,2)) & $NewText
	EndIf
	ProgressSet(int($i/(_Binarytoint32($Files)/100)))
Next
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, $Newfile)
FileClose($hNewfile)
ProgressSet(100, "Done!")
Sleep(750)
ProgressOff()
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc