#include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3>
Dim $NEWdata, $Offset = 0
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
$P3dPath = FileOpenDialog("Select the P3D file", @ScriptDir, "p3d files (*.p3d)",1)
If @error = 1 Then Exit
$File = Fileopen($P3dPath,16)
$NewP3d = FileRead($File,3)
If $NewP3d = "P3D" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
$NewP3d &= FileRead($File,9)
FileClose($File)
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$P3dName = CompGetFileName($P3dPath)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
	MsgBox(0,"Error!","Can't open "&$Name&" file.")
	Exit
EndIf
FileRead($File,4)
If $Endian = 0 Then
	$Size = _BinaryToInt32(FileRead($File,4))
Else
	$Size = Dec(Hex(FileRead($File, 4)))
EndIf
FileRead($File,4)
FileRead($File,FileRead($File,1))
FileRead($File,4)
If $Endian = 0 Then
	$Files = _BinaryToInt32(FileRead($File,4))
Else
	$Files = Dec(Hex(FileRead($File, 4)))
EndIf
For $i = 1 to $Files
	FileRead($File,FileRead($File,1))
Next
$pos = FileGetPos($File)+1
$pos2 = $pos + $Files*4
FileSetPos($File,0,0)
$Newfile = FileRead($File,$Size)
$Newtext = Binary("0x00")
For $i = 1 To $Files
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$bNewText = StringToBinary ($NEWdata[$i],4)
	$NewLen = BinaryLen($bNewText)
	$Newtext &= $bNewText
	If $Endian = 0 Then
		$Newfile = _BinaryPoke($Newfile,$pos,$Offset,"dword")
	Else
		$Newfile = _BinaryPoke($Newfile,$pos,Binary("0x" & Hex($Offset,8)),"dword")
	EndIf
	$Offset += $NewLen
	$pos += 4
	If $Endian = 0 Then
		$Newfile = _BinaryPoke($Newfile,$pos2,$Offset+1,"dword")
	Else
		$Newfile = _BinaryPoke($Newfile,$pos2,Binary("0x" & Hex($Offset+1,8)),"dword")
	EndIf
	$pos2 += 4
Next
$Newfile &= FileRead($File,4)
FileRead($File,8)
$Size = FileRead($File,1)
If $Endian = 0 Then
	$Newfile &= _BinaryReverse(Binary("0x" & Hex($Offset+Dec(Hex($Size))+21,8))) & _BinaryReverse(Binary("0x" & Hex($Offset+Dec(Hex($Size))+21,8)))
Else
	$Newfile &= Binary("0x" & Hex($Offset+Dec(Hex($Size))+21,8)) & Binary("0x" & Hex($Offset+Dec(Hex($Size))+21,8))
EndIf
$Newfile &= $Size & FileRead($File,$Size) & FileRead($File,4)
If $Endian = 0 Then
	$Newfile &= _BinaryReverse(Binary("0x" & Hex($Offset,8)))
Else
	$Newfile &= Binary("0x" & Hex($Offset,8))
EndIf
$hNewfile = FileOpen($Name, 2+16)
FileWrite($hNewfile, $Newfile & BinaryMid($Newtext,2))
FileClose($hNewfile)
$Names = _FileListToArray(@ScriptDir, "*.dat", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no dat files in the folder.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i = 1 to $Names[0]
	$File = FileOpen(@ScriptDir&"\"&$Names[$i], 0+16)
	$NewP3d &= FileRead($File)
Next
If $Endian = 0 Then
	$NewP3d = _BinaryPoke($NewP3d,9,BinaryLen($NewP3d),"dword")
Else
	$NewP3d = _BinaryPoke($NewP3d,9,Binary("0x" & Hex(BinaryLen($NewP3d),8)),"dword")
EndIf
$hNewfile = FileOpen("NEW_"&$P3dName, 2+16)
FileWrite($hNewfile, $NewP3d)
FileClose($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc