#include <Binary.au3> 
$sScriptName = "Rayman Origins Text Importer"
$sAllTextFilePath = FileOpenDialog("Select the TXT file...", @ScriptDir, "text files (*.txt)|All (*.*)", 1)
If @error = 1 Then Exit
$hAllTextFile = FileOpen ($sAllTextFilePath, 0+64)
$sAllText = FileRead($hAllTextFile)
FileClose ($hAllTextFile)
$a=StringRegExp($sAllText&'[', '(?s)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n=UBound($a)
Dim $aAllText[Int($n/2)]
For $i = 0 to $n-1 Step 2
    $aAllText[$i/2]=$a[$i+1]
 Next
$FilePath = FileOpenDialog("Select the LOC file", @ScriptDir, "loc files (*.loc)|All (*.*)",1)
If @error = 1 Then Exit
$hFile = FileOpen ($FilePath, 0+16) 
$bFile = FileRead ($hFile)
FileClose ($hFile)
$LangidFiles = Binary ("0x" & Hex ($aAllText[0], 8)) & Binary ("0x" & Hex (Int($n/2)-1, 8))
$Pos = _HexSearch($FilePath, $LangidFiles)+9
For $i=1 To int($n/2)-1
   $bText = StringToBinary ($aAllText[$i],3)
   $iTextLen = Int(Dec(Hex (BinaryLen ($bText), 8))/2)
   $Id = Binarymid ($bFile, $Pos, 4)
   $iOldTextLen = Dec (Hex (Binarymid ($bFile, 4+$Pos, 4), 8))
   $bOldText = Binarymid ($bFile, 8+$Pos, $iOldTextLen*2)
   $Pos += ($iTextLen*2)+8
   $bTextLen = Binary ("0x" & Hex ($iTextLen, 8))
   $bOldTextLen = Binary ("0x" & Hex ($iOldTextLen, 8))
   If $bOldTextLen & $bOldText <> $bTextLen & $bText Then
   $bFile = _BinaryReplace($bFile, $Id & $bOldTextLen & $bOldText, $Id & $bTextLen & $bText, 1)
   Endif
Next
$hFile = FileOpen ("NEW_localisation.loc", 2+16)
FileWrite ($hFile, $bFile)
FileClose ($hFile)
Func _HexSearch($FilePath, $BinaryValue, $StartOffset = Default)    
        Local $Buffer, $ptr, $hFile, $Result, $Read, $SearchValue, $Pos, $BufferSize = 2048
            If $StartOffset = Default       Then    $StartOffset = 0
            If Not FileExists($FilePath)    Then    Return SetError(1, @error, 0)
            $fLen = FileGetSize($FilePath)
            If $StartOffset > $fLen         Then    Return SetError(2, @error, 0)
            If Not IsBinary($BinaryValue)   Then    Return SetError(3, @error, 0)
            If Not IsNumber($StartOffset)   Then    Return SetError(4, @error, 0)
            $SearchValue = BinaryToString($BinaryValue)
            $Buffer = DllStructCreate("byte[" & $BufferSize & "]")
            $ptr = DllStructGetPtr($Buffer)
                $hFile = _WinAPI_CreateFile($FilePath, 2, 2, 1)
                If $hFile = 0 Then Return SetError(5, @error, 0)
            $Result = _WinAPI_SetFilePointer($hFile, $StartOffset)
            $err = @error
            If $Result = 0xFFFFFFFF Then
                _WinAPI_CloseHandle($hFile)
                Return SetError(5, $err, 0)
            EndIf
            $Pos = $StartOffset
            While True
                    $Read = 0
                    $Result = _WinAPI_ReadFile($hFile, $ptr, $BufferSize, $Read)
                    $err = @error
                    If Not $Result Then
                        _WinAPI_CloseHandle($hFile)
                        Return SetError(6, $err, 0)
                    EndIf
                    $Result = DllStructGetData($Buffer, 1)
                    $Result = BinaryToString($Result)
                    $Result = StringInStr($Result, $SearchValue)
                    If $Result > 0 Then ExitLoop
                    If $Read < $BufferSize Then
                        _WinAPI_CloseHandle($hFile)
                        Return -1
                    EndIf
                    $Pos += $Read
            WEnd
            _WinAPI_CloseHandle($hFile)
            If Not $Result Then Return SetError(7, @error, 0)
            $Result = $Pos + $Result - 1
            Return $Result
		 EndFunc
TrayTip ("Importer", "Finish!", 3)
sleep (2000)