#Include <File.au3>
#include <Binary.au3>
$MsgDir = FileSelectFolder ("Select the MSG folder...", "", "", @ScriptDir)
If $MsgDir = "" Then
   Exit
EndIf
$Lang = InputBox("Language", "Type the language you want to export."&@CRLF&"eng, pol, ...", "", " M3")
$Names = _FileListToArray($MsgDir, "*"&$Lang&".gmd", 1)
If $Names = "" Then
	MsgBox(0,"Error","There are no gmd files in the folder,"&@CR&"or you type wrong language.")
	Exit
EndIf
Dim $Text
$File = FileOpen ($MsgDir &"\"& $Names[1], 0+16)
$Id = FileRead($File,3)
FileClose($File)
If $Id = "GMD" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
For $i=1 to $Names[0]
	$File = FileOpen ($MsgDir &"\"& $Names[$i], 0+16)
	If $Endian = 0 Then
		FileSetPos($File,20,0)
		$Ids = _BinaryToInt32(FileRead ($File, 4))
		$Files = _BinaryToInt32(FileRead ($File, 4))
		$Idsz = _BinaryToInt32(FileRead ($File, 4))
	Else
		FileSetPos($File,20,0)
		$Ids = Dec(Hex(FileRead($File, 4)))
		$Files = Dec(Hex(FileRead($File, 4)))
		$Idsz = Dec(Hex(FileRead($File, 4)))
	EndIf
	FileRead ($File, 4)
	$Val = FileRead($File, 4)
	If $Endian = 0 Then
		Filesetpos($File,40+_BinaryToInt32($Val)+1+$Ids*8+$Idsz,0)
	Else
		Filesetpos($File,40+Dec(Hex(($Val)))+1+$Ids*8+$Idsz,0)
	EndIf
	For $n = 1 to $Files
		$S = ""
		$Str = ""
		Do
			$Str &= $S
			$S = FileRead ($File, 1)
		Until $S = 0
		$Str = BinaryToString("0x" & StringRegExpReplace($Str,"0x",""),4)
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
	Next
	FileClose($File)
Next
$hTextFile = FileOpen ("RER_Text_"&$Lang&".txt", 2+256)
FileWrite ($hTextFile, $Text)
FileClose ($hTextFile)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)