#include <File.au3>
#include <Binary.au3>
Dim $NEWdata, $num = 1
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
$Lang = InputBox("Language", 'Type "eng" if you want to import english only.'&@CR&@CR&'Type "all" if you want to import all languages.', "", " M3")
If $Lang <> "eng" and $Lang <> "all" Then Exit
If $Lang = "eng" Then
	$Asize = 1
Else
	$Asize = FileGetSize($Name)-1
EndIf
$Newfile = Binary("0x00")
Do
$pos = FileGetPos($File)
$Files = _BinaryToInt32(FileRead($File,4))
For $i = 1 to $Files
	$sNum = FileRead($File,4)
	For $n = 1 to $sNum
	$Len = _BinaryToInt32(FileRead($File,1))
	If $Len >= 128 Then
		$Len = $Len + ((_BinaryToInt32(FileRead($File,1))-1)*128)
	EndIf
	FileRead($File,$Len)
	Next
Next
FileRead($File,$Files*8)
$pos2 = FileGetPos($File)
FileSetPos($File,$pos,0)
$Newfile &= FileRead($File,$pos2 - $pos)
$Files = FileRead($File,4)
$Newfile &= $Files
For $i = 1 to $Files
	$Len = _BinaryToInt32(FileRead($File,1))
	If $Len >= 128 Then
		$Len = $Len + ((_BinaryToInt32(FileRead($File,1))-1)*128)
	EndIf
	FileRead($File,$Len)
	$NEWdata[$num] = StringRegExpReplace($NEWdata[$num],"<cf>",@CRLF)
	$NEWdata[$num] = StringRegExpReplace($NEWdata[$num],"<lf>",@LF)
	$NEWdata[$num] = StringRegExpReplace($NEWdata[$num],"<cr>",@CR)
	$NewText = StringToBinary($NEWdata[$num],4)
	$num += 1
	$Len = BinaryLen($NewText)
	$Div = Int($Len/128)
	If $Div > 0 Then
		$Len = $Len+(128*($Div+1))
		$Newfile &= _BinaryReverse(Binary("0x" & Hex($Len,4))) & $NewText
	Else
		$Newfile &= Binary("0x" & Hex($Len,2)) & $NewText
	EndIf
Next
Until FileGetPos($File) > $Asize
$Newfile &= FileRead($File)
$hNewfile = FileOpen("NEW_"&$Name, 2+16)
FileWrite($hNewfile, BinaryMid($Newfile,2))
FileClose($hNewfile)
TrayTip("Importer", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc