$Path = FileOpenDialog("Select the STRDB file", @ScriptDir, "strdb files (*.strdb)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
$Name = CompGetFileName($Path)
$Id = FileRead($File,4)
If $Id = "SKDB" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
FileRead($File,4)
If $Endian = 0 Then
	$Head = _BinaryToInt32(FileRead($File,4))
Else
	$Head = Dec(Hex(FileRead($File, 4)))
EndIf
If $Endian = 0 Then
	$Files = _BinaryToInt32(FileRead($File,4))
Else
	$Files = Dec(Hex(FileRead($File, 4)))
EndIf
FileRead($File,12)
$Baseoff = $Files*8+$Head
Dim $Text
For $i = 1 to $Files
	FileRead($File,4)
	If $Endian = 0 Then
		$Offset = _BinaryToInt32(FileRead($File,4))*2+$Baseoff
	Else
		$Offset = Dec(Hex(FileRead($File, 4)))*2+$Baseoff
	EndIf
	$pos = FileGetPos($File)
	FileSetPos($File,$Offset,0)
	$S = ""
	$Str = ""
	Do
		If $Endian = 0 Then
			$Str &= BinaryToString($S,2)
		Else
			$Str &= BinaryToString($S,3)
		EndIf
		$S = FileRead ($File, 2)
	Until $S = 0
	$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
	$Str = StringRegExpReplace($Str,@LF,"<lf>")
	$Str = StringRegExpReplace($Str,@CR,"<cr>")
	$Text &= $Str & @CRLF
	FileSetPos($File,$pos,0)
Next
If $Endian = 0 Then
	$hAllTextFil = FileOpen ($Name&".txt", 2+32)
Else
	$hAllTextFil = FileOpen ($Name&".txt", 2+64)
EndIf
FileWrite ($hAllTextFil, $Text)
FileClose ($hAllTextFil)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func _BinaryToInt32($Binary)
	Return BitAND(Int(Binary($Binary)), 0xFFFFFFFF)
EndFunc