#Include <Binary.au3>
#include <WinAPI.au3>
$sScriptName = "The Case of the Silver Earring Importer"
$sAllTextFilePath = FileOpenDialog("Select the TXT file...", @ScriptDir, "text files (*.txt)|All (*.*)", 1)
If $sAllTextFilePath = "" Then
	Exit
EndIf
$hAllTextFile = FileOpen ($sAllTextFilePath, 0+32)
$sAllText = FileRead($hAllTextFile)
FileClose ($hAllTextFile)
$a=StringRegExp($sAllText&'[', '(?s)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n=UBound($a)
Dim $aAllText[Int($n/2)]
For $i = 0 to $n-1 Step 2
    $aAllText[$i/2]=$a[$i+1]
 Next
$sLocbFilePath = FileOpenDialog("Select the tbl file", @ScriptDir, "tbl files (*.tbl)|All files (*.*)",1)
If @error = 1 Then
		Exit
	EndIf
$hLocbfile = FileOpen ($sLocbFilePath, 0+16)
$bLocbfile = FileRead ($hLocbfile)
FileClose ($hLocbfile)
$Name = CompGetFileName($sLocbFilePath)
$DSRC = StringToBinary("DSRC")
$DSRCpos = _HexSearch($sLocbFilePath, $DSRC)
$MSRCpos = _BinaryToInt32(Binarymid ($bLocbfile, $DSRCpos+5, 4)) + $DSRCpos + 9
$DSRC = Binarymid ($bLocbfile, 1, $DSRCpos+8)
$MSRC = Binarymid ($bLocbfile, $MSRCpos)
$plus = Binary ("0x" & Hex (00, 4))
Dim $DSRCsize = 0, $Pos = 0 
For $i = 1 To $n/2
   $bNewText = StringToBinary ($aAllText[$i-1],2)
   $bNewText &= $plus
   $Offset = _BinaryReverse(Binary ("0x" & Hex ($DSRCpos+8+$DSRCsize, 8)))
   $NewLen = Dec(Hex (BinaryLen ($bNewText), 8))
   $DSRCsize += $NewLen
   $DSRC &= $bNewText
   $MSRC = _BinaryPoke($MSRC, $Pos+25, $Offset, "dword")
   $Pos += 12
Next
$bDSRCsize = _BinaryReverse(Binary ("0x" & Hex ($DSRCsize, 8)))
$DSRC = _BinaryPoke($DSRC, $DSRCpos+5, $bDSRCsize, "dword")
$NewFile=$DSRC&$MSRC
   $hNewFile = FileOpen ($Name&"_new", 2+16)
   FileWrite ($hNewFile, $NewFile)
   FileClose ($hNewFile)
MsgBox(0, $sScriptName, "Finish!")
Func _HexSearch($FilePath, $BinaryValue, $StartOffset = Default)    
        Local $Buffer, $ptr, $hFile, $Result, $Read, $SearchValue, $Pos, $BufferSize = 2048
            If $StartOffset = Default       Then    $StartOffset = 0
            If Not FileExists($FilePath)    Then    Return SetError(1, @error, 0)
            $fLen = FileGetSize($FilePath)
            If $StartOffset > $fLen         Then    Return SetError(2, @error, 0)
            If Not IsBinary($BinaryValue)   Then    Return SetError(3, @error, 0)
            If Not IsNumber($StartOffset)   Then    Return SetError(4, @error, 0)
            $SearchValue = BinaryToString($BinaryValue)
            $Buffer = DllStructCreate("byte[" & $BufferSize & "]")
            $ptr = DllStructGetPtr($Buffer)
                $hFile = _WinAPI_CreateFile($FilePath, 2, 2, 1)
                If $hFile = 0 Then Return SetError(5, @error, 0)
            $Result = _WinAPI_SetFilePointer($hFile, $StartOffset)
            $err = @error
            If $Result = 0xFFFFFFFF Then
                _WinAPI_CloseHandle($hFile)
                Return SetError(5, $err, 0)
            EndIf
            $Pos = $StartOffset
            While True
                    $Read = 0
                    $Result = _WinAPI_ReadFile($hFile, $ptr, $BufferSize, $Read)
                    $err = @error
                    If Not $Result Then
                        _WinAPI_CloseHandle($hFile)
                        Return SetError(6, $err, 0)
                    EndIf
                    $Result = DllStructGetData($Buffer, 1)
                    $Result = BinaryToString($Result)
                    $Result = StringInStr($Result, $SearchValue)
                    If $Result > 0 Then ExitLoop
                    If $Read < $BufferSize Then
                        _WinAPI_CloseHandle($hFile)
                        Return -1
                    EndIf
                    $Pos += $Read
            WEnd
            _WinAPI_CloseHandle($hFile)
            If Not $Result Then Return SetError(7, @error, 0)
            $Result = $Pos + $Result - 1
            Return $Result
		 EndFunc
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
	EndFunc