#include<binary.au3>
#include<file.au3>
Dim $Text
If $CmdLine[0] <> 0 Then
	$Ext = CompGetFileExt($CmdLine[1])
	If $Ext = ".asr" Then
		$File = fileopen($CmdLine[1],16)
		$Asrid = FileRead ($File, 8)
		If $Asrid <> "Asura   " Then
			MsgBox(0,"Error!",'Wrong id: "'&BinaryToString($Asrid)&'"'&@CR&'Expected: "Asura   "')
			Exit
		EndIf
		$Id = FileRead ($File, 4)
		If $Id = "HTXT" Then
			FileSetPos($File,24,0)
			$Files = _BinaryToInt32(FileRead ($File, 4))
			FileRead($File, 12)
			For $i = 1 to $Files
				FileRead($File,4)
				$Len = _BinaryToInt32(FileRead($File,4))*2
				$Str = BinaryToString(FileRead($File,$Len),2)
				$Str = StringTrimRight($Str,1)
				$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
				$Str = StringRegExpReplace($Str,@LF,"<lf>")
				$Str = StringRegExpReplace($Str,@CR,"<cr>")
				$Text &= $Str & @CRLF
			Next
			$hTextFile = FileOpen (CompGetFileName($CmdLine[1])&".txt", 2+32)
			FileWrite ($hTextFile, $Text)
			FileClose ($hTextFile)
			FileClose ($File)
		Else
			MsgBox(0,"Error!",'Wrong id: "'&BinaryToString($Id)&'"'&@CR&'Expected: "HTXT"')
			Exit
		EndIf
	Else
		$Names = _FileListToArray($CmdLine[1], "*.dlln", 1)
		If $Names = "" Then
			MsgBox(0,"Error!","There are no dlln files in the folder!")
			Exit
		EndIf
		For $i=1 to $Names[0]
			$File = FileOpen ($CmdLine[1] &"\"& $Names[$i], 0+16)
			FileSetPos($File,16,0)
			$S = ""
			$p = 0
			Do
				$p += 1
				$S = FileRead ($File, 1)
			Until $S = 0
			$Pad = 4 - Mod($p,4)
			If $Pad > 0 And $Pad < 4 Then FileRead($File,$Pad)
			FileRead($File,25)
			$Len = _BinaryToInt32(FileRead($File,4))*2
			$Str = BinaryToString(FileRead($File,$Len),2)
			$Str = StringTrimRight($Str,1)
			$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
			$Str = StringRegExpReplace($Str,@LF,"<lf>")
			$Str = StringRegExpReplace($Str,@CR,"<cr>")
			$Text &= $Str & @CRLF
			FileClose ($File)
		Next
		$hTextFile = FileOpen (CompGetFileName($CmdLine[1])&".txt", 2+32)
		FileWrite ($hTextFile, $Text)
		FileClose ($hTextFile)
	EndIf
Else
	MsgBox(0, "Drag & Drop", "Drag an asr file or a folder to the exe.")
	Exit
EndIf
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileExt($Path,$Dot=True)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        $ret = StringSplit($ret[UBound($ret)-1],".",2)
        If IsArray($ret) Then
            If $Dot Then
                $Dot = "."
            Else
                $Dot = ""
            EndIf
            Return $Dot & $ret[UBound($ret)-1]
        EndIf
    EndIf
    If @error Then Return -1
EndFunc
Func CompGetFileName($Path)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        Return $ret[UBound($ret)-1]
    EndIf
    If @error Then Return -1
EndFunc