#include <Binary.au3>
#include <File.au3>
Dim $NEWdata
If $CmdLine[0] <> 0 Then
_FileReadToArray($CmdLine[1],$NEWdata)
$Name = StringTrimRight(CompGetFileName($CmdLine[1]),4)
$Ext = CompGetFileExt($Name)
$plus = Binary ("0x" & Hex (0, 4))
If $Ext = ".asr" Then
	$File = FileOpen ($Name, 0+16)
	If $File = -1 Then
		MsgBox(0,"Error","Cant find "&$Name&" file.")
		Exit
	EndIf
	$OrigSize = FileGetSize($Name)
	$bFile = FileRead($File)
	FileSetPos($File,24,0)
	$Files = _BinaryToInt32(FileRead ($File, 4))
	FileSetPos($File,32,0)
	$Unk = _BinaryToInt32(FileRead ($File, 4))
	FileSetPos($File,0,0)
	$Newfile = FileRead($File,40)
	For $i = 1 to $Files
		$Newfile &= FileRead($File,4)
		FileRead($File,_BinaryToInt32(FileRead ($File, 4))*2)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
		$NewText = StringToBinary ($NEWdata[$i],2) & $plus
		$Len = Int(BinaryLen($NewText)/2)
		$Newfile &= _BinaryReverse(Binary ("0x" & Hex ($Len, 8))) & $NewText
	Next
	$StrSize = BinaryLen($Newfile)-40-($Files*8)
	$Newfile &= FileRead($File)
	$Asize = BinaryLen($Newfile)-24
	$Diff = $Asize - $OrigSize
	$Newfile = _BinaryPoke($Newfile, 13, $Asize, "dword")
	$Newfile = _BinaryPoke($Newfile, 33, $StrSize, "dword")
	$hNewFile = FileOpen ("NEW_"&$Name, 2+16)
	FileWrite ($hNewFile, $Newfile)
	FileClose ($hNewFile)
	FileClose ($File)
Else
	$OrigSize = DirGetSize($Name)+8
	$Names = _FileListToArray($Name, "*.dlln", 1)
	If $Names = "" Then
		MsgBox(0,"Error!","There are no dlln files in the .\"&$Name&"\ folder!")
		Exit
	EndIf
For $i=1 to $Names[0]
	$File = FileOpen ($Name &"\"& $Names[$i], 0+16)
	FileSetPos($File,16,0)
	$S = ""
	$p = 0
	Do
		$p += 1
		$S = FileRead ($File, 1)
	Until $S = 0
	$Pad = 4 - Mod($p,4)
	If $Pad > 0 And $Pad < 4 Then FileRead($File,$Pad)
	FileRead($File,25)
	$pos = FileGetPos($File)
	FileSetPos($File,0,0)
	$Newfile = FileRead($File,$pos)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$NewText = StringToBinary ($NEWdata[$i],2) & $plus
	$Len = Int(BinaryLen($NewText)/2)
	$Newfile &= _BinaryReverse(Binary ("0x" & Hex ($Len, 8))) & $NewText
	$Newfile = _BinaryPoke($Newfile,5,BinaryLen($Newfile),"dword")
	$hNewfile = FileOpen ($Name &"\"& $Names[$i], 2+16)
	FileWrite($hNewfile,$Newfile)
	FileClose($hNewfile)
	FileClose($File)
Next
	$Size = DirGetSize($Name)+8
	$Diff = $Size - $OrigSize
	If FileExists($Name & "\File000.FNFO") Then
		$File = FileOpen($Name & "\File000.FNFO",1+16)
		FileSetPos($File,16,0)
		FileWrite($File,_BinaryReverse(Binary("0x" & Hex($Size,8))))
		FileClose($File)
	EndIf
	$Asts = _FileListToArray($Name, "*.asts", 1)
	If $Asts <> "" Then
		$File = FileOpen ($Name &"\"& $Asts[1], 1+16)
		FileSetPos($File,16,0)
		$Files = FileRead($File,4)
		FileRead($File,1)
		For $i = 1 to $Files
			$p = 0
			$S = ""
			Do
				$p += 1
				$S = FileRead($File,1)
			Until $S = 0
			$Pad = 4 - Mod($p,4)
			If $Pad > 0 And $Pad < 4 Then FileRead($File,$Pad+5)
			$Size = _BinaryToInt32(FileRead($File,4))+$Diff
			FileSetPos($File,FileGetPos($File)-4,0)
			FileWrite($File,_BinaryReverse(Binary("0x" & Hex($Size,8))))
			FileRead($File,4)
		Next
	EndIf
	FileClose($File)
EndIf
Else
	MsgBox(0, "Drag & Drop", "Drag the txt file to the exe.")
	Exit
EndIf
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
Func CompGetFileExt($Path,$Dot=True)
    If StringLen($Path) < 4 Then Return -1
    $ret = StringSplit($Path,"\",2)
    If IsArray($ret) Then
        $ret = StringSplit($ret[UBound($ret)-1],".",2)
        If IsArray($ret) Then
            If $Dot Then
                $Dot = "."
            Else
                $Dot = ""
            EndIf
            Return $Dot & $ret[UBound($ret)-1]
        EndIf
    EndIf
    If @error Then Return -1
EndFunc