#NoTrayIcon
#include <File.au3>
#include <Binary.au3>
Dim $NEWdata
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
$Files = _BinaryToInt32(FileRead($File, 4))
$Offset = ($Files*12)+4
FileSetPos($File,0,0)
$NewfileHead = FileRead($File,$Offset)
$NewfileText = Binary ("0x" & Hex (0, 2))
$Pos = 0
ProgressOn("Superpower 2 Importer", "Working...","",300,300,2+16)
For $i = 1 To $Files
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
	$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
	$bNewText = StringToBinary ($NEWdata[$i],2)
	$NewLen = BinaryLen ($bNewText)
	$NewfileHead = _BinaryPoke($NewfileHead, 9+$Pos, $Offset, "dword")
	$NewfileHead = _BinaryPoke($NewfileHead, 13+$Pos, $NewLen, "dword")
	$NewfileText &= $bNewText
	$Offset += $NewLen
	$Pos += 12
	ProgressSet(int($i/($Files/100)))
Next
$NewfileText = BinaryMid($NewfileText,2)
$hNewfile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewfile, $NewfileHead&$NewfileText)
FileClose ($hNewfile)
ProgressSet(100, "Done!")
Sleep(750)
ProgressOff()
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc