#include <File.au3>
#include <Binary.au3>
#include <ArrayNaturalSort.au3>
Dim $NEWdata, $Num = 0
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Dir = StringTrimRight($TxtPath,4)
$Names = _FileListToArrayRec($Dir, "*.SoundNodeWave", 1,1)
If $Names = "" Then
	MsgBox(0,"Error","There are no .SoundNodeWave files in the "&@cr&CompGetFileName($Dir)&" folder, or the folder not exist.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
For $i=1 to $Names[0]
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,98,0)
	If FileRead($File,4) = 4 Then
		$pos = 210
	Else
		$pos = 185
	EndIf
	FileSetPos($File,$pos,0)
	$BlockSize = FileRead($File,4)
	If $BlockSize <> "0x04000000" Then
		FileSetPos($File,0,0)
		$Newfile = FileRead($File,$pos+24+_BinaryToInt32($BlockSize))
		$BlockSize = _BinaryToInt32(FileRead($File,4))
		$Old1 = FileRead($File, 52)
		$StringBlock = _BinaryToInt32(FileRead($File,4))
		$Old2 = FileRead($File, 24)
		FileRead($File,8)
		$Str = $NEWdata[$Num+$i]
		$Str = StringRegExpReplace($Str,"<cf>",@CRLF)
		$Str = StringRegExpReplace($Str,"<lf>",@LF)
		$Str = StringRegExpReplace($Str,"<cr>",@CR)
		$OldStrLen = _BinaryToInt32(FileRead($File, 4))
		If $OldStrLen = 0 Then
			$NewText = _BinaryReverse(Binary("0x" & Hex(4,8))) & Binary("0x" & Hex(0,16))
			$Dif = 0
		Else
			If $OldStrLen < 0 Then
				$OldLen = -_BinaryToInt32($OldStrLen)*2
				FileRead($File,$OldLen)
				$NewText = StringToBinary($Str,2) & Binary("0x0000")
				$NewLen = BinaryLen($NewText)
				$Dif = $NewLen - $OldLen
				$NewText = _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex(-int($NewLen/2),8))) & $NewText
			Else
				$OldLen = _BinaryToInt32($OldStrLen)
				FileRead($File,$OldLen)
				$NewText = StringToBinary($Str) & Binary("0x00")
				$NewLen = BinaryLen($NewText)
				$Dif = $NewLen - $OldLen
				$NewText = _BinaryReverse(Binary("0x" & Hex($NewLen+4,8))) & Binary("0x00000000") & _BinaryReverse(Binary("0x" & Hex($NewLen,8))) & $NewText
			EndIf
		EndIf
		$Newfile = $Newfile & _BinaryReverse(Binary("0x" & Hex($BlockSize+$Dif,8))) & $Old1 & _BinaryReverse(Binary("0x" & Hex($StringBlock+$Dif,8))) & $Old2 & $NewText & FileRead($File)
		$Asize = FileGetSize($Dir &"\"& $Names[$i]) - 68
		FileSetPos($File,$Asize,0)
		$End1 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileRead($File, 12)
		$End2 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileRead($File, 12)
		$End3 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileRead($File, 12)
		$End4 = _BinaryToInt32(FileRead($File, 4))+$Dif
		FileRead($File, 12)
		$End5 = _BinaryToInt32(FileRead($File, 4))+$Dif
		$Newsize = BinaryLen($Newfile)
		$Newfile = _BinaryPoke($Newfile, $Newsize-67, $End1, "dword")
		$Newfile = _BinaryPoke($Newfile, $Newsize-51, $End2, "dword")
		$Newfile = _BinaryPoke($Newfile, $Newsize-35, $End3, "dword")
		$Newfile = _BinaryPoke($Newfile, $Newsize-19, $End4, "dword")
		$Newfile = _BinaryPoke($Newfile, $Newsize-3, $End5, "dword")
		$hNewfile = FileOpen ($Dir &"\"& $Names[$i], 2+16)
		FileWrite ($hNewfile, $Newfile)
		FileClose ($hNewfile)
Else
	$Num -= 1
EndIf
FileClose ($File)
Next
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc