#include<Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
$Path = FileOpenDialog("Select the DLG file", @ScriptDir, "dlg files (*.dlg)",1)
If @error = 1 Then Exit
$File = fileopen($Path,16)
$Name = CompGetFileName($Path)
Dim $Text
If FileRead($File,4) = "0x05000000" Then
	$Endian = 0
Else
	$Endian = 1
EndIf
If $Endian = 0 Then
	$Files = _BinaryToInt32(FileRead($File,4))
Else
	$Files = Dec(Hex(FileRead($File,4)))
EndIf
FileRead($File,4)
For $i = 1 to $Files
	FileRead($File,8)
	If $Endian = 0 Then
		$Size = _BinaryToInt32(FileRead($File,2))
	Else
		$Size = Dec(Hex(FileRead($File,2)))
	EndIf
	FileRead($File,$Size)
	If $Endian = 0 Then
		$Size = _BinaryToInt32(FileRead($File,2))*2
		$Str = StringTrimRight(BinaryToString(FileRead($File,$Size),2),1)
	Else
		$Size = Dec(Hex(FileRead($File,2)))*2
		$Str = StringTrimRight(BinaryToString(FileRead($File,$Size),3),1)
	EndIf
	$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
	$Str = StringRegExpReplace($Str,@LF,"<lf>")
	$Str = StringRegExpReplace($Str,@CR,"<cr>")
	$Text &= $Str & @CRLF
Next
FileRead($File,4)
If $Endian = 0 Then
	$BlockNum = _BinaryToInt32(FileRead($File,4))
Else
	$BlockNum = Dec(Hex(FileRead($File,4)))
EndIf
Dim $Offsets[$BlockNum]
For $i = 1 to $BlockNum
	FileRead($File,4)
	If $Endian = 0 Then
		$Offsets[$i-1] = _BinaryToInt32(FileRead($File,4))
	Else
		$Offsets[$i-1] = Dec(Hex(FileRead($File,4)))
	EndIf
Next
For $i = 1 to $BlockNum
	FileSetPos($File,$Offsets[$i-1],0)
	If $Endian = 0 Then
		$Files = _BinaryToInt32(FileRead($File,4))
	Else
		$Files = Dec(Hex(FileRead($File,4)))
	EndIf
	FileRead($File,4)
	For $f = 1 to $Files
		FileRead($File,8)
		If $Endian = 0 Then
			$Size = _BinaryToInt32(FileRead($File,2))
		Else
			$Size = Dec(Hex(FileRead($File,2)))
		EndIf
		FileRead($File,$Size)
		If $Endian = 0 Then
			$Size = _BinaryToInt32(FileRead($File,2))*2
			$Str = StringTrimRight(BinaryToString(FileRead($File,$Size),2),1)
		Else
			$Size = Dec(Hex(FileRead($File,2)))*2
			$Str = StringTrimRight(BinaryToString(FileRead($File,$Size),3),1)
		EndIf
		$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
		$Str = StringRegExpReplace($Str,@LF,"<lf>")
		$Str = StringRegExpReplace($Str,@CR,"<cr>")
		$Text &= $Str & @CRLF
	Next
Next
If $Endian = 0 Then
	$hFile = FileOpen ($Name&".txt", 2+32)
Else
	$hFile = FileOpen ($Name&".txt", 2+64)
EndIf
FileWrite ($hFile, $Text)
FileClose ($hFile)
TrayTip ("Exporter", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc