#Include <File.au3>
#Include <Array.au3>
#include <Binary.au3> 
$sScriptName = "Toy Soldiers Text Exporter"
$sOLDFilePath = FileOpenDialog("Select the ToySoldiers.orig file", @ScriptDir, "orig file (*.orig)|All (*.*)",1)
	If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
	$hOLDfile = FileOpen ($sOLDFilePath, 0+32) 
	$bOLDfile = FileRead ($hOLDfile)
	FileClose ($hOLDfile)
$a1=StringRegExp($bOLDfile&'[', '(?s)(\[.*?\])(?:\r\n)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n1=UBound($a1)
Dim $OLDdata[$n1]
For $i = 0 to $n1-3 Step 3
    $OLDdata[$i] = StringTrimRight (StringTrimLeft ($a1[$i], 1), 1)
	$OLDdata[$i+1] = StringTrimRight (StringTrimLeft ($a1[$i+1], 1), 1)
    $OLDdata[$i+2]=$a1[$i+2]
Next	

$sNEWFilePath = FileOpenDialog("Select the TXT file", @ScriptDir, "ToySoldiersText (*.txt)|All (*.*)",1)
	If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
	$hNEWfile = FileOpen ($sNEWFilePath, 0+32) 
	$bNewfile = FileRead ($hNEWfile)
	FileClose ($hNEWfile)
$a2=StringRegExp($bNEWfile&'[', '(?s)(\[.*?\])(?:\r\n)(.*?)(?=\r\n\[)', 3)
$n2=UBound($a2)
Dim $NEWdata[Int($n2/2)]
For $i = 0 to $n2-2 Step 2
    $NEWdata[$i/2]=$a2[$i+1]
Next

$FilePath = FileOpenDialog("Select the locb file", @ScriptDir, "Toy Soldiers (*.locb)|All (*.*)",1)
	If @error = 1 Then
		MsgBox (0, "Error", "No file selected!")
		Exit
	EndIf
	$hFile = FileOpen ($FilePath, 0+16) 
	$bFile = FileRead ($hFile)
	FileClose ($hFile)
	
MsgBox(0, "Working", "Please wait, this will take some minutes!" & @CRLF & "Click the OK button, and wait for finish!")
$k=2
$Pos = 0
$Diff = 0
$BaseOff = Dec (Hex (_BinaryReverse(Binarymid ($bFile, 77, 3)), 4))+1
$plus = Binary ("0x" & Hex (00, 2))
For $i=0 To ($n2/2)-1
   $bNEWText = StringToBinary ($NEWdata[$i],2)
   $bOLDText = StringToBinary ($OLDdata[$k],2)
   $OLDTextLen = Int($OLDdata[$k-1])
   $NEWTextLen = Int((Dec(Hex (BinaryLen ($bNEWText), 8)))+2)/2
   $NewOff = Int($OLDdata[$k-2])
   $NewOff += $Diff*2
   $Diff += $NEWTextLen - $OLDTextLen
   $bNewOff = _BinaryReverse(Binary ("0x" & Hex (Int($NewOff), 8)))
   $bNEWTextLen = _BinaryReverse(Binary ("0x" & Hex (Int($NEWTextLen), 8)))
   $bFile = _BinaryPoke($bFile, $BaseOff+$Pos+4, $bNEWTextLen, "dword")
   $bOLDText = $plus & $bOLDText & $plus & $plus
   $bNEWText = $plus & $bNEWText & $plus & $plus
   If $bOLDText <> $bNEWText Then
   $bFile = _BinaryReplace($bFile, $bOLDText, $bNEWText, 1)
   EndIf
   $bFile = _BinaryPoke($bFile, $BaseOff+$Pos, $bNewOff, "dword")
   $Pos += 12
   $k += 3
Next
   $hFile = FileOpen ($FilePath, 2+16)
   FileWrite ($hFile, $bFile)
   FileClose ($hFile)
MsgBox(0, "End", "Finish!")