#Include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
#include <ArrayNaturalSort.au3> ;NaturalCompare, https://www.autoitscript.com/forum/topic/83626-natural-order-string-comparison/
$Dir = FileSelectFolder ("Select the folder...", "", "", @ScriptDir)
If $Dir = "" Then
   Exit
EndIf
$Names = _FileListToArrayRec($Dir, "*.SoundNodeWave", 1,1)
If $Names = "" Then
	MsgBox(0,"No files","There are no SoundNodeWave files in the folder.")
	Exit
EndIf
_ArrayNaturalSort($Names,0,1)
Dim $Text, $Skiplist
For $i=1 to $Names[0]
	$skip = 0
	$File = FileOpen ($Dir &"\"& $Names[$i], 0+16)
	FileSetPos($File,132,0)
	$FirstSize = FileRead($File,4)
	If $FirstSize <> 1294 Then
		If $FirstSize <> "0x04000000" Then
			FileSetPos($File,132+60+_BinaryToInt32($FirstSize),0)
			$Num = FileRead($File,4)
			FileSetPos($File,132+88+_BinaryToInt32($FirstSize),0)
			For $n = 1 to $Num
				$Len = _BinaryToInt32(FileRead($File,4))
				If $Len < 0 Then
					$Len = -$Len*2
					$Str = BinaryToString(FileRead($File,$Len),2)
					$Str = StringTrimRight($Str,1)
				Else
					$Str = BinaryToString(FileRead($File,$Len))
					$Str = StringTrimRight($Str,1)
				EndIf
				FileRead($File,60)
				$Str = StringRegExpReplace($Str,@CRLF,"<cf>")
				$Str = StringRegExpReplace($Str,@LF,"<lf>")
				$Str = StringRegExpReplace($Str,@CR,"<cr>")
				$Text &= $Str & @CRLF
			Next
		EndIf
	EndIf
	FileClose($File)
Next
$hFile = FileOpen (CompGetFileName($Dir)&".txt", 2)
FileWrite($hFile, $Text)
FileClose($hFile)
TrayTip("Exporter", "Finish!", 3)
sleep(3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc
