#include <File.au3>
#include <Binary.au3> ;Binary UDF, https://www.autoitscript.com/forum/topic/131037-binary-udf/
Dim $NEWdata, $f = 1, $pos = 20
$TxtPath = FileOpenDialog("Select the TXT file", @ScriptDir, "text files (*.txt)",1)
If @error = 1 Then Exit
_FileReadToArray($TxtPath,$NEWdata)
$Name = StringTrimRight(CompGetFileName($TxtPath),4)
$File = FileOpen ($Name, 0+16)
If $File = -1 Then
MsgBox(0,"Error","Can't open "&$Name&" file.")
Exit
EndIf
FileSetPos($File,12,0)
If FileRead($File,4) = "0x04000100" Then
	FileSetPos($File,0,0)
	$Newfile = FileRead($File,20)
	Do
		FileSetPos($File,$pos,0)
		$Newfile &= FileRead($File,12)
		$Size = FileRead($File,2)
		$Num = FileRead($File,2)
		$NewText = $Num
		For $n = 1 to $Num
			$NEWdata[$f] = StringRegExpReplace($NEWdata[$f],"<cf>",@CRLF)
			$NEWdata[$f] = StringRegExpReplace($NEWdata[$f],"<lf>",@LF)
			$NEWdata[$f] = StringRegExpReplace($NEWdata[$f],"<cr>",@CR)
			$NewText &= StringToBinary($NEWdata[$f],4) & Binary("0x0000")
			$f += 1
		Next
		$Len = BinaryLen($NewText)-2
		$Pad = 4 - Mod($Len,4)
		If $Pad > 0 And $Pad < 4 Then
			$NewText &= Binary("0x" & Hex(0,$Pad*2))
		EndIf
		$Len = BinaryLen($NewText)-2
		$Newfile &= _BinaryReverse(Binary("0x" & Hex($Len,4))) & $NewText
		FileRead($File,$Size)
		$pos = FileGetPos($File)
	Until FileRead($File,4) = "0xffffffff"
	$Newfile &= Binary("0xffffffff")
Else
	FileSetPos($File,4,0)
	$Files = _BinaryToInt32(FileRead($File,4))
	$Offset = $Files*12+8
	$pos = 9
	FileSetPos($File,0,0)
	$NewfileHead = FileRead($File,$Offset)
	$NewfileText = Binary("0x00")
	For $i = 1 to $Files
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cf>",@CRLF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<lf>",@LF)
		$NEWdata[$i] = StringRegExpReplace($NEWdata[$i],"<cr>",@CR)
		$NewText = StringToBinary($NEWdata[$i],4) & Binary("0x00")
		$Len = BinaryLen($NewText)
		$NewfileText &= $NewText
		$NewfileHead = _BinaryPoke($NewfileHead,$pos,$Offset,"dword")
		$NewfileHead = _BinaryPoke($NewfileHead,$pos+4,$Len,"dword")
		$Offset += $Len
		$pos += 12
	Next
	$Newfile = $NewfileHead & BinaryMid($NewfileText,2)
EndIf
$hNewfile = FileOpen ("NEW_"&$Name, 2+16)
FileWrite ($hNewfile, $Newfile)
FileClose ($hNewfile)
TrayTip ("Importer", "Finish!", 3)
sleep (3000)
Func CompGetFileName($Path)
If StringLen($Path) < 4 Then Return -1
$ret = StringSplit($Path,"\",2)
If IsArray($ret) Then
Return $ret[UBound($ret)-1]
EndIf
If @error Then Return -1
EndFunc